#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <bitset>
#define pb push_back
#define ff first
#define ss second
#define all(a) a.begin(), a.end()
using namespace std;
using ll = long long;

typedef vector<int> VI;
typedef vector<VI> VVI;
typedef pair<int, int> PII;
typedef vector<PII> VPI;

const int INPUTIDX = 65520;
VI program;

void nocopy(int word) {
	program[word + 0] = program[word + 1] = 0;
}

void answerNO(int word) {
	program[word + 0] = 0;
	program[word + 1] = INPUTIDX;
	program[word + 2] = 0b1111111111111111;
}
void answerYES(int word) {
	program[word + 0] = 1;
	program[word + 1] = INPUTIDX;
	program[word + 2] = 0b1111111111111111;
}

void addif(int offset, int bit, int value, int trueind) {
	// OFFSET MUST BE DIVISIBLE BY 64
	int start = offset + 0b00000;
	int mid = offset + 0b00011;
	int s00 = offset + 0b10000;
	int s01 = offset + 0b10100;
	int s10 = offset + 0b11000;
	int s11 = offset + 0b11100;

	program[start + 0] = INPUTIDX + bit;
	program[start + 1] = ((mid + 2) << 4) + 2;
	program[start + 2] = mid;

	nocopy(mid);
	nocopy(s00);
	nocopy(s01);
	nocopy(s10);
	nocopy(s11);
	program[mid + 2] = s00 + (value<<3);

	program[s00 + 2] = trueind;
	program[s11 + 2] = trueind;
	answerNO(s01);
	answerNO(s10);
}

void runprogram(int input) {
	program[4095] = input;
	//cout << bitset<16>(program[4095]) << endl;
	int ptr = 0;
	while (ptr < 4094) {
		//cout << "POINTER IS AT " << bitset<8>(ptr) << endl;
		int a = program[ptr + 0];
		int b = program[ptr + 1];
		int c = program[ptr + 2];
		/*cout << "VALUES: " << bitset<16>(a) << ", " << bitset<16>(b) << ", " << bitset<16>(c) << endl;
		cout << "COPIED " << (a & 15) << "-th bit of " << (a >> 4) << "-th word (" << (program[a >> 4] & (1 << (a & 15))) << ") into ";
		cout << (b & 15) << "-th bit of " << (b >> 4) << "-th word" << endl;
		cout << endl;*/

		if (program[a >> 4] & (1 << (a & 15))) {
			program[b >> 4] |= (1 << (b & 15));
		} 
		else {
			program[b >> 4] &= ~(1 << (b & 15));
		}
		ptr = c;
	}
	//cout << "FINISHED, t = " << t << endl;
}

string tohex(int x) {
	string digits = "0123456789abcdef";
	string ans;
	for (int i = 0; i < 4; i++) {
		ans.pb(digits[x%16]);
		x /= 16;
	}
	reverse(all(ans));
	return ans;
}

void solve() {
	//cout << (65520 >> 4) << " " << (65520 & 15) << endl;
	//return;
	int x;
	cin >> x;

	const int programSIZE = 2000;
	program = VI(programSIZE);

	program[2] = 64;
	program[0] += 2;
	
	const int last = 16;
	for (int b = 0; b < last; b++) {
		addif((b+1)*64, b, bool(x & (1<<b)), (b+2)*64);
	}
	
	answerYES((last + 1) * 64);

	for (int i = 0; i < programSIZE; i++) {
		cout << tohex(program[i]) << " ";
	}
	cout << endl;
	return;
	while (true) {
		int x;
		cin >> x;
		
		runprogram(x);
		//cout << bitset<16>(program[4095]) << endl;
		if (program[4095] & 1) cout << "YES" << endl;
		else cout << "NO" << endl;
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int t = 1;
	//cin >> t;
	while (t--) solve();

}
