#include <bits/stdc++.h>

using namespace std;

using ll = long long;


void solve(){
    int n, m, q;
    cin >> n >> m >> q;
    vector<pair<long long, long long>> ad(n);
    vector<long long> eps(m), t(q);
    for (int i = 0; i < n; i++){
        cin >> ad[i].first;
    }
    for (int i = 0; i < n; i++){
        cin >> ad[i].second;
    }

    for (int i = 0; i < m; i++){
        cin >> eps[i];
    }
    for (int i = 0; i < q; i++){
        cin >> t[i];
    }

    auto sort_intervals = [](const pair<ll, ll>& a, const pair<ll, ll>& b) {
        if (a.second == b.second) {
            return a.first > b.first;
        }
        return a.second > b.second;
    };
    std::multiset<pair<ll, ll>, decltype(sort_intervals)> mst(sort_intervals);

    for (int i = 0; i < n; ++i) {
        mst.insert({ad[i].second - ad[i].first, ad[i].second});
    }

    vector<pair<ll, ll>> intervals;

    while (!mst.empty()) {
        auto [l, r] = *mst.begin();

        if (!intervals.empty() && r > intervals.back().first) {
            auto diff = r - intervals.back().first;
            r -= diff;
            l -= diff;
        }
        intervals.push_back({l, r});
        mst.erase(mst.begin());
    }

    reverse(intervals.begin(), intervals.end());


    vector<ll> sum_of_lengths(n);
    sum_of_lengths[0] = intervals[0].second - intervals[0].first;
    for (int i = 1; i < n; ++i) {
        sum_of_lengths[i] = sum_of_lengths[i - 1] + (intervals[i].second - intervals[i].first);
    }

    vector<ll> pref_eps(m);

    pref_eps[0] = eps[0];
    for (int i = 1; i < m; ++i) {
        pref_eps[i] = pref_eps[i - 1] + eps[i];
    }

    for (auto time : t) {
        int ind = lower_bound(intervals.begin(), intervals.end(), pair<ll, ll>{time, 1e18}) - intervals.begin();

        ll cur_sum = 0;
        if (ind != 0) {
            --ind;
            if (ind - 1 >= 0) {
                cur_sum += sum_of_lengths[ind - 1];
            }
            cur_sum += min(time, intervals[ind].second) - intervals[ind].first;
        }

        ll time_left = time - cur_sum;
//
//        cerr << "t = " << time << " TIME LEFT = " << time_left << '\n';

        ind = upper_bound(pref_eps.begin(), pref_eps.end(), time_left) - pref_eps.begin();

        cout << ind << ' ';
    }
    cout << '\n';


}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--){
        solve();
    }
    
    return 0;
}
