#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <alg.h>

#define pb push_back
using namespace std;
const int N = 1e5+5;
int n, m, set_true, unset_true, prio[N];
string tp[N];
vector<vector<int>> gr;

vector<int> topoSort() {
    vector<int> indeg(gr.size()), ret;
    for (int i = 1; i < gr.size(); i++) {
        vector<int> li = gr[i];
        for (int x : li) if (x != 0) indeg[x]++;
    }
    queue<int> q;
    for (int i = 1; i < gr.size(); i++) if (indeg[i] == 0) q.push(i);
    while(!q.empty()) {
        int i = q.front();
        ret.pb(i);
        q.pop();
        for (int x : gr[i])
            if (--indeg[x] == 0) q.push(x);
    }
    return ret;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    string temp;
    getline(cin, temp);
    n = stoi(temp);

    bool yes = true;

    for (int i = 1; i <= n; i++) {
        string s;
        getline(cin, s);
        if (s == "set true") {
            if (set_true != 0) yes = false;
            set_true = i;
        }
        if (s == "unset true") {
            if (unset_true != 0) yes = false;
            unset_true = i;
        }
        tp[i] = s;
    }
    gr.resize(n + 1);

    cin >> m;
    for (int i = 1; i <= m; i++) {
        int x, y;
        cin >> x >> y;
        gr[x].pb(y);

        if ((tp[y] == "set false" || tp[y] == "unset true") && tp[x] == "unset false") {
            if (set_true == 0) yes = false;
            gr[x].pb(set_true);
        }
        if ((tp[x] == "set true" || tp[x] == "set false") && tp[y] == "unset false") {
            if (unset_true == 0) yes = false;
            gr[unset_true].pb(y);
        }
    }

    for (int i = 1; i <= n; i++) {
        if (tp[i] == "set false") {
            if (set_true == 0) yes = false;
            gr[set_true].pb(i);
            if (unset_true != 0) gr[i].pb(unset_true);
        }
    }
    if (unset_true != 0 && set_true != 0) gr[set_true].pb(unset_true);
    if (set_true == 0 && unset_true > 0) yes = false;
    if (unset_true == 0) {
        for (int i = 1; i <= n; i++) {
            if (tp[i] == "unset false") {
                gr[i].pb(set_true);
            }
        }
    }
    if (!yes) {
        cout << -1 << endl;
        return 0;
    }

    vector<int> ans = topoSort();
    if (ans.size() < n) {
        cout << -1 << endl;
        return 0;
    }
    vector<int> later;
    bool seen = false;
    for (int i = 0; i < ans.size(); i++) {
        if (tp[ans[i]] == "set true") seen = true;
        if (tp[ans[i]] == "unset false" && seen) {
            later.pb(ans[i]);
        } else {
            cout << ans[i] << " ";
            if (tp[ans[i]] == "unset true") {
                for (int j = 0; j < later.size(); j++) cout << later[j] << " ";
                seen = false;
            }
        }
    }

    return 0;
}
