#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <queue>
#include <cstdint>
using namespace std;

bool check2(string s) {
   //  cout << "!" << s << endl;
    if (s.empty()) return false;
    if (s == "0") return true;
    if (s[0] == '0') return false;
    if (s.size() > 10) return false;

    return all_of(s.begin(), s.end(), [](char ch) {
                  return ch >= '0' && ch <= '9'; });
}

bool check(string s) {
    auto epos = s.find("=");

    if (epos == s.npos)
        return false;
    else {
        string left = s.substr(0, epos);
        string right = s.substr(epos + 1);
        if (left.empty() || right.empty()) return false;

        bool pos = true;

        string buf = "";
        int64_t ans = 0;
        int64_t sgn = 1;
        for (int i = 0; i < left.size(); i++) {
            if (left[i] >= '0' && left[i] <= '9')
                buf += (left[i]);
            else {
                if (!check2(buf)) return false;
                ans += sgn * atoll(buf.c_str());
                buf.clear();
                if (left[i] == '+') sgn=1;
                else sgn=-1;
            }
        }

        if (!check2(buf)) return false;
        ans += sgn * atoll(buf.c_str());

        sgn = 1;
        buf = "";
        for (int i = 0; i < right.size(); i++) {
            if (right[i] >= '0' && right[i] <= '9')
                buf += (right[i]);
            else {
                if (!check2(buf)) return false;
                ans -= sgn * atoll(buf.c_str());

                buf.clear();
                if (right[i] == '+') sgn=1;
                else sgn=-1;
            }
        }
        if (!check2(buf)) return false;
        ans -= sgn * atoll(buf.c_str());

        if (ans==0) return true;
    }
    return false;
}

/*
int dp[3][N]={0};

void solve() {
    int n;cin>>n;
    string s1, s2;
    cin >> s1 >> s2;
  dp[0][0]=dp[1][0]=dp[2][0]=1;

    if (s1[0] == '#'){
        dp[1][1] = 1;
    }

    if(s2[0]=='#') dp[2][1] = 1;
    if(s1[0] == '#' && s1[0] == '#') dp[0][1] = 1;


    for (int i = 2; i <= n; i++) {
        dp[0][i]=dp[1][i]=dp[2][i]=0;
        if (s1[i-1] == '.' && s2[i-1]=='.') {
            dp[0][i] = dp[0][i-1];
            dp[0][i]+=dp[1][i-1]*dp[2][i-1];
        }
        if(s1[i-1]=='.' && s1[i-2]=='.'){
            dp[1][i] = dp[1][i - 2];
            if(dp[0][i-2] && (s2[i-1]==s2[i-2]))
               dp[1][i] += dp[0][i - 2];
        }
        if(s2[i-1]=='.' && s2[i-2]=='.'){
            dp[2][i] = dp[2][i - 2];
            if(dp[0][i-2] && (s1[i-1]==s1[i-2]))
               dp[2][i] += dp[0][i - 2];
        }
        if(s1[i-1]=='#'){
            dp[1][i]=dp[0][i-1]+dp[1][i-1];

        }
        if(s2[i-1]=='#'){
            dp[2][i]=dp[0][i-1]+dp[2][i-1];

        }
        if(s2[i-1]=='#' && s1[i-1]=='#'){
            dp[0][i]=dp[0][i-1] + dp[1][i-1]*dp[2][i-1] ;

        }

    }
    for(int i=0;i<3;i++){
        for(int j=1;j<=n;j++)
        cout<<dp[i][j]<<' ';
       cout<<endl;
    }
 long long    ans = dp[0][n] + dp[1][n]* dp[2][n];
    if(ans==0) cout<<"None"<<endl;
    else if(ans==1) cout<<"Unique"<<endl;
    else cout<<"Multiple"<<endl;

}
*/

void solve() {
    string s;
    cin>>s;

    int n = s.size();
    if (check(s)) {
        cout<<"Correct\n";
        return;
    }
    bool can=false;
    for (int i = 0; i < n; i++){
        for (int j = 0; j < n; j++) {
            string ns = s;
            char c = ns[j];
            if (c < '0' || c > '9') continue;

            ns.erase(ns.begin() + j);
            if (i < ns.size())
                ns.insert(ns.begin() + i, c);
            else ns.push_back(c);

            if (check(ns)) {
                can = true;
                cout << ns << endl;
                return;
            }
        }
    }
    if (!can) cout<<"Impossible\n";
}

/*
const int N = 1003;
int ind[N],a[N],a2[N];
vector<pair<int,int>> ans;
void solve(){
    int n,x,cnt=0,sum=0,y;
    cin>>n;
    for(int i = 1;i <= n;i++){
        cin>>a[i];
        ind[i]=i;
        a2[i]=i;
    }
   for(int i = n;i>= 0;i--){
        x = a[i];
        for(int j = ind[x]-1;j>0;j--){
            y = a2[j];
            ans.push_back({x,y});
            swap(a2[j],a2[j+1]);
            swap(ind[x],ind[y]);
           //for(int k=1;k<=n;k++) cout<<a2[k]<<' ';
          // cout<<endl;

        }

    }
     cout<<ans.size()<<endl;
    for(auto p:ans) cout<<p.first<<' '<<p.second<<endl;


}*/
int main()
{
    int t = 1;
    // cin >> t;
    while (t--) {
            solve();

    }

    return 0;
}
