#include <bits/stdc++.h>
using namespace std;

#define SQT 0.70710678118654752438189403651591646848828531801700592041015625l

#define len(a) ((int)(a).size())

struct pt {
    long long x, y, u, v;

    pt operator+(const pt& p) const { return {x + p.x, y + p.y, u + p.u, v + p.v}; }
    pt operator-(const pt& p) const { return {x - p.x, y - p.y, u - p.u, v - p.v}; }
    pt operator*(long long d) const { return {x * d, y * d, u * d, v * d}; }

    bool operator<(const pt& p) const {
        long double i = x + (u - v) * SQT;
//        cout << i << "\n";
        long double j = p.x + (p.u - p.v) * SQT;
        if(i == j){
            i = y + (u + v) * SQT;
            j = p.y + (p.u + p.v) * SQT;
            return i < j;
        }
        return i < j;
    }
    bool operator==(const pt& p) const { return x == p.x && y == p.y && u == p.u && v == p.v; }

    void rotate45(){
        long long temp = v;
        v = y;
        y = u;
        u = x;
        x = -temp;
    }
};

void print(pt& p) {
    cout << "{" << p.x << " " << p.y << " " << p.u << " " << p.v << "}\n";
}

//constexpr int N = 5e4 + 5;
int n;
vector<pair<pt, pt>> vec;

void unitethem(vector<pair<pt, pt>>& vecx, int phA){
    for(int i = 0; i < len(vecx); i++){
        for(int j = 0; j < phA; j++) vecx[i].first.rotate45();
        for(int j = 0; j < phA; j++) vecx[i].second.rotate45();
        if(vecx[i].second < vecx[i].first) swap(vecx[i].first, vecx[i].second);
    }
    sort(vecx.begin(), vecx.end());
    for(int i = 1; i < len(vecx); i++){
        if(vecx[i - 1].second == vecx[i].first){
            vecx[i].first = vecx[i - 1].first;
            vecx[i - 1] = {{0, 0, 0, 0}, {0, 0, 0, 0}};
        }
    }
    for(int i = 0; i < len(vecx); i++){
        for(int j = 0; j < 8 - phA; j++) vecx[i].first.rotate45();
        for(int j = 0; j < 8 - phA; j++) vecx[i].second.rotate45();
        if(vecx[i].second < vecx[i].first) swap(vecx[i].first, vecx[i].second);
    }
}

void putintovec(vector<pair<pt, pt>>& vecx) {
    for(int i = 0; i < len(vecx); i++){
        if(vecx[i].first == vecx[i].second) continue;
        vec.push_back(vecx[i]);
    }
}

void childrenoftheworldunite(){
    vector<pair<pt, pt>> vecx, vecy, vecu, vecv;
    for(int i = 0; i < len(vec); i++){
        if(vec[i].second.x != vec[i].first.x) vecx.push_back(vec[i]);
        if(vec[i].second.y != vec[i].first.y) vecy.push_back(vec[i]);
        if(vec[i].second.u != vec[i].first.u) vecu.push_back(vec[i]);
        if(vec[i].second.v != vec[i].first.v) vecv.push_back(vec[i]);
    }

    unitethem(vecx, 2);
    unitethem(vecy, 0);
    unitethem(vecu, 1);
    unitethem(vecv, 7);

    vec.clear();

    putintovec(vecx);
    putintovec(vecy);
    putintovec(vecu);
    putintovec(vecv);
}

void solve(){
    cin >> n;

    pt cur = {0, 0, 0, 0};
    pt dir = {1, 0, 0, 0};

    string comm;
    long long val;
    for(int i = 0; i < n; i++){
        cin >> comm;
        cin >> val;
        if(comm == "draw"){
            vec.push_back({cur, cur + dir * val});
            cur = cur + dir * val;
            continue;
        }
        if(comm == "rotate"){
            for(long long j = 45; j <= val; j += 45){
                dir.rotate45();
            }
            continue;
        }
        cur = cur + dir * val;
    }

//    for(int i = 0; i < len(vec); i++){
//        print(vec[i].first);
//        print(vec[i].second);
//        cout << "\n";
//    }
//
//    cout << "-----\n";

    for(int i = 0; i < len(vec); i++){
        if(vec[i].second < vec[i].first) swap(vec[i].first, vec[i].second);
    }
    childrenoftheworldunite();
    sort(vec.begin(), vec.end());

//    for(int i = 0; i < len(vec); i++){
//        print(vec[i].first);
//        print(vec[i].second);
//        cout << "\n";
//    }

    vector<pair<pt, pt>> rvec(vec);

    for(int ang = 45; ang < 360; ang += 45){
        for(int i = 0; i < len(rvec); i++){
            rvec[i].first.rotate45();
            rvec[i].second.rotate45();
            if(rvec[i].second < rvec[i].first) swap(rvec[i].first, rvec[i].second);
        }
        sort(rvec.begin(), rvec.end());
        pt diff = rvec[0].first - vec[0].first;
        bool ok = true;
        for(int i = 0; i < len(rvec); i++){
            if(rvec[i].first - vec[i].first != diff || rvec[i].second - vec[i].second != diff){
                ok = false;
                break;
            }
        }
        if(ok){
            cout << ang << "\n";
            return;
        }
    }
    cout << "360\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cout.precision(62);
    cout << fixed;

    solve();
    return 0;
}
