#include <bits/stdc++.h>
#define int long long
using namespace std;


void solve() {
    int n; cin >> n;
    vector<int> a(2*n);
    vector<vector<int>> vals(n);
    for (int i = 0; i < 2*n; ++i) {
        cin >> a[i]; --a[i];
        vals[a[i]].push_back(i);
    }

    vector<vector<int>> g(2*n);
    for (int i = 0; i < 2*n-1; ++i) {
        int u, v; cin >> u >> v; --u, --v; 
        g[u].push_back(v);
        g[v].push_back(u);
    }

    vector<vector<int>> dp(2*n, vector<int>(2));
    vector<int> best(2*n, -1);
    auto dfs = [&](auto self, int x, int p) -> void {
        // dp[x][0/1] - do(n't) take (x, p) edge
        for (int to : g[x]) {
            if (to != p) {
                self(self, to, x);
            }
        }

        //dp[x][1] = 1 + dp[children][0]
        //dp[x][0] = dp[child][1] + dp[children][0]
        dp[x][1] = p != -1;
        for (int to : g[x]) {
            if (to != p) {
                dp[x][1] += dp[to][0];
            }
        }

        best[x] = -1;
        for (int to : g[x]) {
            if (to != p) {
                int cur = (dp[x][1] - (p != -1)) - dp[to][0] + dp[to][1];
                if (dp[x][0] < cur) {
                    dp[x][0] = cur;
                    best[x] = to;
                }
            }
        }
    };

    vector<pair<int, int>> matching;
    auto reconstruct = [&](auto self, int x, int p, bool is_taken) -> void {
        if (is_taken) {
            matching.push_back({x, p});
            for (int to : g[x]) {
                if (to != p) {
                    self(self, to, x, false);
                }
            }
        } else {
            for (int to : g[x]) {
                if (to != p) {
                    self(self, to, x, to == best[x]);
                }
            }
        }
    };

    dfs(dfs, 0, -1);
    reconstruct(reconstruct, 0, -1, false);

    vector<pair<int, int>> edge(2*n);
    // cout << (int)matching.size() << '\n';
    vector<bool> in_matching(2*n);
    for (pair<int, int> &p : matching) {
        if (p.first > p.second) {
            swap(p.first, p.second);
        }
        // cout << p.first << ' ' << p.second << endl;
        edge[p.first] = edge[p.second] = {p.first, p.second};
        in_matching[p.first] = in_matching[p.second] = true;
    }

    set<pair<int, int>> edges(matching.begin(), matching.end());
    vector<bool> used(2*n);
    vector<pair<int, int>> ans;

    auto get_id = [&](vector<int> &v, int val) -> int {
        for (int i = 0; i < (int)v.size(); ++i) {
            if (v[i] == val) {
                return i;
            }
        }
        assert(false);
    };

    auto SWAP = [&](int i, int j) -> void {
        // cout << "SWAP " << i << ' ' << j << endl;
        assert(used[i] == false && used[j] == false);
        used[i] = used[j] = true;
        int vi = a[i], vj = a[j]; 
        vals[vi].erase(vals[vi].begin() + get_id(vals[vi], i));
        vals[vj].erase(vals[vj].begin() + get_id(vals[vj], j));
        vals[vi].push_back(j);
        vals[vj].push_back(i);
        swap(a[i], a[j]);
        ans.push_back({i, j});
    };

    auto get_partner = [&](int i) -> int {
        int vi = a[i];
        assert((int)vals[vi].size() == 2 && get_id(vals[vi], i) != -1);
        return vals[vi][0] ^ vals[vi][1] ^ i;
    };

    while (!edges.empty()) {
        pair<int, int> e = *edges.begin();

        while (true) {
            pair<int, int> E = e;
            if (E.first > E.second) {
                swap(E.first, E.second);
            }
            if (edges.count(E) == 0) {
                break;
            }

            edges.erase(E);
            if (a[e.first] == a[e.second]) {
                break;
            }

            int partner = get_partner(e.first);
            // cout << e.first << ' ' << e.second << ' ' << partner << ' ';
            SWAP(e.second, partner);
            int partner_partner = get_partner(partner);
            // cout << partner_partner << ' ' << in_matching[partner] << ' ' << in_matching[partner_partner] << endl;
            if (in_matching[partner]) {
                e = edge[partner];
                if (e.first != partner) {
                    swap(e.first, e.second);
                }
            } else if (in_matching[partner_partner]) {
                e = edge[partner_partner];
                if (e.first != partner_partner) {
                    swap(e.first, e.second);
                }
            } else {
                break;
            }
        }
    }

    cout << (int)ans.size() << '\n';
    for (pair<int, int> p : ans) {
        cout << p.first + 1 << ' ' << p.second + 1 << '\n';
    }
    
    // int total = 0;
    // for (int i = 0; i < 2*n; ++i) {
    //     for (int to : g[i]) {
    //         total += a[i] == a[to];
    //     }
    // }
    // total /= 2;
    // cout << total << endl;

}

main() {
    int t; cin >> t;
    for (int _ = 0; _ < t; ++_) {
        solve();
    }
}