#include <bits/stdc++.h>

using namespace std;

int di[4] = {0, 0, 1, -1};
int dj[4] = {1, -1, 0, 0};

bool inside(int i, int j, int n) {
    return 0 <= i && i < 2 && 0 <= j && j < n;
}

void solve() {
    int n;
    cin >> n;
    set<vector<int>> st;
    vector<vector<int>> cnt(2, vector<int> (n, 0));
    vector<vector<char>> a(2, vector<char> (n, ' '));
    for (int i = 0; i < 2; i++) {
        for (int j = 0; j < n; j++) {
            cin >> a[i][j];
        }
    }

    for (int i = 0; i < 2; i++) {
        for (int j = 0; j < n; j++) {
            if (a[i][j] == '#') continue;
            int deg = 0;
            for (int ii = 0; ii < 4; ii++) {
                int ti = i + di[ii];
                int tj = j + dj[ii];
                if (inside(ti, tj, n) && a[ti][tj] == '.') {
                    deg++;
                }
            }
            st.insert({deg, i, j});
            cnt[i][j] = deg;
        }
    }
    auto relax = [&](int i, int j) {
        st.erase({cnt[i][j], i, j});
        a[i][j] = '#';
        cnt[i][j]--;
        for (int ii = 0; ii < 4; ii++) {
            int ti = i + di[ii], tj = j + dj[ii];
            if (inside(ti, tj, n) && a[ti][tj] == '.') {
                st.erase({cnt[ti][tj], ti, tj});
                cnt[ti][tj]--;
                st.insert({cnt[ti][tj], ti, tj});
            }
        }
    };
    // cout << st.size() << '\n';
    while (!st.empty()) {
        auto cur = *st.begin();
        st.erase(st.begin());
        int deg = cur[0], i = cur[1], j = cur[2];
        // cout << i << ' '
        if (deg == 0) continue;
        else if (deg == 1) {
            for (int ii = 0; ii < 4; ii++) {
                int ti = i + di[ii], tj = j + dj[ii];
                if (inside(ti, tj, n) && a[ti][tj] == '.') {
                    relax(ti, tj);
                    a[i][j] = '#';
                    break;
                    // relax(i, j);
                }
            }
        }
        else {
            break;
        }
        
    }
    int mult = 0;
    for (int i = 0; i < 2; i++) {
        for (int j = 0; j < n; j++) {
            // cout << a[i][j];
            if (a[i][j] != '.') continue;
            int d = 0;
            for (int ii = 0; ii < 4; ii++) {
                int ti = i + di[ii], tj = j + dj[ii];
                if (inside(ti, tj, n) && a[ti][tj] == '.') {
                    d++;
                    // relax(i, j);
                }
            }
            if (d == 0) {
                cout << "None\n";
                return;
            } else {
                mult++;
            }
        }
        // cout << '\n';
    }
    if (mult > 0) {
        cout << "Multiple\n";
    } else {
        cout << "Unique\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int tt;
    cin >> tt;
    while (tt--) solve();
}