#include <bits/stdc++.h>

using namespace std;

template <typename T_container, typename T = typename enable_if
        <!is_same<T_container, string>::value, typename
        T_container::value_type>::type>
ostream& operator<<(ostream &os, const T_container &v){
    os << '{';
    string sep;
    for (const T &x:v){
        os << sep << x;
        sep = ", ";
    }
    return os << '}';
}

void dbg_out(){cerr<<endl;}
template <typename Head, typename... Tail> void dbg_out(Head H
        ,Tail... T){cerr<<' '<<H; dbg_out(T...);}

#define dbg(...) dbg_out(__VA_ARGS__)
#define pi pair<int, int>
#define pb push_back
#define ft first
#define sd second
#define all(x) (x).begin(), (x).end()

#define TEST_CASES
#define vt vector

void solve() {
    int n;
    cin >> n;
    vt<int> a(2 * n);
    vt<vt<int>> colors(n);
    for(int i = 0; i < 2 * n; ++i) {
        cin >> a[i];
        --a[i];
        colors[a[i]].push_back(i);
    }
    vt<vt<int>> g(2*n);
    for(int i = 1; i < 2 * n; ++i) {
        int a, b;
        cin >> a >> b;
        g[--a].push_back(--b);
        g[b].push_back(a);
    }
    vt<int> matching(2*n, -1);
    auto Dfs = [&](auto self, int e, int p) -> int {
        int last = -1;
        for(auto to: g[e]) if(to != p) {
            last = max(last, self(self, to, e));
        }
        if(last != -1) {
            matching[last] = e;
            matching[e] = last;
            return -1;
        }
        return e;
    };
    Dfs(Dfs, 0, 0);
    vt<pair<int, int>> res;
    vt<int> used(2 * n, false);
    for(int i = 0; i < 2 * n ; ++i) if(!used[i] and matching[i] != -1) {
        auto Dfs = [&](auto self, int e, int color) -> void {
            if(matching[e] == -1 || used[e]) {
                return;
            }
            int adjv = matching[e];
            int cl = a[adjv];
            int where = -1;
            used[e] = 1;
            used[adjv] = 1;
            for(auto x: colors[color]) if(!used[x]) {
                where = x;
            }
            if(where == -1) {
                return ;
            }
            res.emplace_back(where, adjv);
            self(self, where, cl);
        };
        Dfs(Dfs, i, a[i]);
    }
    cout << int(res.size()) << '\n';
    vt<int> cnt(2 * n, 0);
    for(auto [x,y] :res ) {
        swap(a[x], a[y]);
        cout << x + 1 << ' ' << y + 1 << '\n';
    }
}

int main() {
//    freopen("C:\\work\\untitled\\inp.txt", "r", stdin);
    cin.tie(0)->sync_with_stdio(0);
    int tt = 1;
#ifdef TEST_CASES
    cin >>tt;
#endif
    while(tt--)
        solve();
    return 0;
}