#include <bits/stdc++.h>

using namespace std;

template <typename T_container, typename T = typename enable_if
        <!is_same<T_container, string>::value, typename
        T_container::value_type>::type>
ostream& operator<<(ostream &os, const T_container &v){
    os << '{';
    string sep;
    for (const T &x:v){
        os << sep << x;
        sep = ", ";
    }
    return os << '}';
}

void dbg_out(){cerr<<endl;}
template <typename Head, typename... Tail> void dbg_out(Head H
        ,Tail... T){cerr<<' '<<H; dbg_out(T...);}

#define dbg(...) dbg_out(__VA_ARGS__)
#define pi pair<int, int>
#define pb push_back
#define ft first
#define sd second
#define all(x) (x).begin(), (x).end()

#define TEST_CASES
#define vt vector

bool debug = false;

mt19937 rng(1);
//std::chrono::steady_clock::now().time_since_epoch().count());

void solve() {
    int n;
    if(debug) {
        n = 4;
    } else {
        cin >> n;
    }
    vt<int> a(2 * n), st;
    if(debug) {
        for(int i = 0; i < 2 * n; ++i) {
            a[i] = i /2;
        }
        shuffle(a.begin(), a.end(), rng);
        st = a;
    }
    vt<vt<int>> colors(n);
    for(int i = 0; i < 2 * n; ++i) {
        if(!debug) {
            cin >> a[i];
            --a[i];
        }
        colors[a[i]].push_back(i);
    }
    vt<vt<int>> g(2*n);
    for(int i = 1; i < 2 * n; ++i) {
        int a, b;
        if(debug) {
            a = i + 1, b = rng() % i + 1;
        } else {
            cin >> a >> b;
        }
        g[--a].push_back(--b);
        g[b].push_back(a);
    }
    vt<int> matching(2*n, -1);
    int matching_size = 0;
    vt<int> colorscnt(2*n, 0);
    auto Dfs = [&](auto self, int e, int p) -> int {
        int last = -1;
        for(auto to: g[e]) if(to != p) {
            last = max(last, self(self, to, e));
        }
        if(last != -1) {
            dbg("e=", e, "last=", last);
            matching[last] = e;
            colorscnt[a[last]]++;
            colorscnt[a[e]]++;
            matching[e] = last;
            ++matching_size;
            return -1;
        }
        return e;
    };
    Dfs(Dfs, 0, 0);
    dbg("shiit");
    vt<pair<int, int>> res;
    vt<int> used(2 * n, false);
    auto Dfs1 = [&](auto self, int e, int color) -> void {
        if(matching[e] == -1 || used[e]) {
            return;
        }
        int adjv = matching[e];
        int cl = a[adjv];
        int where = -1;
        used[e] = 1;
        used[adjv] = 1;
        for(auto x: colors[color]) if(!used[x]) {
            where = x;
        }
        if(where == -1) {
            return ;
        }
        res.emplace_back(where, adjv);
        self(self, where, cl);
    };
    vt<int> vertices;
    for(int i = 0; i < 2 * n; ++i) if(colorscnt[a[i]] == 2) {
        Dfs1(Dfs1, i, a[i]);
    }
    for(int i = 0; i < 2 * n; ++i) if(!used[i] and matching[i] != -1) {
        Dfs1(Dfs1, i, a[i]);
    }
    if(!debug) {
        cout << int(res.size()) << '\n';
    }
    vt<int> cnt(2 * n, 0);
    for(auto [x,y] :res ) {
        swap(a[x], a[y]);
        cnt[x]++;
        cnt[y]++;
        if(!debug) {
            cout << x + 1 << ' ' << y + 1 << '\n';
        }
    }
    for(int i = 0; i < 2 * n; ++i) {
        for(auto to: g[i]) if(to < i) {
            matching_size -= a[i] == a[to];
        }
    }
    if(debug and matching_size > 0) {
        for(int i = 0; i < 2 * n; ++i)
        for(auto to: g[i]) if(i < to) {
            dbg("edge", i, to);
        }
        dbg("were=", st);
        dbg("a=", a);
        dbg("matching=", matching);
        for(auto x: res) {
            dbg(x.first, x.second);
        }
        exit(0);
    }
//    assert(matching_size == 0);
    assert(*min_element(a.begin(), a.end()) <= 1);
}

int main() {
//    freopen("C:\\work\\untitled\\inp.txt", "r", stdin);
    cin.tie(0)->sync_with_stdio(0);
    int tt = 1;
    if(debug) {
     tt = 1e5;
    } else {
#ifdef TEST_CASES
        cin >> tt;
#endif
    }
    while(tt--)
        solve();
    return 0;
}