#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <cmath>
#define fs first
#define ss second
#define vi vector <int>
#define vii vector <vi>
#define int long long
#define pii pair <int, int>
#define all(x) (x).begin(), (x).end()
#define pb push_back
using namespace std;
const int mod = 1e9 + 7;

bool equality(string s){
    if (s[0] == '=' || s.back() == '+' || s.back() == '-' || s.back() == '=')
        return false;

    int temp = 0;
    for (int i = 0; i < s.size(); ++ i){
        if (s[i] == '0' && temp == 0) {
            if (i + 1 < s.size() && (s[i+1] == '+' || s[i+1] == '-' || s[i+1] == '='))
                continue;
            return false;
        }
        if (s[i] >= '0' && s[i] <= '9') temp = 1;
        else {
            if (temp == 0){
                if (i > 0 && s[i-1] == '=') continue;
                return false;
            }
            temp = 0;
        }
    }

    return true;
}

bool correct(string s){
    if (!equality(s)) return false;
    vi a, b;
    int sign = 1, ok = 1, cur = 0;

    for (char c : s){
        if (c >= '0' && c <= '9') {
            int x = c - '0';
            cur = cur * 10 + x;
        }
        else {
            if (cur > 9999999999LL) return false;
            if (ok) a.pb(sign * cur);
            else b.pb(sign * cur);

            if (c == '=') {
                ok = 0;
                sign = 1;
            }

            if (c == '+') sign = 1;
            if (c == '-') sign = -1;
            cur = 0;
        }
    }
    if (cur > 9999999999LL) return false;
    b.push_back(sign * cur);

    if (a.empty() || b.empty()) return false;

    auto sumv = [&](vi &v){
        int res = 0;
        for (int i : v) res += i;
        return res;
    };

    return sumv(a) == sumv(b);
}

void solve(){
    string s; cin >> s;

    if (correct(s)){
        cout << "Correct";
        return;
    }

    int n = s.size();
    for (int i = 0; i < n; ++ i){
        if (s[i] == '+' || s[i] == '-' || s[i] == '=') continue;

        string a = s;
        a.erase(i, 1);
        string ss = "";
        ss.pb(s[i]);

        for (int j = 0; j < n; ++ j){
            string b = a;
            b.insert(j, ss);

            if (correct(b)){
                cout << b;
                return;
            }
        }
    }

    cout << "Impossible";
}

signed main(){
    cin.tie(nullptr)->ios::sync_with_stdio(false);
    int t = 1;
//    cin >> t;
    while (t --)
        solve();
    return 0;
}
