#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
void __print(int x){cerr << x;}
void __print(long x){cerr << x;}
void __print(long long x){cerr << x;}
void __print(long double x){cerr << x;}
void __print(unsigned x){cerr << x;}
void __print(unsigned long x){cerr << x;}
void __print(unsigned long long x){cerr << x;}
void __print(float x){cerr << x;}
void __print(double x){cerr << x;}
void __print(char x){cerr <<'\'' <<  x << '\'';}
void __print(const char *x){cerr <<'\"' <<  x << '\"';}
void __print(const string &x){cerr <<'\"' <<  x << '\"';}
void __print(bool x){cerr << (x ? "true":"false");}

template<typename T,typename V> 
void __print(const pair<T,V> &x){ cerr << "{";  __print(x.first); cerr<<","; __print(x.second); cerr << "}"; }
template<typename T>
void __print(const T &x){ int f = 0; cerr << "{"; for(auto &i:x) cerr << (f++ ? ",":""),__print(i); cerr << "}";}
void _print(){cerr << "]\n";}
template<typename T,typename ... V>
void _print(T t,V... v){__print(t);if(sizeof...(v)) cerr << ", ";_print(v...);}
#define debug(x...) cerr << "[" << #x << "] = [";_print(x);
#ifndef LOCAL
    #define debug(x...) 42
#endif
#define all(x) (x).begin(),(x).end()

const ld PI = 3.141592653589793;
const int MOD = 1e9 + 7;
const int INF = 1e9;
const ll INFLL = 4e18;
const double EPS = 1e-9;
const int MAXN = 1000*1007;

int get_type(string& a, string& b) {
    if(a == "set" && b == "true") return 1;
    if(a == "set" && b == "false") return 2;
    if(a == "unset" && b == "true") return 3;
    if(a == "unset" && b == "false") return 4;
    return -1;
}

void solve(int NT){
    int n; cin >> n;

    vector<int> ty(n + 1);
    int one_id = -1, three_id = -1;
    for(int i = 1; i <= n; ++i) {
        string a1, a2; cin >> a1 >> a2;
        int s = get_type(a1, a2);
        ty[i] = s;

        if(s == 3) {
            if(three_id == -1) {
                three_id = i;
            } else {
                cout << "-1";
                return;
            }
        }

        if(s == 1) {
            if(one_id == -1) {
                one_id = i;
            } else {
                cout << "-1";
                return;
            }
        }
    }

    int m; cin >> m;
    vector<vector<int>> g(n + 1);
    for(int i = 0; i < m; ++i) {
        int x, y; cin >> x >> y;
        g[x].emplace_back(y);

        if(one_id != -1 && ty[x] == 4) {
            if(ty[y] == 2 || ty[y] == 3) {
                g[x].emplace_back(one_id);
            }
        }

        if(three_id != -1 && ty[y] == 4) {
            if(ty[x] == 2 || ty[x] == 1) {
                g[three_id].emplace_back(y);
            }
        }
    }

    for(int i = 1; i <= n; ++i) {
        if(one_id != -1 && ty[i] == 2) {
            g[one_id].emplace_back(i);
        }
        if(three_id != -1 && ty[i] == 2) {
            g[i].emplace_back(three_id);
        }
    }

    if(one_id != -1 and three_id != -1) {
        g[one_id].emplace_back(three_id);
    }

    vector<int> vis(n + 1);
    vector<int> topsort; topsort.reserve(n + 1);
    vector<bool> hasn4(n + 1);

    int cnt = 0, cnt4 = 0;
    auto dfs = [&](auto&& dfs, int x) -> bool {
        vis[x] = 1;

        cnt++;
        if(ty[x] == 4) cnt4++;
        else hasn4[x] = 1;

        for(int z: g[x]) {
            if(vis[z] == 1) {
                return true;
            }

            if(vis[z] == 0) {
                if(dfs(dfs, z)) {
                    return true;
                }
            }

            if(hasn4[z]) hasn4[x] = 1;
        }

        vis[x] = 2;
        topsort.emplace_back(x);
        return false;
    };
    
    vector<int> to_b;
    for(int x = 1; x <= n; ++x) {
        if(vis[x] == 0) {
            cnt = cnt4 = 0;
            if(dfs(dfs, x)) {
                cout << "-1";
                return;
            }

            if(cnt == cnt4 && hasn4[x] == 0) {
                debug(x, cnt, cnt4);
                for(int i = 0; i < cnt; ++i) {
                    to_b.emplace_back(topsort.back());
                    topsort.pop_back();
                }
            }
        }
    }

    for(int x: to_b) topsort.emplace_back(x);
    reverse(topsort.begin(), topsort.end());

    int last = 4;
    bool is_one = false;
    for(int x: topsort) {
        int cur = ty[x];
        bool ok = false;
        if(cur == 4) {
            if(last == 4 || last == 3) {
                ok = true;
            }
        } else if(cur == 3) {
            if(last == 1 || last == 2) {
                ok = true;
            }
        } else if(cur == 2) {
            if(last == 2 || last == 1) {
                ok = true;
            }
        } else if(cur == 1) {
            if(last == 4) {
                ok = true;
            }
        }

        if(ok) last = cur;
        else {
            cout << "-1";
            return;
        }
    }

    for(int x: topsort) {
        cout << x << ' ';
    }
}

// #define TESTCASES
int main(){
    cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
    #ifdef TESTCASES
        cin >> t;
    #endif
    for(int i = 1; i <= t; ++i ){
        solve(i);
        cout << '\n';
    }
    return 0;
}