#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
void __print(int x){cerr << x;}
void __print(long x){cerr << x;}
void __print(long long x){cerr << x;}
void __print(long double x){cerr << x;}
void __print(unsigned x){cerr << x;}
void __print(unsigned long x){cerr << x;}
void __print(unsigned long long x){cerr << x;}
void __print(float x){cerr << x;}
void __print(double x){cerr << x;}
void __print(char x){cerr <<'\'' <<  x << '\'';}
void __print(const char *x){cerr <<'\"' <<  x << '\"';}
void __print(const string &x){cerr <<'\"' <<  x << '\"';}
void __print(bool x){cerr << (x ? "true":"false");}

template<typename T,typename V> 
void __print(const pair<T,V> &x){ cerr << "{";  __print(x.first); cerr<<","; __print(x.second); cerr << "}"; }
template<typename T>
void __print(const T &x){ int f = 0; cerr << "{"; for(auto &i:x) cerr << (f++ ? ",":""),__print(i); cerr << "}";}
void _print(){cerr << "]\n";}
template<typename T,typename ... V>
void _print(T t,V... v){__print(t);if(sizeof...(v)) cerr << ", ";_print(v...);}
#define debug(x...) cerr << "[" << #x << "] = [";_print(x);
#ifndef LOCAL
    #define debug(x...) 42
#endif
#define all(x) (x).begin(),(x).end()

const ld PI = 3.141592653589793;
const int MOD = 1e9 + 7;
const int INF = 1e9;
const ll INFLL = 4e18;
const double EPS = 1e-9;
const int MAXN = 1000*1007;

void solve(int NT){
    int n, m, q; cin >> n >> m >> q;

    vector<pair<ll, ll>> tasks(n);
    for(int i = 0; i < n; ++i) cin >> tasks[i].second;
    for(int i = 0; i < n; ++i) cin >> tasks[i].first;

    sort(tasks.begin(), tasks.end());

    vector<pair<ll, ll>> segs;

    ll last = INFLL;
    for(int i = n - 1; i >= 0; --i) {
        last = min(last, tasks[i].first);
        segs.emplace_back(last - tasks[i].second, last);
        last -= tasks[i].second;
    }
    reverse(segs.begin(), segs.end());

    last = 0;
    vector<ll> episodes;
    for(int i = 0; i < m; ++i) {
        ll x; cin >> x;
        last += x;
        episodes.emplace_back(last);
    }

    episodes.emplace_back(INFLL);

    vector<pair<ll, int>> events;
    for(int i = 0; i < n; ++i) {
        events.emplace_back(segs[i].first, -1);
        events.emplace_back(segs[i].second, -2);
    }

    vector<int> ans(q);
    vector<ll> que(q);
    for(int i = 0; i < q; ++i) {
        cin >> que[i];
        events.emplace_back(que[i], i);
    }

    // debug(segs);
    sort(events.begin(), events.end());
    // debug(events);

    ll tot = 0, last_close = 0;
    bool is_free = true;

    for(auto [tim, ty]: events) {
        if(ty == -1) {
            tot += tim - last_close;
            is_free = false;
        } else if(ty == -2) {
            last_close = tim;
            is_free = true;    
        } else {

            if(is_free) {
                tot += tim - last_close;
                last_close = tim;
            }

            int id = ty;
            int s = upper_bound(episodes.begin(), episodes.end(), tot) - episodes.begin();
            ans[id] = s;
        }
    }

    for(int x: ans) cout << x << ' ';
}

#define TESTCASES
int main(){
    cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
    #ifdef TESTCASES
        cin >> t;
    #endif
    for(int i = 1; i <= t; ++i ){
        solve(i);
        cout << '\n';
    }
    return 0;
}