#include <iostream>
#include <vector>
#include <array>

using namespace std;

template <size_t N>
string checkMarked(const int n, array<string, N> &mat)
{
    int flag = 0;
    while (flag < 10)
    {
        for (int row = 0; row < 2; ++row)
        {
            for (int i = 0; i < n; ++i)
            { // for each char
                if (mat[row][i] == '#')
                    continue;

                vector<pair<int, int>> neighbors;

                if (i > 0) // check left
                {
                    if (mat[row][i - 1] == '@')
                    {
                        neighbors.push_back({row, i - 1});
                    }
                }
                if (i < n - 1) // check right
                {
                    if (mat[row][i + 1] == '@')
                    {
                        neighbors.push_back({row, i + 1});
                    }
                }
                if (mat[(row + 1) % 2][i] == '@') // check bottom/top
                {
                    neighbors.push_back({(row + 1) % 2, i});
                }

                if (neighbors.size() == 0)
                {
                    return "None";
                }
                if (neighbors.size() >= 1)
                {
                    mat[row][i] = '#';
                    mat[neighbors[0].first][neighbors[0].second] = '#';
                    // for (auto neighbor : neighbors)
                    // {
                    //     mat[row][i] = '#';
                    //     mat[neighbor.first][neighbor.second] = '#';
                    //     continue;
                    // }
                }
            }
        }
        ++flag;
    }
    return "Multiple";
}

string testCase()
{
    int n;
    cin >> n;
    // 0 - #; 1 - .; 2 - marked
    array<string, 2> mat;
    cin >> mat[0] >> mat[1];

    int editCnt = 0;
    int cleanCnt = 0;
    while (true)
    {
        for (int row = 0; row < 2; ++row)
        {
            for (int i = 0; i < n; ++i)
            { // for each char
                if (mat[row][i] == '#')
                {
                    ++cleanCnt;
                    continue;
                }

                vector<pair<int, int>> neighbors;

                if (i > 0) // check left
                {
                    if (mat[row][i - 1] == '.' || mat[row][i - 1] == '@')
                    {
                        neighbors.push_back({row, i - 1});
                    }
                }
                if (i < n - 1) // check right
                {
                    if (mat[row][i + 1] == '.' || mat[row][i + 1] == '@')
                    {
                        neighbors.push_back({row, i + 1});
                    }
                }
                if (mat[(row + 1) % 2][i] == '.' || mat[(row + 1) % 2][i] == '@') // check bottom/top
                {
                    neighbors.push_back({(row + 1) % 2, i});
                }

                if (neighbors.size() == 0)
                {
                    return "None";
                }
                if (neighbors.size() == 1)
                {
                    mat[row][i] = '#';
                    mat[neighbors[0].first][neighbors[0].second] = '#';
                    ++editCnt;
                    continue;
                }
                
                if (mat[row][i] == '@' && editCnt == 0)
                {
                    return checkMarked<2>(n, mat);
                }
                mat[row][i] = '@';
                ++editCnt;
            }
        }
        if (cleanCnt == n * 2)
        {
            return "Unique";
        }
        editCnt = 0;
        cleanCnt = 0;
    }
    return "0";
}

int main()
{
    ios_base::sync_with_stdio(false);

    int t;
    cin >> t;

    for (int ti = 0; ti < t; ++ti)
    {
        cout << testCase() << '\n';
    }

    cout << flush;

    return 0;
}