// author: Danila "akshin_" Axyonov

#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
typedef long long int lli;
typedef pair<lli, lli> plli;

#define deadline        first
#define t               second

void solve();

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    lli Q;
    cin >> Q;
    while (Q--)
        solve();

    return 0;
}

void solve() {
    lli N,
        M,
        Q;

    cin >> N >> M >> Q;
    vector<plli> tasks(N);
    for (int i = 0; i < (int)N; ++i)
        cin >> tasks[i].t;
    for (int i = 0; i < (int)N; ++i)
        cin >> tasks[i].deadline;
    vector<lli> movies(M);
    for (int i = 0; i < (int)M; ++i)
        cin >> movies[i];
    vector<lli> queries(Q);
    for (lli i = 0; i < (int)Q; ++i)
        cin >> queries[i];

    vector<lli> movies_pref(M + 1LL);
    movies_pref[0] = 0LL;
    for (int i = 0; i < (int)M; ++i)
        movies_pref[i + 1] = movies_pref[i] + movies[i];

    sort(tasks.begin(), tasks.end());
    vector<lli> tasks_pref(N + 1LL);
    tasks_pref[0] = tasks[0].t;
    for (int i = 1; i < (int)N; ++i)
        tasks_pref[i] = tasks_pref[i - 1] + tasks[i].t;
    vector<lli> free_time(N);
    for (int i = 0; i < (int)N; ++i)
        free_time[i] = tasks[i].deadline - tasks_pref[i];
    for (int i = (int)N - 2; i >= 0; --i)
        free_time[i] = min(free_time[i], free_time[i + 1]);

    for (lli query : queries) {
        lli l = -1LL,
            r = N;
        while (l + 1LL < r) {
            lli m = (l + r) >> 1;
            if (query < tasks[m].deadline)
                r = m;
            else
                l = m;
        }
        lli ftime;
        if (r == N)
            ftime = free_time.back() + (query - tasks.back().deadline);
        else
            ftime = free_time[r];

        lli l1 = 0LL,
            r1 = M + 1LL;
        while (l1 + 1LL < r1) {
            lli m1 = (l1 + r1) >> 1;
            if (movies_pref[m1] <= ftime)
                l1 = m1;
            else
                r1 = m1;
        }

        cout << l1 << ' ';
    }
    cout << '\n';
    return;
}
