//#pragma warning (disable : 4996)
#include <iostream>
#include <string>
#include <vector>
#include <queue>

using namespace std;

int gcd(int a, int b) {
	while (b != 0) {
		a %= b;

		int temp = a;
		a = b;
		b = temp;
	}

	return a;
}

int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	int n;
	cin >> n;



	vector<int> operations;

	for (int i = 0; i < n; i++) {
		string operation;
		string boolean;

		cin >> operation >> boolean;

		int opVal = operation[0] == 's';
		int bVal = boolean[0] == 't';

		int type;
		if (opVal == 1) {
			type = (bVal == 1) ? 1 : 2;
		}
		else {
			type = (bVal == 1) ? 3 : 0; // 0 = 4
		}

		operations.push_back(type);
	}



	vector<vector<int>> edgesTo;
	vector<vector<int>> edgesFrom;
	for (int i = 0; i < n; i++) {
		edgesTo.push_back(vector<int>());
		edgesFrom.push_back(vector<int>());
	}

	int* subCount = new int[n];
	int* belongsTo = new int[n];
	for (int i = 0; i < n; i++) {
		belongsTo[i] = -1;
		subCount[i] = 0;
	}

	int m;
	cin >> m;
	for (int i = 0; i < m; i++) {
		int L, R;
		cin >> L >> R;
		L--;
		R--;

		edgesTo[L].push_back(R);
		edgesFrom[R].push_back(L);

		subCount[L]++;
	}

	queue<int> q;
	for (int i = 0; i < n; i++) {
		if (subCount[i] == 1) q.push(i);
	}

	vector<int> heaps[5];
	bool* isUsed = new bool[n];
	for (int i = 0; i < n; i++) isUsed[i] = false;

	bool isPossible = true;
	while (q.size() > 0 && isPossible) {
		int leftVer = q.front();
		q.pop();

		for (int i = 0; i < edgesTo[leftVer].size(); i++) {
			int rightVer = edgesTo[leftVer][i];

			if (operations[leftVer] > operations[rightVer]) {
				if (operations[rightVer] == 0) {
					operations[rightVer] = 4;
				}
			}

			if (operations[leftVer] > operations[rightVer]) {
				isPossible = false;
				break;
			}

			subCount[rightVer]--;
			if (subCount[rightVer] == 1) {
				q.push(rightVer);
			}
		}

		heaps[operations[leftVer]].push_back(leftVer);
		isUsed[leftVer] = true;
	}

	for (int i = 0; i < n; i++) {
		if (!isUsed[i]) {
			isUsed[i] = true;
			int op = operations[i];

			heaps[op].push_back(i);
		}
	}

	if (heaps[1].size() == 0) {
		for (int i = 2; i < 5; i++) {
			if (heaps[i].size() > 0) {
				isPossible = false;
				break;
			}
		}
	}

	if (heaps[3].size() == 0) {
		for (int i = 4; i < 5; i++) {
			if (heaps[i].size() > 0) {
				isPossible = false;
				break;
			}
		}
	}

	if (isPossible) {
		bool printSpace = false;
		for (int i = 0; i < 5; i++) {
			for (int j = 0; j < heaps[i].size(); j++) {
				if (printSpace) cout << ' ';
				
				cout << heaps[i][j] + 1;

				printSpace = true;
			}
		}
		// output result
	}
	else cout << -1 << endl;

	return 0;

	/*int T;
	cin >> T;

	for (int testId = 0; testId < T; testId++) {
		int W, H;
		cin >> W >> H;

		int w1, h1, x1, y1, dx1, dy1;
		int w2, h2, x2, y2, dx2, dy2;

		cin >> w1 >> h1 >> x1 >> y1 >> dx1 >> dy1;
		cin >> w2 >> h2 >> x2 >> y2 >> dx2 >> dy2;

		int cycleCount = 0;
		int intersectionCount = 0;

		int W1 = W - w1;
		int W2 = W - w2;
		int H1 = H - h1;
		int H2 = H - h2;

		int startX1 = x1;
		int startX2 = x2;
		int startY1 = y1;
		int startY2 = y2;

		do {
			cycleCount++;
			if (x1 >= x2 && x1 < x2 + w2 && y1 >= y2 && y1 < y2 + h2) {
				intersectionCount++;
			}
			else if (x2 >= x1 && x2 < x1 + w1 && y2 >= y1 && y2 < y1 + h1) {
				intersectionCount++;
			}

			x1 += dx1;
			x2 += dx2;
			y1 += dy1;
			y2 += dy2;

			if (x1 == 0 || x1 == W1) dx1 = -dx1;
			if (x2 == 0 || x2 == W2) dx2 = -dx2;
			if (y1 == 0 || y1 == H1) dy1 = -dy1;
			if (y2 == 0 || y2 == H2) dy2 = -dy2;

		} while (x1 != startX1 || x2 != startX2 || y1 != startY1 || y2 != startY2);

		int g = gcd(cycleCount, intersectionCount);
		cycleCount /= g;
		intersectionCount /= g;

		cout << intersectionCount << '/' << cycleCount << endl;
	}*/

	return 0;
}
