#include <bits/stdc++.h>

using namespace std;

template<typename T>
bool mini(T &a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}


template<typename T>
bool maxi(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

template<ranges::input_range R>
requires (!is_same_v<string, R> && !is_convertible_v<R, string>)
ostream &operator<<(ostream &out, const R &v) {
    string space = "\n";
    if constexpr (is_scalar_v<typename R::value_type>) {
        space = " ";
    }
    for (const auto &a: v) {
        out << a << space;
    }
    return out;
}


template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &a: v) {
        in >> a;
    }
    return in;
}

template<typename T, typename U>
ostream &operator<<(ostream &out, pair<T, U> &v) {
    out << v.first << ' ' << v.second;
    return out;
}

template<typename T, typename U>
istream &operator>>(istream &in, pair<T, U> &v) {
    in >> v.first >> v.second;
    return in;
}

using ll = long long;

/*
 *
 */

const ll maxval = 1e10;

bool do_add(char c, ll &sum, ll &cur, ll &lastop, bool &find) {
    if (c == '+' || c == '-' || c == '=') {
        sum += cur * lastop;
        if (c == '+') {
            lastop = 1;
        } else if (c == '-') {
            lastop = -1;
        } else {
            lastop = 1;
            find = true;
        }
        cur = 0;
    } else {
        if (cur == 0 && c == '0') {
            return false;
        }
        cur = cur * 10 + c - '0';
        if (cur >= maxval) {
            return false;
        }
    }
    return true;
}

bool check(const string &s) {
    ll a = 0;
    ll b = 0;
    ll cur = 0;
    ll lastop = 1;
    bool find = false;
    for (char c: s) {
        if (!find) {
            if (!do_add(c, a, cur, lastop, find)) {
                return false;
            }
        } else {
            if (!do_add(c, b, cur, lastop, find)) {
                return false;
            }
        }
    }
    if (cur >= maxval) {
        return false;
    }
    b += cur * lastop;
    return a == b && find;
}

bool is_c(char c) {
    return '0' <= c && c <= '9';
}

void solve() {
    string s;
    cin >> s;
    if (check(s)) {
        cout << "Correct";
        return;
    }
    for (int i = 0; i < s.size(); i++) {
        if (is_c(s[i]) &&
                ((i > 0 && is_c(s[i - 1])) || (i + 1 < s.size() && is_c(s[i + 1])))) {
            char cur = s[i];
            string copy = s;
            copy.erase(copy.begin() + i);
            for (int j = 0; j <= copy.size(); j++) {
                string copy2 = copy;
                copy2.insert(copy2.begin() + j, cur);
                if (check(copy2)) {
                    cout << copy2;
                    return;
                }
            }
        }
    }
    cout << "Impossible";
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int test = 1;
#ifdef BOBRY
    freopen("./../bobry.in", "r", stdin);
    freopen("./../bober.out", "w", stdout);
#endif

#ifdef BOBRY
    cin >> test;
#endif

    while (test--) {
        solve();
        cout << '\n';
    }
}