#include <bits/stdc++.h>

using namespace std;

template<typename T>
bool mini(T &a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}


template<typename T>
bool maxi(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

template<ranges::input_range R>
requires (!is_same_v<string, R> && !is_convertible_v<R, string>)
ostream &operator<<(ostream &out, const R &v) {
    string space = "\n";
    if constexpr (is_scalar_v<typename R::value_type>) {
        space = " ";
    }
    for (const auto &a: v) {
        out << a << space;
    }
    return out;
}


template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &a: v) {
        in >> a;
    }
    return in;
}

template<typename T, typename U>
ostream &operator<<(ostream &out, pair<T, U> &v) {
    out << v.first << ' ' << v.second;
    return out;
}

template<typename T, typename U>
istream &operator>>(istream &in, pair<T, U> &v) {
    in >> v.first >> v.second;
    return in;
}

using ll = long long;

/*
 *
 */

struct edge {
    int to;
    ll w;

    edge(int to, ll w) : to(to), w(w) {}
};


constexpr ll INF = 2e18;

using graph = vector<vector<int>>;
using wgraph = vector<vector<edge>>;

bool recalc(int to, int from, vector<int>& dp, int n, int w) {
    if (to == n - 1) {
        return false;
    }
    return mini(dp[to], dp[from] + w);
}

void solve() {
    int n, m;
    cin >> n >> m;
    wgraph g(n);
    for (int i = 0; i < m; ++i) {
        int a, b;
        ll c;
        cin >> a >> b >> c;
        --a;--b;
        g[b].emplace_back(a, c);
    }


    vector<ll> d(n, INF);
    auto cmp = [&d](int i, int j) {
        if (d[i] != d[j]) {
            return d[i] < d[j];
        }
        return i < j;
    };
    set<int, decltype(cmp)> qd(cmp);
    d[n - 1] = 0;
    qd.insert(n - 1);
    while (!qd.empty()) {
        int v = *qd.begin();
        qd.erase(qd.begin());
        for (edge e:g[v]) {
            if (d[e.to] > d[v] + e.w) {
                qd.erase(e.to);
                d[e.to] = d[v] + e.w;
                qd.insert(e.to);
            }
        }
    }

    vector<int> cnt(n, 0);
    for (int i = 0; i < n; ++i) {
        for (edge e :g[i]) {
            if (d[e.to] == d[i] + e.w) {
                ++cnt[e.to];
            }
        }
    }

    queue<int> q0;
    queue<int> q;
    vector<int> dp(n, n);
    for (int i = 0; i < n; ++i) {
        if (d[i] == INF) {
            q0.push(i);
            dp[i] = -1;
        }
    }

    while (!q0.empty() || !q.empty()) {
        int v;
        if (q0.empty()) {
            v = q.front();
            q.pop();
        } else {
            v = q0.front();
            q0.pop();
        }
        mini(dp[v], n);
        for (edge e: g[v]) {
            if (d[e.to] == d[v] + e.w && --cnt[e.to] == 0 && recalc(e.to, v, dp, n, 0)) {
                q0.push(e.to);
            }
            if (recalc(e.to, v, dp, n, 1)) {
                q.push(e.to);
            }
        }
    }
    cout << dp[0];
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int test = 1;
#ifdef BOBRY
    freopen("./../bobry.txt", "r", stdin);
    freopen("./../bober.txt", "w", stdout);
#endif

#ifdef BOBRY
    cin >> test;
#endif

    while (test--) {
        solve();
        cout << '\n';
    }
}