#include <iostream>
#include <vector>
#include <string>
#include <unordered_map>
#include <algorithm>
#include <set>
using namespace std;

#define int long long

bool cycle = false;

vector<int> visit, order;
vector<vector<int>> g;
void topsort(int v)
{
    if (cycle)
        return;

    visit[v] = 1;
    for (auto u : g[v]) {
        if (visit[u] == 0) {
            topsort(u);
        } else {
            cycle = false;
        }
    }

    visit[v] = 2;
    order.push_back(v);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    set<int> sets, unsets;

    int posset = -1, posunset = -1;
    for (int i = 1; i <= n; i++) {
        string type, res;
        cin >> type >> res;

        if (res == "true") {
            if (type == "set") {
                if (posset != -1) {
                    cout << "-1\n";
                    return 0;
                }
                posset = i;
            }
            else {
                if (posunset != -1) {
                    cout << "-1\n";
                    return 0;
                }
                posunset = i;
            }
        }
        else if (type == "set")
            sets.insert(i);
        else
            unsets.insert(i);
    }

    int m;
    cin >> m;

    vector<vector<int>> edges(n + 1);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        edges[u].push_back(v);
    }

    g.resize(n + 1);
    visit.resize(n + 1, 0);

    set<int> bs = sets;
    if (posset != -1) {
        for (auto e : sets)
            g[posset].push_back(e);
        if (posunset != -1)
            g[posset].push_back(posunset);
        bs.insert(posset);
    }

    if (posunset != -1) {
        for (auto e : sets)
            g[e].push_back(posunset);
        bs.insert(posunset);
    }

    for (int i = 0; i < edges.size(); i++) {
        for (auto e : edges[i]) {
            if (bs.find(i) != bs.end() && bs.find(e) != bs.end()) {
                g[i].push_back(e);
            }
        }
    }

    for (auto v : bs)
        if (!visit[v])
            topsort(v);

    if (cycle) {
        cout << "-1\n";
        return 0;
    }

    reverse(order.begin(), order.end());
    vector<int> ans = order;
    order.clear();

    visit.assign(n + 1, 0);
    g.assign(n + 1, vector<int>());
    for (int i = 0; i < edges.size(); i++) {
        for (auto e : edges[i]) {
            if (bs.find(i) == bs.end() || bs.find(e) == bs.end()) {
                int first = i, second = e;
                if (bs.find(first) != bs.end())
                    first = 0;
                if (bs.find(second) != bs.end())
                    second = 0;
                g[first].push_back(second);
            }
        }
    }

    for (int i = 0; i <= n; i++)
        if (bs.find(i) == bs.end() && !visit[i])
            topsort(i);
    reverse(order.begin(), order.end());

    if (cycle) {
        cout << "-1\n";
        return 0;
    }

    vector<int> result;

    int pos = 0;
    while (pos < order.size() && order[pos] != 0) {
        result.push_back(order[pos]);
        pos++;
    }
    for (auto e : ans)
        result.push_back(e);

    pos++;
    while (pos < order.size() && order[pos] != 0) {
        result.push_back(order[pos]);
        pos++;
    }

    int start = false;
    for (auto e : result) {
        if (sets.find(e) != sets.end() && start == true)
            ;
        else if (unsets.find(e) != unsets.end() && start == false)
            ;
        else if (e == posset && start == false)
            start = true;
        else if (e == posunset && start == true)
            start = false;
        else {
            cout << "-1\n";
            return 0;
        }
    }

    for (auto e : result)
        cout << e << ' ';
    cout << '\n';

    return 0;
}
