#include <iostream>
#include <vector>
#include <string>
#include <unordered_map>
#include <algorithm>
using namespace std;

#define int long long

void solve() {
    int n, m, q;
    cin >> n >> m >> q;

    vector<int> episodes(m);
    vector<pair<int, int>> tasks(n);
    for (int i = 0; i < n; i++) cin >> tasks[i].second;
    for (int i = 0; i < n; i++) cin >> tasks[i].first;
    for (int i = 0; i < m; i++) cin >> episodes[i];
    sort(tasks.begin(), tasks.end());

    vector<int> start(n);
    for (int i = n - 1; i >= 0; i--) {
        start[i] = tasks[i].first - tasks[i].second + 1;
        if (i + 1 != n)
            start[i] = min(start[i], start[i + 1] - tasks[i].second + 1);
    }

    vector<int> watches;
    int cur_time = 1, cur_task = 0;
    for (int i = 0; i < m; i++) {
        while (cur_task < n && cur_time + episodes[i] - 1 >= start[cur_task]) {
            start[cur_task] = cur_time;
            cur_time += tasks[cur_task].second;
            cur_task++;
        }

        cur_time += episodes[i];
        watches.push_back(cur_time - 1);
    }

    while (q--) {
        int tk;
        cin >> tk;

        int l = -1, r = m;
        while (l + 1 < r) {
            int m = (l + r) / 2;

            if (watches[m] <= tk)
                l = m;
            else
                r = m;
        }

        cout << r << ' ';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--)
        solve();

    return 0;
}
