#ifndef LOCAL
#pragma GCC optimize("O3")
#endif
#include <bits/stdc++.h>
#define sz(n) (int)(n).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define endl '\n'
using namespace std;
using ll = int64_t;

const int N = 200010;
vector<int> g[N];
int col[N];
int rev_col[N];

pair<int, int> match[N];
int match_index[N];
int match_sz = 0;

int match_dfs(int v, int r) {
    int is_paired = 0;
    for (auto u : g[v]) {
        if (u == r) continue;
        int res = match_dfs(u, v);
        if (res == 1 && is_paired == 0) {
            match_index[u] = 2 * match_sz;
            match_index[v] = 2 * match_sz + 1;
            match[match_sz++] = {u, v};
            is_paired = 1;
        }
    }
    return !is_paired;
}

void solve() {
    int colors;
    cin >> colors;
    int n = 2 * colors;
    fill(rev_col, rev_col + n, -1);
    fill(match_index, match_index + n, -1);
    match_sz = 0;
    for (int i = 0; i < n; ++i) {
        g[i].clear();
    }
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        --x;
        int c = 2 * x;
        if (rev_col[c] != -1) ++c;
        col[i] = c;
        rev_col[c] = i;
    }
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    match_dfs(0, -1);
    vector<pair<int, int>> ans;
    for (int it = 0; it < match_sz; ++it) {
        int cur = it;
        int banned = 0;
        int col0 = col[match[cur].first];
        int col1 = col[match[cur].second];
        while (cur != -1 && (col0 ^ col1) != 1) {
            int my_col;
            int swapped_v;
            if (banned == 0) {
                my_col = col0 ^ 1;
                swapped_v = match[cur].second;
            } else {
                my_col = col1 ^ 1;
                swapped_v = match[cur].first;
            }
            int other_v = rev_col[my_col];
            swap(col[other_v], col[swapped_v]);
            swap(rev_col[col[other_v]], rev_col[col[swapped_v]]);
            ans.emplace_back(other_v, swapped_v);
            int ind = match_index[other_v];
            int other_pair_col = col[other_v] ^ 1;
            int other_pair_v = rev_col[other_pair_col];
            int pair_ind = match_index[other_pair_v];
            if (ind == -1) {
                if (pair_ind == -1) break;
                banned = (pair_ind ^ 1) & 1;
                cur = pair_ind >> 1;
            } else {
                if (pair_ind == -1) break;
                banned = ind & 1;
                cur = ind >> 1;
            }
            col0 = col[match[cur].first];
            col1 = col[match[cur].second];
        }
    }
    cout << ans.size() << endl;
    for (auto [a, b] : ans) {
        cout << a + 1 << ' ' << b + 1 << endl;
    }
}

int main() {
#ifdef LOCAL
    freopen("../stream.in", "r", stdin);
    freopen("../stream.out", "w", stdout);
    auto start = clock();
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif
    int tt = 1;
    cin >> tt;
    while (tt--) solve();
#ifdef LOCAL
    cerr << "TIME: " << 1e3 * (clock() - start) / CLOCKS_PER_SEC << " ms\n";
#endif
    return 0;
}