#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

using namespace std;
using ll = long long;
using vi = vector<int>;
using vl = vector<ll>;

const ll INF = 2e18;

using ld = long double;

struct Number {
    ll x, y;
};
Number operator+(const Number &a, const Number &b) {
    return {a.x + b.x, a.y + b.y};
}
Number operator-(const Number &a, const Number &b) {
    return {a.x - b.x, a.y - b.y};
}
Number operator*(const Number &a, ll x) {
    return {a.x * x, a.y * x};
}
Number operator*(const Number &a, const Number& b) {
    return {a.x * b.x + a.y * b.y * 2, a.x * b.y + a.y * b.x};
}

ll sgn(ll x) {
    if (x > 0) return 1;
    if (x < 0) return -1;
    return 0;
}

bool operator<(const Number &a, const Number &b) {
    // a.x + sqrt(2) * a.y < b.x + sqrt(2) * b.y
    ll v1 = a.x - b.x;
    ll v2 = b.y - a.y;
    ll s1 = sgn(v1);
    ll s2 = sgn(v2);
    if (s1 != s2) return s1 < s2;
    if (s1 == 0) return false;
    if (s1 == 1) return v1 * v1 < 2 * v2 * v2;
    return v1 * v1 > 2 * v2 * v2;
}
bool operator<=(const Number &a, const Number &b) {
    return !(b < a);
}
bool operator==(const Number &a, const Number &b) {
    return make_pair(a.x, a.y) == make_pair(b.x, b.y);
}

using pt = pair<Number, Number>;

Number SIN[360], COS[360];


void precalc() {
    SIN[0] = {0, 0};
    SIN[45] = {0, 1};
    SIN[90] = {2, 0};
    SIN[135] = {0, 1};
    COS[0] = {2, 0};
    COS[45] = {0, 1};
    COS[90] = {0, 0};
    COS[135] = {0, -1};


    for(int i = 180; i < 360; i += 45) {
        SIN[i] = SIN[i - 180] * (-1ll);
        COS[i] = COS[i - 180] * (-1ll);
    }
}

Number operator*(const pt &a, const pt &b) {
    return a.first * b.second - a.second * b.first;
}

pt operator-(const pt &a, const pt &b) {
    return {a.first - b.first, a.second - b.second};
}

bool check(Number l1, Number r1, Number l2, Number r2) {
    if (r1 < l1) swap(l1, r1);
    if (r2 < l2) swap(l2, r2);
    return max(l1, l2) <= min(r1, r2);
}

const Number ZERO = {0, 0};
vector<ar<int, 2>> commands;
vector<pair<pt, pt>> get_segs(int ang) {
    vector<pair<pt, pt>> who;

    auto Add = [&] (pair<pt, pt> seg) {
        if (seg.first > seg.second) swap(seg.first, seg.second);
        vector<bool> ok(who.size(), true);
        rep(i, who.size()) {
            pt v1 = seg.second - seg.first;
            auto [u, v] = who[i];
            pt v2 = v - u;

            Number res = v1 * v2;
            if (res != ZERO) continue;

            pt v3 = v - seg.first;
            res = v1 * v3;
            if (res != ZERO) continue;

            if (!check(seg.first.first, seg.second.first, u.first, v.first)) continue;
            if (!check(seg.first.second, seg.second.second, u.second, v.second)) continue;
            ok[i] = false;

            pt mn = min({seg.first, seg.second, u, v});
            pt mx = max({seg.first, seg.second, u, v});
            seg = {mn, mx};
        }

        int j = 0;
        rep(i, who.size()) {
            if (!ok[i]) continue;
            swap(who[i], who[j++]);
        }
        who.resize(j);

        who.emplace_back(seg);
    };

    pt cur = {ZERO, ZERO};
    for(auto &[tp, d] : commands) {
        if (tp == 0) {
            ang += d;
            ang %= 360;
            continue;
        }
        pt nxt = cur;
        nxt.first = nxt.first + COS[ang] * d;
        nxt.second = nxt.second + SIN[ang] * d;
        if (tp == 1) Add({cur, nxt});
        cur = nxt;
    }

    pt mn = who[0].first;
    for(auto &[u, v] : who) {
        mn = min(mn, u);
    }
    for(auto &[u, v] : who) {
        u = u - mn;
        v = v - mn;
    }
    sort(all(who));
    return who;
}

void solve() {
    int n; cin >> n;
    rep(_, n) {
        ar<int, 2> cur;
        string s; cin >> s;
        if (s == "rotate") {
            cur[0] = 0;
        } else if (s == "draw") {
            cur[0] = 1;
        } else {
            cur[0] = 2;
        }
        cin >> cur[1];
        commands.push_back(cur);
    }

    auto segs = get_segs(0);
    for(int ang = 45; ang <= 360; ang += 45) {
        auto segs2 = get_segs(ang % 360);
        if (segs == segs2) {
            cout << ang << '\n';
            return;
        }
    }
    assert(0);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    precalc();
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}