#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector<int> solve_topsort(int n, vector<pair<int, int>>& edges)
{
    sort(edges.begin(), edges.end());
    int m = edges.size();
    vector<int> counts(n);
    for(int i = 0; i < m; i++)
	if(edges[i].first != edges[i].second)
	counts[edges[i].second]++;
    vector<int> ans;
    for(int i = 0; i < n; i++)
	if(counts[i] == 0)
	    ans.push_back(i);
    for(int i = 0; i < ans.size(); i++)
    {
	int j = ans[i];
	int idx = lower_bound(edges.begin(), edges.end(), make_pair(j, 0)) - edges.begin();
	while(idx < m && edges[idx].first == j)
	{
	    if(!--counts[edges[idx].second])
		ans.push_back(edges[idx].second);
	    idx++;
	}
    }
    return ans;
}

int main()
{
    int n;
    cin >> n;
    vector<pair<bool, bool>> data;
    for(int i = 0; i < n; i++)
    {
	string a, b;
	cin >> a >> b;
	data.push_back(make_pair(a == "set", b == "true"));
    }
    int m;
    cin >> m;
    vector<pair<int, int>> edges(m);
    auto bad = [&]()
    {
	cout << "-1\n";
	exit(0);
    };
    for(int i = 0; i < m; i++)
    {
	cin >> edges[i].first >> edges[i].second;
	edges[i].first--;
	edges[i].second--;
	if(edges[i].first == edges[i].second)
	    bad();
    }
    int n_set = 0;
    int n_unset = 0;
    for(auto& i : data)
	if(i.second)
	    if(i.first)
		n_set++;
            else
		n_unset++;
    vector<int> ans;
    if(n_set && n_unset)
    {
	auto edges2 = edges;
	for(auto& i : edges2)
	{
	    if(data[i.first].first || data[i.first].second)
		i.first = n;
	    if(data[i.second].first || data[i.second].second)
		i.second = n;
	}
	vector<int> topsort1 = solve_topsort(n+1, edges2);
	if(topsort1.size() != n+1)
	    bad();
	vector<pair<int, int>> edges3;
	for(auto& i : edges)
	    if((data[i.first].first || data[i.first].second) && (data[i.second].first || data[i.second].second))
		edges3.push_back(i);
	int which_set_true = 0;
	while(!data[which_set_true].first || !data[which_set_true].second)
	    which_set_true++;
	int which_unset_true = 0;
	while(data[which_unset_true].first || !data[which_unset_true].second)
	    which_unset_true++;
	for(int i = 0; i < n; i++)
	    if(data[i].first || data[i].second)
	    {
		edges3.push_back(make_pair(which_set_true, i));
		edges3.push_back(make_pair(i, which_unset_true));
	    }
	vector<int> topsort2 = solve_topsort(n, edges3);
	if(topsort2.size() != n)
	    bad();
	for(int i : topsort1)
	{
	    if(i == n)
	    {
		for(int j : topsort2)
		    if(data[j].first || data[j].second)
			ans.push_back(j);
	    }
	    else if(data[i].first || data[i].second)
		continue;
	    else
		ans.push_back(i);
	}
    }
    else if(n_set)
    {
	int which_set_true = 0;
	while(!data[which_set_true].first || !data[which_set_true].second)
	    which_set_true++;
	for(int i = 0; i < n; i++)
	    if(data[i].first)
		edges.push_back(make_pair(which_set_true, i));
	    else
		edges.push_back(make_pair(i, which_set_true));	
	ans = solve_topsort(n, edges);
    }
    else if(!n_set && !n_unset)
    {
	for(auto& i : data)
	    if(i.first)
		bad();
	ans = solve_topsort(n, edges);
    }
    if(ans.size() != n)
	bad();
    cout << ans[0] + 1;
    for(int i = 1; i < n; i++)
	cout << ' ' << ans[i] + 1;
    cout << endl;
    return 0;
}
