#include <iostream>
#include <vector>
#include <array>

using namespace std;

/*
01
10

00
00

10
01

11
11

10
10

*/

const int MAXN = 2e5 + 123;
int dp[MAXN][4];
int a[MAXN];

int clip(int x, int a, int b) {
  return min(max(x, a), b);
}

bool check(int a, int b) {
  return a == 1 && b == 2 ||
         a == 2 && b == 1 ||
         a == 3 && b == 0 ||
         a == 3 && b == 3 ||
         a == 0 && b == 3;
}

void solve() {
  int n;
  cin >> n;
  for (int i = 0; i <= n; i++) {
    for (int j = 0; j < 4; j++) {
      dp[i][j] = 0;
    }
    a[i] = 0;
  }
  for (int i = 0; i < 2; i++) {
    string s;
    cin >> s;
    for (int j = 0; j < n; j++) {
      if (s[j] == '#') {
        a[j] |= 1 << i;
      }
    }
  }

  dp[0][3] = 1;
  for (int i = 1; i <= n; i++) {
    for (int prev = 0; prev < 4; prev++) {
      for (int cur = 0; cur < 4; cur++) {
        if (!check(prev, cur)) {
          continue;
        }
        if (cur & a[i - 1]) {
          continue;
        }
        auto& kek = dp[i][cur | a[i - 1]];
        kek += dp[i - 1][prev];
        kek = clip(kek, 0, 4);
      }
    }
  }

  /*
  for (int i = 0; i <= n; i++) {
    for (int j = 0; j < 4; j++) {
      cout << i << " " << j << " " << dp[i][j] << endl;
    }
  }
  */

  if (dp[n][3] == 0) {
    cout << "None\n";
  } else if (dp[n][3] == 1) {
    cout << "Unique\n";
  } else {
    cout << "Multiple\n";
  }
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  int t;
  cin >> t;
  while (t--) {
    solve();
  }
}
