#include <bits/stdc++.h>

#pragma GCC optimize("O3", "unroll-loops")
#pragma GCC target("sse4.2")

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int,int>;
using pll = pair<ll,ll>;
using graph = vector<vector<int>>;

#define all(a) a.begin(), a.end()
#define f first
#define s second
#define pb push_back

const int mod = 1'000'000'007;
const ld eps = 1e-9;
const ll inf = 3'000'000'000'000'000'007ll;

struct IOInit {
    IOInit() {
        cin.tie(0)->sync_with_stdio(0);
        cout << fixed << setprecision(12);
    }
    ~IOInit() {
        #ifdef DEBUG
            cerr << fixed << setprecision(5) << "Runtime: " << clock() * 1.0 / CLOCKS_PER_SEC << endl;
        #endif
    }
} _io;

template<class T> istream& operator>>(istream& str, vector<T> &x) {
    for (auto &i : x) str >> i;
    return str;
}
template<class ...T> void read(T&... x) {(cin >> ... >> x);}
template<class ...T> void print(const T&... x) {(cout << ... << x);}
template<class ...T> void println(const T&... x) {print(x..., '\n');}

template<class T> int sz(const T& x) {return x.size();}
template<class T, class U> bool chmin(T& x, const U& y) {return y < x?x=y,1:0;}
template<class T, class U> bool chmax(T& x, const U& y) {return x < y?x=y,1:0;}

#ifdef DEBUG
    template<class T>
    string pdbg(const T& x) {
        if constexpr (same_as<T, string>) {
            return "\"" + x  +"\"";
        }
        if constexpr (requires{x.first;}) {
            return "{" + pdbg(x.f) + ", " + pdbg(x.s) + "}";
        }
        if constexpr (requires{cout << x;}) {
            stringstream ss;
            ss << x;
            return ss.str();
        }
        if constexpr(ranges::range<T>) {
            string ans = "{";
            string del = ", ";
            auto it = begin(x);
            if (it != end(x)) ans += pdbg(*it++);
            while (it !=end(x)) ans += del + pdbg(*it++);
            return ans + "}";
        }
        return "Can't parse type";
    }
    template<class T, class ...U>
    string pdbg(const T& x, const U&... y) {
        return pdbg(x) + ", " + pdbg(y...);
    }
    #define dbg(...) print("[",#__VA_ARGS__,"] = ", pdbg(__VA_ARGS__)), cout << endl
#else
    #define dbg(...) 0
#endif

graph G, rev;
vector<int> order;
vector<bool> used;
int banned = -1;

void dfs_order(int v, graph &G) {
    if (used[v] || v == banned) return;
    used[v] = true;
    for (auto i : G[v]) {
        dfs_order(i, G);
    }
    order.pb(v);
}

vector<int> toposort(graph &G) {
    order = vector<int>();
    used = vector<bool>(sz(G));
    for (int i = 0; i < sz(G); ++i) {
        dfs_order(i, G);
    }
    reverse(all(order));
    return order;
}

int main() {
    int n;
    read(n);
    int true_set = -1;
    int true_unset = -1;
    vector<int> bad_set;
    vector<int> bad_unset;
    vector<bool> unset(n);
    for (int i = 0; i < n; ++i) {
        string a, b;
        read(a, b);
        if (b == "true") {
            auto &true_var = a == "set" ? true_set : true_unset;
            if (true_var != -1) {
                println(-1);
                return 0;
            }
            true_var = i;
        } else {
            auto &bad_var = a == "set" ? bad_set : bad_unset;
            bad_var.pb(i);
            unset[i] = a == "unset";
        }
    }
    if (true_unset != -1 && true_set == -1) {
        println(-1);
        return 0;
    }
    if (true_set == -1 && sz(bad_set) > 0) {
        println(-1);
        return 0;
    }
    int m;
    read(m);
    dbg(unset);
    G = rev = graph(n);
    auto add_edge = [&](int u, int v) {
        G[u].pb(v);
        rev[v].pb(u);
    };
    for (int i = 0; i < m; ++i) {
        int u, v;
        read(u, v);
        --u, --v;
        add_edge(u, v);
    }
    for (auto i : bad_set) {
        if (true_set != -1) {
            add_edge(true_set, i);
        }
        if (true_unset != -1) {
            add_edge(i, true_unset);
        }
    }
    if (true_set != -1 && true_unset == -1) {
        for (auto i : bad_unset) {
            add_edge(i, true_set);
        }
    }
    auto try_dfs = [&](int v, int b, graph &G) {
        used = vector<bool>(n);
        if (v == -1) return used;
        banned = b;
        dfs_order(v, G);
        return used;
    };
    vector<bool> forward_set = try_dfs(true_set, true_unset, G);
    vector<bool> backward_unset = try_dfs(true_unset, true_set, rev);
    vector<bool> forward_unset = try_dfs(true_unset, true_set, G);
    for (int i = 0; i < n; ++i) {
        if (!unset[i]) continue;
        if (forward_set[i] && backward_unset[i] || forward_set[i] && true_unset == -1) {
            println(-1);
            return 0;
        }
    }
    vector<bool> backward_unset_full = try_dfs(true_unset, -1, rev);
    vector<bool> backward_set_full = try_dfs(true_set, -1, rev);
    vector<bool> forward_set_full = try_dfs(true_set, -1, G);
    dbg(forward_set_full);
    auto order = toposort(G);
    vector<int> lft, rgt;
    vector<int> mid;
    for (auto i : order) {
        if (unset[i]) {
            if (backward_unset_full[i] || backward_set_full[i] || true_unset == -1) {
                if (forward_set_full[i])  {
                    println(-1);
                    return 0;
                }
                lft.pb(i);
            } else {
                rgt.pb(i);
            }
        } else {
            mid.pb(i);
        }
    }
    dbg(lft, mid, rgt);
    vector<int> ans;
    for (auto i : lft) ans.pb(i);
    for (auto i : mid) ans.pb(i);
    for (auto i : rgt) ans.pb(i);
    vector<int> pos(n);
    for (int i = 0; i < n; ++i) {
        pos[ans[i]] = i;
    }
    for (int i = 0; i < n; ++i) {
        for (auto j : G[i]) {
            if (pos[i] > pos[j]) {
                println(-1);
                return 0;
            }
        }
    }
    for (auto i : ans) print(i + 1, ' ');
    return 0;
}