#include <bits/stdc++.h>

#pragma GCC optimize("O3", "unroll-loops")
#pragma GCC target("sse4.2")

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int,int>;
using pll = pair<ll,ll>;
using graph = vector<vector<int>>;

#define all(a) a.begin(), a.end()
#define f first
#define s second
#define pb push_back

const int mod = 1'000'000'007;
const ld eps = 1e-9;
const ll inf = 3'000'000'000'000'000'007ll;

struct IOInit {
    IOInit() {
        cin.tie(0)->sync_with_stdio(0);
        cout << fixed << setprecision(12);
    }
    ~IOInit() {
        #ifdef DEBUG
            cerr << fixed << setprecision(5) << "Runtime: " << clock() * 1.0 / CLOCKS_PER_SEC << endl;
        #endif
    }
} _io;

template<class T> istream& operator>>(istream& str, vector<T> &x) {
    for (auto &i : x) str >> i;
    return str;
}
template<class ...T> void read(T&... x) {(cin >> ... >> x);}
template<class ...T> void print(const T&... x) {(cout << ... << x);}
template<class ...T> void println(const T&... x) {print(x..., '\n');}

template<class T> int sz(const T& x) {return x.size();}
template<class T, class U> bool chmin(T& x, const U& y) {return y < x?x=y,1:0;}
template<class T, class U> bool chmax(T& x, const U& y) {return x < y?x=y,1:0;}

#ifdef DEBUG
    template<class T>
    string pdbg(const T& x) {
        if constexpr (same_as<T, string>) {
            return "\"" + x  +"\"";
        }
        if constexpr (requires{x.first;}) {
            return "{" + pdbg(x.f) + ", " + pdbg(x.s) + "}";
        }
        if constexpr (requires{cout << x;}) {
            stringstream ss;
            ss << x;
            return ss.str();
        }
        if constexpr(ranges::range<T>) {
            string ans = "{";
            string del = ", ";
            auto it = begin(x);
            if (it != end(x)) ans += pdbg(*it++);
            while (it !=end(x)) ans += del + pdbg(*it++);
            return ans + "}";
        }
        return "Can't parse type";
    }
    template<class T, class ...U>
    string pdbg(const T& x, const U&... y) {
        return pdbg(x) + ", " + pdbg(y...);
    }
    #define dbg(...) print("[",#__VA_ARGS__,"] = ", pdbg(__VA_ARGS__)), cout << endl
#else
    #define dbg(...) 0
#endif

pair<vector<char>, vector<string>> split(string s, set<char> d) {
    int p = -1;
    vector<string> t;
    vector<char> sg;
    for (int i = 0; i < sz(s); ++i) {
        if (d.count(s[i])) {
            sg.pb(s[i]);
            t.pb(s.substr(p + 1, i - p - 1));
            p = i;
        }
    }
    t.pb(s.substr(p + 1, sz(s) - p));
    return {sg, t};
}

optional<ll> eval(string s) {
    auto [sg, v] = split(s, {'+', '-'});
    if (sz(sg) != sz(v) - 1) return {};
    for (int i = 0; i < sz(v); ++i) {
        if (sz(v[i]) < 1 || sz(v[i]) > 10 || sz(v[i]) > 1 && v[i][0] == '0') {
            return {};
        }
    }
    sg.insert(sg.begin(), '+');
    ll ans = 0;
    for (int i = 0; i < sz(v); ++i) {
        ll val = stoll(v[i]);
        ans += sg[i] == '+' ? val : -val;
    }
    return ans;
}

int main() {
    string s;
    read(s);
    auto [ignore, lr] = split(s, {'='});
    dbg(lr);
    auto check_equal = [&](string a, string b) {
        dbg(a, b);
        auto va = eval(a), vb = eval(b);
        return va && vb && va.value() == vb.value();
    };
    if (check_equal(lr[0], lr[1])) {
        println("Correct");
        return 0;
    }
    for (int from = 0; from < 2; ++from) {
        for (int to = 0; to < 2; ++to) {
            for (int i = 0; i < sz(lr[from]); ++i) {
                for (int j = 0; j < sz(lr[to]) - (from == to); ++j) {
                    auto check = lr;
                    char c = check[from][i];
                    if (!(c >= '0' && c <= '9')) continue;
                    check[from].erase(check[from].begin() + i);
                    check[to].insert(check[to].begin() + j, c);
                    if (check_equal(check[0], check[1])) {
                        println(check[0], '=', check[1]);
                        return 0;
                    }
                }
            }
        }
    }
    println("Impossible");
    return 0;
}