#include <bits/stdc++.h>
#define int long long
using namespace std;

int getX(int angle)
{
    if ((angle >= 0 && angle < 90) ||
        (angle > 270 && angle <= 360))
        return 1;

    if ((angle > 90 && angle < 270))
        return -1;

    return 0;
}

int getY(int angle)
{
    if (angle > 0 && angle < 180)
        return 1;

    if (angle > 180 && angle < 360)
        return -1;

    return 0;
}

void normalize(vector<vector<int> > &lines)
{
    for (auto &u : lines)
    {
        if (u[8] >= 180 && u[8] < 360)
        {
            swap(u[0], u[4]);
            swap(u[1], u[5]);
            swap(u[2], u[6]);
            swap(u[3], u[7]);
        }
    }
}

void getLines(int angle, vector<int> &type, vector<int> &val, vector<vector<int> > &lines)
{
    int xa, xb, ya, yb;
    xa = xb = ya = yb = 0;

    for (int i = 0; i < type.size(); i++)
    {
        if (type[i] == 0)
        {
            angle += val[i];
            while (angle > 360)
                angle -= 360;
        }
        else if (type[i] == 1)
        {
            int cx = getX(angle);
            int cy = getY(angle);

            int exa, exb, eya, eyb;
            exa = exb = eya = eyb = 0;

            if (angle % 90 == 0)
            {
                exa = xa + cx * val[i];
                eya = ya + cy * val[i];
            }
            else
            {
                exb = xb + cx * val[i];
                eyb = yb + cy * val[i];
            }

            lines.push_back({xa, xb, ya, yb, exa, exb, eya, eyb, angle});

            xa = exa;
            xb = exb;
            ya = eya;
            yb = eyb;
        }
        else
        {
            int cx = getX(angle);
            int cy = getY(angle);

            if (angle % 90 == 0)
            {
                xa += cx * val[i];
                ya += cy * val[i];
            }
            else
            {
                xb += cx * val[i];
                yb += cy * val[i];
            }
        }
    }

    normalize(lines);
}

bool cmp(vector<int> a, vector<int> b)
{
    bool good = true;
    for (int i = 0; i < 8; i++)
        if (a[i] != b[i])
        {
            good = false;
        }

    return good;
}

void solve()
{
    int n;
    cin >> n;
    vector<vector<int> > a;
    vector<int> type(n);
    vector<int> val(n);
    for (int i = 0; i < n; i++)
    {
        string s;
        cin >> s;
        if (s == "rotate")
            type[i] = 0;
        else if (s == "draw")
            type[i] = 1;
        else
            type[i] = 2;
        cin >> val[i];
    }

    vector<vector<int> > trueLines;
    getLines(0, type, val, trueLines);

    sort(trueLines.begin(), trueLines.end());

    for (int angle = 45; angle <= 360; angle += 45)
    {
        vector<vector<int> > curLines;
        getLines(angle, type, val, curLines);

        sort(curLines.begin(), curLines.end());

        int oxa, oxb, oya, oyb;
        oxa = oxb = oya = oyb = 0;

        oxa = curLines[0][0] - trueLines[0][0];
        oxb = curLines[0][1] - trueLines[0][1];
        oya = curLines[0][2] - trueLines[0][2];
        oyb = curLines[0][3] - trueLines[0][3];

        for (auto &u : curLines)
        {
            u[0] -= oxa;
            u[1] -= oxb;
            u[2] -= oya;
            u[3] -= oyb;
            u[4] -= oxa;
            u[5] -= oxb;
            u[6] -= oya;
            u[7] -= oyb;
        }

        bool good = true;
        for (int i = 0; i < curLines.size(); i++)
        {
            if (cmp(curLines[i], trueLines[i]))
                continue;

            good = false;
            break;
        }

        if (good)
        {
            cout << angle << "\n";
            exit(0);
        }
    }
}


int32_t main()
{
    ios_base::sync_with_stdio(false);

        solve();

}
