#include<bits/stdc++.h>
using namespace std;
#ifdef LOCAL
#define debug(...) [](auto...a){ ((cout << a << ' '), ...) << endl; }(#__VA_ARGS__, ": ", __VA_ARGS__)
#define debugv(v) do { cout << #v << ": "; for (auto x : v) cout << x << ' '; cout << endl; } while(0)
#else
#define debug(...)
#define debugv(v)
#endif // LOCAL
#define int long long
#define app push_back
#define all(x) x.begin(), x.end()


int32_t main() {
    cin.tie(0); ios_base::sync_with_stdio(0);

    int n;
    cin >> n;

    int k = 0;

    vector <string> type(n), res(n);
    for (int i = 0; i < n; ++i) {
        cin >> type[i] >> res[i];
        k += res[i] == "true";
    }

    int m; cin >> m;
    vector <pair <int, int> > edges;
    vector <vector <int>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        edges.push_back({u,v});
        g[u].app(v);
    }

    auto topsort = [&] (vector <int> active) {
        vector <int> used(n), top;
        function <void(int)> dfs = [&] (int u) {
            used[u] = 1;
            for (int v : g[u]) {
                if (!active[v]) {
                    continue;
                }
                if (!used[v]) {
                    dfs(v);
                }
            }
            top.app(u);
        };
        for (int u = 0; u < n; ++u) {
            if (!active[u]) {
                continue;
            }
            if (!used[u]) {
                dfs(u);
            }
        }
        reverse(all(top));
        return top;
    };


    if (k == 0) {
        for (int i = 0; i < n; ++i) {
            if (type[i] == "set") {
                cout << -1 << '\n';
                exit(0);
            }
        }
        vector <int> vse(n, 1);
        auto ans = topsort(vse);
        for (int e : ans) {
            cout << e + 1 << ' ';
        }
        cout << '\n';
    }
    else if (k == 1) {
        vector <int> ord(n);
        for (int i = 0; i < n; ++i) {
            if (res[i] == "true") {
                if (type[i] != "set") {
                    cout << -1 << '\n';
                    exit(0);
                }
                ord[i] = 1;
            }
            else if (type[i] == "unset") {
                ord[i] = 0;
            }
            else {
                ord[i] = 2;
            }
        }
        for (auto [u, v] : edges) {
            if (ord[u] > ord[v]) {
                cout << -1 << '\n';
                exit(0);
            }
        }
        vector <int> l(n), r(n);
        for (int i = 0; i < n; ++i) {
            if (ord[i] == 0) {
                l[i] = 1;
            }
            else if (ord[i] == 2) {
                r[i] = 1;
            }
        }
        for (int e : topsort(l)) {
            cout << e + 1 << ' ';
        }
        for (int i = 0; i < n; ++i) {
            if (res[i] == "true") {
                cout << i + 1 << ' ';
            }
        }
        for (int e : topsort(r)) {
            cout << e + 1 << ' ';
        }
        cout << '\n';
    }
    else {


        vector <int> ts;
        for (int i = 0; i < n; ++i) {
            if (res[i] == "true") {
                ts.push_back(i);
            }
        }
        if (type[ts.front()] == type[ts.back()]) {
            cout << -1 << '\n';
            exit(0);
        }
        vector <int> ord(n);
        for (int i = 0; i < n; ++i) {
            if (type[i] == "set") {
                if (res[i] == "true") {
                    ord[i] = 0;
                }
                else {
                    ord[i] = 1;
                }
            }
            else {
                if (res[i] == "true") {
                    ord[i] = 2;
                }
                else {
                    ord[i] = -1;
                }
            }
        }
        vector <int> need(n, -1);

        auto put = [&] (int i, int x) {

            if (need[i] != -1 && need[i] != x) {
                cout << -1 << '\n';
                exit(0);
            }
            need[i] = x;
        };

        for (auto [u, v] : edges) {
                debug(u,v,ord[u],ord[v]);
            if (ord[u] != -1 && ord[v] != -1) {
                if (ord[u] > ord[v]) {
                    cout << -1 << '\n';
                    exit(0);
                }
            }
            else if (ord[u] == -1 && ord[v] != -1) {
                put(u, 0);
            }
            else if (ord[u] != -1 && ord[v] == -1) {
                put(v, 1);
            }
        }
        vector <int> dp(n), used(n);
        function <void(int)> go = [&] (int u) {
            used[u] = 1;
            dp[u] = 1;
            if (need[u] == 0) {
                dp[u] = 0;
            }
            for (int v : g[u]) {
                if (ord[v] != -1) {
                    continue;
                }
                if (!used[v]) {
                    go(v);
                }
                dp[u] = min(dp[u], dp[v]);
            }
            if (need[u] == 1 && dp[u] == 0) {
                cout << -1 << '\n';
                exit(0);
            }
        };
        for (int u = 0; u < n; ++u) {
            if (ord[u] != -1) {
                continue;
            }
            if (!used[u]) {
                go(u);
            }
        }
        debug(need[4], dp[4]);
        vector <int> l(n), r(n);
        for (int i = 0; i < n; ++i) {
            if (ord[i] == -1) {
                if (dp[i]) {
                    r[i] = 1;
                }
                else {
                    l[i] = 1;
                }
            }
        }

        if (type[ts.front()] != "set") {
            swap(ts[0],ts[1]);
        }

        for (int e : topsort(l)) {
            cout << e + 1 << ' ';
        }
        cout << ts.front() + 1 << ' ';
        vector <int> mid(n);
        for (int i = 0; i < n; ++i) {
            if (ord[i] == 1) {
                mid[i] = 1;
            }
        }
        for (int e : topsort(mid)) {
            cout << e + 1 << ' ';
        }
        cout << ts.back() + 1 << ' ';
        for (int e : topsort(r)) {
            cout << e + 1 << ' ';
        }
        cout << '\n';
    }

    return 0;
}

/*
8
set true
unset true
set false
unset false
unset false
unset false
unset false
unset false
5
1 2
4 3
3 5
5 8
7 4
*/
