#include <bits/stdc++.h>

#define f first
#define s second
#define int li

using namespace std;
using li = long long;
using ld = long double;
using pii = pair<int, int>;

const li INF64 = 1e18 + 13;
const int INF = 1e9 + 13;
const int N = 1e6 + 5;

struct Number {
    li i;
    li r2;

    Number() : i(0), r2(0){};
    Number(li i) : i(i), r2(0){};
    Number(li i, li r2) : i(i), r2(r2){};
};

Number operator+ (Number a, Number b) {
    return Number(a.i + b.i, a.r2 + b.r2);
}

Number operator- (Number a, Number b) {
    return Number(a.i - b.i, a.r2 - b.r2);
}

Number operator- (Number a) {
    return Number(-a.i, -a.r2);
}

Number operator* (Number a, li x) {
    return Number(a.i * x, a.r2 * x);
}

Number get(Number a) {
    assert(a.i % 2 == 0);
    return Number(a.r2, a.i / 2);
}

bool operator< (Number a, Number b) {
    Number res = a - b;
    if(res.i < 0 && res.r2 < 0)
        return true;
    if(res.i > 0 && res.r2 > 0)
        return false;

    if(res.i > 0) {
        return __int128(res.i) * res.i - __int128(res.r2) * res.r2 * 2 < 0;
    } else {
        return __int128(res.i) * res.i - __int128(res.r2) * res.r2 * 2 > 0;
    }
}

bool operator== (Number a, Number b) {
    return a.i == b.i && a.r2 == b.r2;
}

using Point = pair<Number, Number>;

Point operator+(Point a, Point b) {
    return Point(a.f + b.f, a.s + b.s);
}

Point operator-(Point a) {
    return Point(-a.f, -a.s);
}

Point get(Point a) {
    return Point(get(a.f - a.s), get(a.f + a.s));
}


//Point sum(const Point& a, const Point& b) {
//    return Point(a.f + b.f, a.s + b.s);
//}

Point operator*(Point a, li x) {
    return Point(a.f * x, a.s * x);
}

string out(Number a) {
    string s = "";
    s += to_string(a.i);
    s += '+';
    s += to_string(a.r2);
    s += 'r';
    return s;
}

string out(Point p) {
    return "(" + out(p.f) + " " + out(p.s) + ")";
}

/*
11
d 10
r 90
m 10
r 180
d 20
r 90
m 10
r 90
m 10
r 90
d 10

15
d 10
r 45
d 10
r 45
d 10
r 45
d 10
r 45
d 10
r 45
d 10
r 45
d 10
r 45
d 10
*/

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;

    int cur = 0;
    Point p = Point(Number(), Number());

    vector<pair<pair<Point, Point>, Point>> a;
    for(int i = 0; i < n; i++) {
        string com;
        li x;
        cin >> com >> x;

        if(com[0] == 'r') {
            cur += x;
            cur %= 360;
        } else {
//            x *= 2;

            Point dir;
            if(cur == 0) {
                dir.f = 2;
                dir.s = 0;
            } else if(cur == 45) {
                dir.f = Number(0, 1);
                dir.s = Number(0, 1);
            } else if(cur == 90) {
                dir.f = Number(0, 0);
                dir.s = Number(2, 0);
            } else if(cur == 135) {
                dir.f = Number(0, -1);
                dir.s = Number(0, 1);
            }else if(cur == 180) {
                dir.f = Number(-2, 0);
                dir.s = Number(0, 0);
            }else if(cur == 225) {
                dir.f = Number(0, -1);
                dir.s = Number(0, -1);
            }else if(cur == 270) {
                dir.f = Number(0, 0);
                dir.s = Number(-2, 0);
            }else if(cur == 315) {
                dir.f = Number(0, 1);
                dir.s = Number(0, -1);
            }

            Point tmp = dir * x;
            Point q = p + tmp;
            if(com[0] == 'd') {
                if(p < q)
                    a.emplace_back(make_pair(p, dir), q);
                else
                    a.emplace_back(make_pair(q, -dir), p);
            }


            p = q;
        }
    }

    map<pair<Point, Point>, Point> mp;

    for(int i = int(a.size()) - 1; i >= 0; i--) {
        auto key = make_pair(a[i].s, a[i].f.s);
        if(mp.count(key)) {
            Point val = mp[key];
            mp.erase(key);
//            auto nkey = make_pair(a[i].f.f, a[i]f)
            mp[a[i].f] = val;
        } else {
            mp[a[i].f] = a[i].s;
        }
    }

//    a.clear();
    vector<pair<Point, Point>> b;
    for(auto p : mp) {
        b.emplace_back(p.f.f, p.s);

    }



    sort(b.begin(), b.end());
//for(auto p : b) {
//        cout << out(p.f) << ' ' << out(p.s) << endl;
//    }
    auto c = b;

    for(int i = 45; i < 360; i += 45) {
        for(int j = 0; j < c.size(); j++) {
            c[j].f = get(c[j].f);
            c[j].s = get(c[j].s);

            if(c[j].s < c[j].f) {
                swap(c[j].f, c[j].s);
            }
        }

//cout << "c : " << "  i = " << i  << endl;
//        for(auto pr : c) {
//            cout << out(pr.f) << ' ' << out(pr.s) << endl;
//        }

        sort(c.begin(), c.end());

//        cout << "c : " << "  i = " << i  << endl;
//        for(auto pr : c) {
//            cout << out(pr.f) << ' ' << out(pr.s) << endl;
//        }

        Point d = b[0].f + (-c[0].f);
//        cout << "d = " << out(d) << endl;


        bool res = true;
        for(int j = 0; j < c.size(); j++) {
            auto pr = make_pair(c[j].f + d, c[j].s + d);
            res &= (pr == b[j]);
            if(!res) {
//                cout << j << endl;
                break;
            }
        }

//        for(auto pr : c) {
//            cout << out(pr.f + d) << ' ' << out(pr.s + d) << endl;
//        }

        if(res) {
            cout << i << endl;
            return 0;
        }
//        break;
    }

    cout << 360 << endl;

//    int t;
//    cin >> t;
//
//    while(t--)
//        solve();
}

