#include <bits/stdc++.h>

#define re return
#define fi first
#define se second
#define f0r(i,n) for (int i = 0; i < (n); ++i)
#define f0rr(i,n) for (int i = (n) - 1; i >= 0; --i)
#define rep(i,s,n) for (int i = (s); i < (n); ++i)
#define V vector
#define P pair
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define sz(a) ((int)a.size())

using namespace std;

using bl = bool;
using ll = long long;
using lll = __int128;
using ld = double;
using lld = long double;
using vi = vector<int>;
using vll = vector<ll>;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using str = string;
using vii = V<pii>;
using uint = unsigned int;
using ull = unsigned long long;
using vvi = V<vi>;

template<class T> istream& operator>>(istream& in, V<T>& a) { for (T& x : a) in >> x; re in; }
template<class T> ostream& operator<<(ostream& out, const V<T>& a) { for (const T& x : a) out << x << ' '; re out; }

const ll INF = 2e18;
const int ROTATE = 0;
const int DRAW = 1;
const int MOVE = 2;

struct point {
    ll x, y, x_, y_;

    point& operator+=(const point& p) {
        x += p.x;
        y += p.y;
        x_ += p.x_;
        y_ += p.y_;
        re *this;
    }

    point& operator-=(const point& p) {
        x -= p.x;
        y -= p.y;
        x_ -= p.x_;
        y_ -= p.y_;
        re *this;
    }

    point& operator*=(int d) {
        x *= d;
        y *= d;
        x_ *= d;
        y_ *= d;
        re *this;
    }

    bl operator==(const point& p) const {
        re x == p.x && y == p.y && x_ == p.x_ && y_ == p.y_;
    }

    bl operator!=(const point& p) const {
        re x != p.x || y != p.y || x_ != p.x_ || y_ != p.y_;
    }

    bl operator<(const point& p) const {
        if (x != p.x) re x < p.x;
        if (y != p.y) re y < p.y;
        if (x_ != p.x_) re x_ < p.x_;
        re y_ < p.y_;
    }

    point operator+(const point& p) const { re point{*this} += p; }
    point operator-(const point& p) const { re point{*this} -= p; }
    point operator*(int d) const { re point{*this} *= d; }

    friend ostream& operator<<(ostream& out, const point& p) {
        re out << '(' << p.x << ", " << p.y << ", " << p.x_ << ", " << p.y_ << ')';
    }
};

const point DELTA[] = {{1, 0, 0, 0}, {0, 0, 0, 1}, {0, 1, 0, 0}, {0, 0, -1, 0},
                       {-1, 0, 0, 0}, {0, 0, 0, -1}, {0, -1, 0, 0}, {0, 0, 1, 0}};

struct segment {
    point p1, p2;

    bl operator==(const segment& s) const {
        re p1 == s.p1 && p2 == s.p2;
    }

    bl operator<(const segment& s) const {
        if (p1 != s.p1) re p1 < s.p1;
        re p2 < s.p2;
    }

    friend ostream& operator<<(ostream& out, const segment& s) {
        re out << '[' << s.p1 << "; " << s.p2 << ']';
    }
};


int n;
vii commands;

void draw(int dir, V<segment>& segments) {
    point curr{0,0,0,0};
    for (const pii& command : commands) {
        if (command.fi == ROTATE) {
            dir = (dir + command.se / 45) % 8;
        } else {
            point next = curr;
            next += DELTA[dir] * command.se;
            if (command.fi == DRAW) {
                segments.pb(segment{curr, next});
            }
            curr = next;
        }
    }
}

int compare_x(const point& a, const point& b) {
    lll left = a.x - b.x;
    lll right = b.x_ - a.x_ + b.y_ - a.y_;
    if (left < 0 && right >= 0) re -1;
    if (left >= 0 && right < 0) re 1;
    if (left == 0 && right == 0) re 0;
    bl rev = left < 0 && right < 0;
    left *= left * 2;
    right *= right;
    if (rev) swap(left, right);
    if (left == right) re 0;
    if (left < right) re -1;
    re 1;
}

int compare_y(const point& a, const point& b) {
    lll left = a.y - b.y;
    lll right = b.y_ - a.y_ - b.x_ + a.x_;
    if (left < 0 && right >= 0) re -1;
    if (left >= 0 && right < 0) re 1;
    if (left == 0 && right == 0) re 0;
    bl rev = left < 0 && right < 0;
    left *= left * 2;
    right *= right;
    if (rev) swap(left, right);
    if (left == right) re 0;
    if (left < right) re -1;
    re 1;
}

void normalize(V<segment>& segments) {
    point pivot = {INF,INF,0,0};
    for (auto& segment : segments) {
        for (auto& point : V<point>{segment.p1, segment.p2}) {
            int cmp = compare_x(point, pivot);
            if (cmp == -1 || (cmp == 0 && compare_y(point, pivot) == -1)) {
                pivot = point;
            }
        }
    }
    for (auto& segment : segments) {
        segment.p1 -= pivot;
        segment.p2 -= pivot;
        if (!(segment.p1 < segment.p2))
            swap(segment.p1, segment.p2);
    }
}

void merge_(V<segment>& segments) {
    V<V<segment>> segments_types(4);
    for (const auto& segment : segments)
        if (segment.p1.x != segment.p2.x)
            segments_types[0].pb(segment);
        else if (segment.p1.y != segment.p2.y)
            segments_types[1].pb(segment);
        else if (segment.p1.x_ != segment.p2.x_)
            segments_types[2].pb(segment);
        else
            segments_types[3].pb(segment);
    segments.clear();
    f0r(type,4) {
        map<vll, V<segment>> m;
        if (type == 0) {
            for (const auto& segment : segments_types[type])
                m[vll{segment.p1.y, segment.p1.x_, segment.p1.y_}].pb(segment);
        } else if (type == 1) {
            for (const auto& segment : segments_types[type])
                m[vll{segment.p1.x, segment.p1.x_, segment.p1.y_}].pb(segment);
        } else if (type == 2) {
            for (const auto& segment : segments_types[type])
                m[vll{segment.p1.y_, segment.p1.x, segment.p1.y}].pb(segment);
        } else {
            for (const auto& segment : segments_types[type])
                m[vll{segment.p1.x_, segment.p1.x, segment.p1.y}].pb(segment);
        }
        for (auto& p : m) {
            sort(all(p.se));
            V<segment> v;
            for (const auto& segment : p.se) {
                if (!sz(v)) v.pb(segment);
                else {
                    bool do_merge = 0;
                    if (type == 0) do_merge = v.back().p2.x == segment.p1.x;
                    else if (type == 1) do_merge = v.back().p2.y == segment.p1.y;
                    else if (type == 2) do_merge = v.back().p2.x_ == segment.p1.x_;
                    else do_merge = v.back().p2.y_ == segment.p1.y_;
                    if (do_merge) {
                        v.back().p2 = segment.p2;
                    } else {
                        v.pb(segment);
                    }
                }
            }
            segments.insert(segments.end(), all(v));
        }
    }
}

void solve() {
    cin >> n;
    commands.resize(n);
    for (pii& command : commands) {
        str s;
        cin >> s >> command.se;
        command.fi = s == "rotate" ? 0 : 1 + (s == "move");
    }
    V<V<segment>> picture(8);
    f0r(dir,8) {
        draw(dir, picture[dir]);
        normalize(picture[dir]);
        merge_(picture[dir]);
        sort(all(picture[dir]));
//        cout << picture[dir] << '\n';
        if (dir > 0 && picture[0] == picture[dir]) {
            cout << dir * 45;
            return;
        }
    }
    cout << 360;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
//        cout << '\n';
    }
}
