#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define all(a) begin(a), end(a)
#define len(a) int((a).size())
#define rep(i, n) for (int i = 0; i < (n); i++)

mt19937 rnd;

struct Data {
    int x, y;
    bool exactly_one;
};

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; i++) {
        string s, t;
        cin >> s >> t;
        if (s == "set") {
            a[i].first = 1;
        } else {
            assert(s == "unset");
            a[i].first = 0;
        }
        if (t == "true") {
            a[i].second = 1;
        } else {
            assert(t == "false");
            a[i].second = 0;
        }
    }

    vector<vector<int>> g(n);
    vector<int> indeg(n);

    int m;
    cin >> m;
    while (m--) {
        int v, u;
        cin >> v >> u;
        v--, u--;
        indeg[u]++;
        g[v].push_back(u);
    }

    queue<int> que[2][2];
    for (int i : {0, 1}) {
        que[i][0] = que[i][1] = {};
    }

    for (int i = 0; i < n; i++) {
        if (indeg[i] == 0) {
            que[a[i].first][a[i].second].push(i);
        }
    }

    vector<Data> states_ord = {
        {0, 0, false},
        {1, 1, true},
        {1, 0, false},
        {0, 1, true},
        {0, 0, false},
    };

    int state_ptr = 0;
    vector<int> ord;

    auto pop = [&](int x, int y) {
        int v = que[x][y].front();
        ord.push_back(v);
        que[x][y].pop();

        for (auto u : g[v]) {
            indeg[u]--;
            assert(indeg[u] >= 0);
            if (indeg[u] == 0) {
                que[a[u].first][a[u].second].push(u);
            }
        }
    };

    while (state_ptr < len(states_ord)) {
        auto d = states_ord[state_ptr];
        if (!que[d.x][d.y].empty()) {
            pop(d.x, d.y);
            if (d.exactly_one) {
                state_ptr++;
            }
        } else if (d.exactly_one) {
            break;
        } else {
            state_ptr++;
        }
    }

    if (len(ord) != n) {
        cout << "-1\n";
        return 0;
    }

    for (auto x : ord) {
        cout << x + 1 << ' ';
    }
    cout << '\n';

    return 0;
}
