#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define all(a) begin(a), end(a)
#define len(a) int((a).size())
#define rep(i, n) for (int i = 0; i < (n); i++)

mt19937 rnd;

struct chel {
    int w, h;
    int x, y;
    int dx, dy;

    void read() {
        cin >> w >> h >> x >> y >> dx >> dy;
    }
};

struct BIT {
    int n;
    vector<int> bit;

    BIT(int n) : n(n), bit(n + 1) {}

    void add(int pos, int d) {
        for (pos++; pos < len(bit); pos += pos & -pos) {
            bit[pos] += d;
        }
    }

    void add_on_interval(int l, int r, int d) {
        add(l, d);
        add(r, -d);
    }

    int at(int pos) {
        int res = 0;
        for (pos++; pos > 0; pos -= pos & -pos) {
            res += bit[pos];
        }
        return res;
    }
};

void solve() {
    int W, H;
    cin >> W >> H;

    chel first, second;
    first.read();
    second.read();

    auto find_preiod = [&](chel x) {
        auto init = x;
        vector<pair<int, int>> steps;
        while (true) {
            steps.emplace_back(x.x, x.y);
            if (x.x + x.w == W && x.dx == 1) {
                x.dx *= -1;
            } else if (x.x == 0 && x.dx == -1) {
                x.dx *= -1;
            }
            if (x.y + x.h == H && x.dy == 1) {
                x.dy *= -1;
            } else if (x.y == 0 && x.dy == -1) {
                x.dy *= -1;
            }
            x.x += x.dx;
            x.y += x.dy;
            if (init.x == x.x && init.y == x.y && init.dx == x.dx && init.dy == x.dy) {
                break;
            }
        }
        return steps;
    };

    auto first_per = find_preiod(first);
    auto second_per = find_preiod(second);

    if (len(first_per) < len(second_per)) {
        swap(first_per, second_per);
        swap(first, second);
    }

    int g = gcd(len(first_per), len(second_per));
    ll ans = 0;

    struct event {
        int type, x;
        int l, r, d;
        int y;
    };

    vector<event> events;
    events.reserve(2 * (len(second_per) / g) + (len(first_per) / g) + 2);
    BIT bit(W);

    for (int r = 0; r < g; r++) {
        events.clear();
        for (int i = r; i < len(second_per); i += g) {
            int x1 = second_per[i].first - first.w + 1;
            int x2 = second_per[i].first + second.w;
            int y1 = second_per[i].second - first.h + 1;
            int y2 = second_per[i].second + second.h;

            x1 = max(x1, 0);
            y1 = max(y1, 0);
            x2 = min(x2, W);
            y2 = min(y2, H);

            events.push_back({0, x1, y1, y2, 1, -1});
            events.push_back({0, x2, y1, y2, -1, -1});
        }

        for (int i = r; i < len(first_per); i += g) {
            events.push_back({1, first_per[i].first, -1, -1, -1, first_per[i].second});
        }

        sort(all(events), [&](const event &l, const event &r) {
            return make_pair(l.x, l.type) < make_pair(r.x, r.type);
        });

        for (auto &[type, x, l, r, d, y] : events) {
            if (type == 0) {
                bit.add_on_interval(l, r, d);
            } else {
                ans += bit.at(y);
            }
        }
    }

    ll length = 1ll * len(first_per) / g * len(second_per);
    ll ggg = gcd(length, ans);
    ans /= ggg;
    length /= ggg;
    cout << ans << "/" << length << '\n';
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
