#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

#define ll long long

vector<pair<bool, bool>> ops;
deque<int> sets;
deque<int> unsets;

void inline add_op(int i) {
    // set true
    if (ops[i].first && ops[i].second) sets.push_back(i);
        // set false
    else if (ops[i].first && !ops[i].second) sets.push_front(i);
        // unset true
    else if (!ops[i].first && ops[i].second) unsets.push_back(i);
        // unset false
    else unsets.push_front(i);
}

void inline solve() {
    int n;
    cin >> n;
    vector<int> in_pows(n, 0);
    vector<vector<int>> edges(n);
    ops = vector<pair<bool, bool>>(n, {false, false});
    char s[20];
    for (int i = 0; i < n; ++i) {
        cin >> s;
        ops[i].first = s[0] == 's';
        cin >> s;
        ops[i].second = s[0] == 't';
    }
    int m, u, v;
    cin >> m;
    while (m--) {
        cin >> u >> v;
        --u;
        --v;
        edges[u].push_back(v);
        ++in_pows[v];
    }
    // Решаем
    vector<int> ans;

    for (int i = 0; i < n; ++i) {
        if (in_pows[i] != 0) continue;
        add_op(i);
    }
    // Сначала unset false
    while (!unsets.empty() && !ops[unsets.front()].second) {
        int cur = unsets.front();
        unsets.pop_front();
        ans.push_back(cur);
        for (int to : edges[cur]) {
            if (--in_pows[to] == 0) {
                add_op(to);
            }
        }
    }
    // set true
    if (!sets.empty() && ops[sets.back()].second) {
        int cur = sets.back();
        sets.pop_back();
        ans.push_back(cur);
        for (int to : edges[cur]) {
            if (--in_pows[to] == 0) {
                add_op(to);
            }
        }
        // set false
        while (!sets.empty() && !ops[sets.front()].second) {
            cur = sets.front();
            sets.pop_front();
            ans.push_back(cur);
            for (int to : edges[cur]) {
                if (--in_pows[to] == 0) {
                    add_op(to);
                }
            }
        }
        // unset true
        if (!unsets.empty() && ops[unsets.back()].second) {
            cur = unsets.back();
            unsets.pop_back();
            ans.push_back(cur);
            for (int to : edges[cur]) {
                if (--in_pows[to] == 0) {
                    add_op(to);
                }
            }
            // unset false
            while (!unsets.empty() && !ops[unsets.front()].second) {
                cur = unsets.front();
                unsets.pop_front();
                ans.push_back(cur);
                for (int to : edges[cur]) {
                    if (--in_pows[to] == 0) {
                        add_op(to);
                    }
                }
            }
        }
    }

    if (sets.empty() && unsets.empty() && ans.size() == n) {
        for (int i = 0; i < n; ++i) cout << ans[i]+1 << ' ';
        cout << '\n';
    } else {
        cout << "-1\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    int tests = 1;
//    cin >> tests;
    while (tests--) {
        solve();
    }

    return 0;
}

