#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

#define ll long long

void inline solve() {
    int n, m, q;
    cin >> n >> m >> q;
    vector<pair<ll, ll>> tasks(n);
    vector<ll> episodes(m);
    vector<pair<ll, int>> times(q);
    for (int i = 0; i < n; ++i) cin >> tasks[i].second;
    for (int i = 0; i < n; ++i) {
        cin >> tasks[i].first;
    }
    for (int i = 0; i < m; ++i) cin >> episodes[i];
    for (int i = 0; i < q; ++i) {
        cin >> times[i].first;
        times[i].second = i;
    }

    sort(tasks.begin(), tasks.end());
    sort(times.begin(), times.end());

    vector<ll> ans(q);

    // Делаем непересекающимися
    for (int i = 0; i < n; ++i) tasks[i].first -= tasks[i].second;
    for (int i = n-2; i >= 0; --i) {
        if (tasks[i].first + tasks[i].second <= tasks[i+1].first) continue;
        tasks[i].first = tasks[i+1].first - tasks[i].second - 1;
    }
//    for (int i = 0; i < n; ++i) {
//        cout << tasks[i].first << ' ' << tasks[i].second << '\n';
//    }

    // Жадно смотрим серии и отвечаем на запросы
    ll t = 0;
    int curTimes = 0;
    int curTasks = 0;
    int curEpisodes = 0;
    bool watchedSerial = false;
    while (curTimes < times.size() && curTasks < tasks.size() && curEpisodes < episodes.size()) {
        while (curTimes < times.size() && t >= times[curTimes].first) {
            int delta = (t > times[curTimes].first) && watchedSerial;
            ans[times[curTimes].second] = curEpisodes - delta;
            curTimes++;
        }
        if (t + episodes[curEpisodes] <= tasks[curTasks].first) {
            t += episodes[curEpisodes];
            curEpisodes++;
            watchedSerial = true;
        } else {
            t += tasks[curTasks].second;
            curTasks++;
            watchedSerial = false;
        }
    }
    while (curTimes < times.size()) {
        while (curEpisodes < episodes.size() && t+episodes[curEpisodes] <= times[curTimes].first) {
            t += episodes[curEpisodes];
            curEpisodes++;
        }
        ans[times[curTimes].second] = curEpisodes;
        curTimes++;
    }
    for (int i = 0; i < q; ++i) cout << ans[i] << ' ';
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    int tests;
    cin >> tests;
    while (tests--) {
        solve();
    }

    return 0;
}

