#include <iostream>
#include <vector>
#include <map>
#include <math.h>
using namespace std;
map<long long, map<long long, int>> draw(vector<pair<char, int>>& seq, int alpha){
    map<long long, map<long long, int>> plane;
    int angle = 0;
    long long x = 0, y = 0;
    for(int i = 0; i < seq.size(); i++){
        switch(seq[i].first){
        case 'r':
            angle = (angle + seq[i].second)%360;
            break;
        case 'm':{
            x += seq[i].second*(long long)(cos((double)((angle+alpha)%360)*M_PI/180.0)*1e5);
            y += seq[i].second*(long long)(sin((double)((angle+alpha)%360)*M_PI/180.0)*1e5);
            break;
        }
        case 'd':{
            long long nx = x + seq[i].second*(long long)(cos((double)((angle+alpha)%360)*M_PI/180.0)*1e5);
            long long ny = y + seq[i].second*(long long)(sin((double)((angle+alpha)%360)*M_PI/180.0)*1e5);
            plane[x][y] |= (1<<(((angle+alpha)%360)/45));
            plane[nx][ny] |= (1<<(((angle+alpha+180)%360)/45));
            x = nx;
            y = ny;
            break;
        }
        }
    }
    return plane;
}
int main()
{
    size_t n;
    cin >> n;
    vector<pair<char, int>> seq(n);
    for(int i = 0; i < n; i++){
        string next;
        cin >> next >> seq[i].second;
        seq[i].first = next[0];
    }
    auto planeI = draw(seq, 0);
    auto minRI = *planeI.begin();
    auto minCI = *minRI.second.begin();
    for(int alpha = 45; alpha < 360; alpha += 45){
        auto planeP = draw(seq, alpha);
        int movex = -1, movey = -1;
        auto minRP = *planeP.begin();
        auto minCP = *minRP.second.begin();
        movey = minRP.first - minRI.first;
        movex = minCI.first - minCI.first;
        bool flag = false;
        for(auto R: planeP){
            if(planeI.find(R.first - movey) == planeI.end() || planeI[R.first-movey].size() != R.second.size()){
                flag = true;
                break;
            }
            for(auto C: R.second){
                if(planeI[R.first - movey].find(C.first - movex) == planeI[R.first - movey].end()){
                    flag = true;
                    break;
                }
                if(planeI[R.first - movey][C.first - movex] != C.second){
                    flag = true;
                    break;
                }
            }
            if(flag)
                break;
        }
        if(!flag){
            cout << alpha << endl;
            return 0;
        }
    }
    cout << 360 << endl;
}
