#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<algorithm>
#include<cstdint>
#include<bitset>
#include<string>
#include<deque>

using namespace std;

#define int long long
#define all(v) (v).begin(), (v).end()
using ull = uint64_t;

void dfs(vector<vector<int>>& Gr, vector<int>& order, int index,vector<bool>& used)
{
	used[index] = true;
	for (auto u : Gr[index])if (!used[u])
	{
		dfs(Gr, order, u, used);
	}
	order.push_back(index);
}

vector<int> top_sort(vector<vector<int>>& Gr)
{
	vector<int> order;
	int n = Gr.size();
	vector<bool> used(n, false);
	for (int i = 0; i < n; i++)
	{
		if (!used[i])
		{
			dfs(Gr, order, i, used);
		}
	}
	reverse(all(order));
	return order;
}

void dfs13(vector<vector<int>>& Gr, vector<bool>& used, int index)
{
	used[index] = true;
	for (auto u : Gr[index])if (!used[u])
	{
		dfs13(Gr, used, u);
	}
}

bool good(vector<vector<int>>& Gr, vector<int>& order)
{
	int n = order.size();
	vector<int> INDEX(n);
	for (int i = 0; i < n; i++)
	{
		INDEX[order[i]] = i;
	}
	for (int u = 0; u < n; u++)
	{
		for (auto v : Gr[u])
		{
			if (INDEX[u] > INDEX[v])return false;
		}
	}return true;
}


void solve() {
	int n;
	cin >> n;
	vector<int> f(n);
	string SS, SS2;
	set<int> we;
	int cnt = 0;
	for (int i = 0; i < n; i++)
	{
		cin >> SS >> SS2;
		if (SS == "set")
		{
			if (SS2 == "true")
			{
				f[i] = 2; we.insert(2);
			}
			else
			{
				f[i] = 1; cnt++;
			}
		}
		else
		{
			if (SS2 == "true")
			{
				f[i] = 3; we.insert(3);
			}
			else
			{
				f[i] = 0;
			}
		}
	}
	int m; cin >> m;
	int u, v;
	vector<vector<int>> Gr(n), GrT(n);
	for (int i = 0; i < m; i++)
	{
		cin >> u >> v; u--, v--;
		Gr[u].push_back(v);
		GrT[v].push_back(u);
	}
	auto order = top_sort(Gr);
	if (we.size() == 0)
	{
		if (cnt != 0)
		{
			cout << -1 << endl; return;
		}
		for (auto x : order)
		{
			cout << x + 1 << " ";
		}cout << endl; return;
	}
	if (we.size() == 1)
	{
		if (*we.begin() == 3)
		{
			cout << -1 << endl; return;
		}
		n++;
		f.push_back(3);

		Gr.push_back(vector<int>()); GrT.push_back(vector<int>());
		for (int i = 0; i < n - 1; i++)
		{
			Gr[i].push_back(n - 1);
			GrT[n - 1].push_back(i);
		}
	}
	order = top_sort(Gr);
	deque<int> ans;
	int U, V;
	for (auto x : order)
	{
		if (f[x] == 1)
		{
			ans.push_back(x);
		}
		if (f[x] == 2)
		{
			U = x;
		}
		if (f[x] == 3)
		{
			V = x;
		}
	}
	ans.push_back(V); ans.push_front(U);
	
	vector<bool> W1(n, false), W2(n, false);
	for (auto x : ans)
	{
		dfs13(GrT, W1, x);
		dfs13(Gr, W2, x);
	}
	vector<bool> C1(n, false), C2(n, false);
	vector<bool> rest(n, false);
	for (int i = 0; i < n; i++) if (f[i] == 0)
	{
		if (W1[i] && W2[i])
		{
			cout << -1 << endl; return;
		}
		if (W1[i])
		{
			C2[i] = true;
		}
		else if (W2[i])
		{
			C1[i] = true;
		}
		else
		{
			rest[i] = true;
		}
	}
	swap(C1, C2);
	for (auto x : order) if (C2[x])
	{
		ans.push_back(x);
	}
	reverse(all(order));
	for (auto x : order) if (C1[x])
	{
		ans.push_front(x);
	}
	reverse(all(order));
	vector<vector<int>> preans(ans.size()+1);
	int N = ans.size();
	vector<int> INDEX(n + 1, -1);
	for (int i = 0; i < N; i++)
	{
		preans[i+1].push_back(ans[i]);
		INDEX[ans[i]] = i + 1;
	}
	
	int last = 0;
	for (auto x:order)
	{
		if (rest[x])
		{
			preans[last].push_back(x);
			continue;
		}
		if (f[x] == 0)
		{
			last = INDEX[x];
		}
	}
	vector<int> ANS;
	for (int i = 0; i < preans.size(); i++)
	{
		for (auto x : preans[i])
		{
			ANS.push_back(x);
		}
	}
	if (good(Gr, ANS))
	{
		for (auto x : ANS)
		{
			cout << x + 1 << " ";
		}cout << endl;
	}
	else
	{
		cout << -1 << endl;
	}


	
	
	
	
}

signed main() {
	ios::sync_with_stdio(false); cin.tie(0);
	int t = 1; // cin >> t;
	for (int i = 0; i < t; i++)solve();

	return 0;
}