#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<algorithm>
#include<numeric>
#include<cstdint>
#include<bitset>
#include<string>
#include<deque>

using namespace std;

#define int long long
#define all(v) (v).begin(), (v).end()

void dfs(vector<vector<int>>& Gr, vector<pair<int,int>>& dp0, vector<pair<int, int>>& dp1,vector<bool>& used, int index)
{
	used[index] = true;
	int s = 0;
	vector<int> Q;
	for (auto u : Gr[index])if (!used[u])
	{
		dfs(Gr, dp0, dp1, used, u);
		s += max(dp0[u].first, dp1[u].first);
		Q.push_back(u);
	}
	dp0[index] = { s,-1 };
	dp1[index].first = -1;
	for (auto u : Q)
	{
		s -= max(dp0[u].first, dp1[u].first);
		if (s + dp0[u].first > dp1[index].first)
		{
			dp1[index] = { s + dp0[u].first ,u };
		}
		s += max(dp0[u].first, dp1[u].first);
	}
	dp1[index].first++;
}

void dfs13(vector<vector<int>>& Gr, vector<pair<int, int>>& E, int index,vector<bool>& used, \
	vector<pair<int, int>>& dp0, vector<pair<int, int>>& dp1, bool can)
{
	used[index] = true;
	int j = -1;
	if (dp1[index] > dp0[index] && can)
	{
		E.push_back({ index,dp1[index].second });
		j = dp1[index].second;
	}
	for (auto u : Gr[index])if (!used[u])
	{
		if (u != j)
		{
			dfs13(Gr, E, u, used, dp0, dp1, true);
		}
		else
		{
			dfs13(Gr, E, u, used, dp0, dp1, false);
		}
	}
}

void SWAP(int a, int b, vector<int>& h)
{
	int A = h[a], B = h[b];
	h[A] = b; h[B] = a; h[a] = B; h[b] = A;
}

void solve() {
	int n; cin >> n; n *= 2;
	vector<int> A(n);
	for (int i = 0; i < n; i++) {
		cin >> A[i]; A[i]--;
	}
	vector<vector<int>> Gr(n);
	int u, v;
	for (int i = 0; i < n - 1; i++)
	{
		cin >> u >> v; u--, v--;
		Gr[u].push_back(v); Gr[v].push_back(u);
	}
	vector<pair<int, int>> dp0(n, { 0,-1 }), dp1(n, { 0,-1 });
	vector<bool> used(n, false);
	dfs(Gr, dp0, dp1, used, 0);
	vector<pair<int, int>> E;
	used.clear();
	used.resize(n, false);
	dfs13(Gr, E, 0, used, dp0, dp1, true);

	vector<int> g(n, -1);
	vector<int> h(n, -1);
	vector<vector<int>> AAA(n / 2);
	for (int i = 0; i < n; i++)
	{
		AAA[A[i]].push_back(i);
	}
	for (int i = 0; i < n / 2; i++)
	{
		h[AAA[i][0]] = AAA[i][1]; h[AAA[i][1]] = AAA[i][0];
	}
	for (auto [x, y] : E)
	{
		g[x] = y; g[y] = x;
	}
	vector<pair<int, int>> ans;
	for (int i = 0; i < n; i++)if (g[i] != -1)
	{
		int u = i, v = g[i], U, V;
		vector<int> Q; Q.push_back(u); Q.push_back(v);
		while (true)
		{
			U = h[u];
			if (U == v)break;
			if (g[U] == -1)
			{
				ans.push_back({ U,u }); g[u] = g[v] = -1; break;
			}
			V = g[U];
			SWAP(u, V, h);
			g[u] = g[v] = -1;
			u = U, v = V;
		}
		
	}
	cout << ans.size() << endl;
	for (auto [x, y] : ans)
	{
		cout << x + 1 << " " << y + 1 << endl;
	}





}

signed main() {
	ios::sync_with_stdio(false); cin.tie(0);
	int t = 1; cin >> t;
	for (int i = 0; i < t; i++)solve();

	return 0;
}