#include <bits/stdc++.h>
#define int long long
#define ld long double
#define endl '\n'
const int INF = (int)1e9+1;

using namespace std;

const int kMaxn = 1e5 + 5;

vector<int> g[kMaxn];

void clear() {
    for (int i = 0; i < kMaxn; i++) {
        g[i].clear();
    }
}

vector<int> top_sort;
vector<bool> used(kMaxn);

vector<int> order(kMaxn);
void dfs(int v) {
    used[v] = true;

    for (auto u : g[v]) {
        if (!used[u]) {
            dfs(u);
        }
    }

    top_sort.push_back(v);
    order[v] = top_sort.size() - 1;
}
bool check_asyclic() {
    top_sort.clear();



    for (int i = 0; i < kMaxn; i++) {
        used[i] = false;
    }
    for (int i = 0; i < kMaxn; i++) {
        if (!used[i]) {
            dfs(i);
        }
    }
    reverse(top_sort.begin(), top_sort.end());
    for (int v = 0; v < kMaxn; v++) {
        for (auto u : g[v]) {
            if (order[u] > order[v]) {
                return false;
            }
        }
    }

    return true;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    vector<int> pos_st, pos_sf, pos_ut;
    for (int i = 0; i < n; i++) {
        string type;
        string ans;
        cin >> type >> ans;

        if (type == "set") {
            if (ans == "true") {
                pos_sf.push_back(i);
            } else {
                pos_st.push_back(i);
            }
        } else {
            if (ans == "true") {
                pos_ut.push_back(i);
            }
        }
    }
    int m;
    cin >> m;
    vector<pair<int, int>> edges;

    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        edges.emplace_back(a, b);
    }
    if (pos_st.size() + pos_sf.size() > 3) {
        cout << -1;
        return 0;
    }
    if (pos_ut.size() > 3) {
        cout << -1;
        return 0;
    }

    vector<pair<int, int>> inds;

    for (auto val : pos_st) {
        inds.emplace_back(val, 0);
    }

    for (auto val : pos_sf) {
        inds.emplace_back(val, 1);
    }
    for (auto val : pos_ut) {
        inds.emplace_back(val, 2);
    }

    vector<int> poses(inds.size());

    for (int i = 0; i < inds.size(); i++) {
        poses[i] = i;
    }

    do {
        bool last = false;
        bool good = true;
        for (int i = 0; i < inds.size(); i++) {
            auto now = inds[poses[i]];

            if (now.second == 0) {
                if (last == false) {
                    good = false;
                }

                last = true;
            }

            if (now.second == 1) {
                if (last == true) {
                    good = false;
                }

                last = true;
            }

            if (now.second == 0) {
                if (last == false) {
                    good = false;
                }
                last = false;
            }
        }

        if (!good) {
            continue;
        }
        clear();

        map<int, int> fake;
        map<int, vector<int>> real;

        int kek = n;

        for (int i = 0; i < inds.size(); i++) {
            auto now = inds[poses[i]];
            fake[now.first] = kek;
            real[kek].push_back(now.first);
            if (now.second == 2) {
                kek++;
            }
        }

        for (auto [p, q] : edges) {
            int ind_p = (fake[p] == 0 ? p : fake[p]);
            int ind_q = (fake[q] == 0 ? q : fake[q]);
            g[ind_p].push_back(ind_q);
        }

        if (inds[poses.back()].second != 2) {
            for (int i = 0; i < n; i++) {
                g[i].push_back(kek);
            }
        }

        if (check_asyclic()) {
            vector<int> ans;

            for (auto v : top_sort) {
                if (v < n && fake[v] == 0) {
                    ans.push_back(v);
                } else {
                    if (real[v].size()) {
                        for (auto lol : real[v]) {
                            ans.push_back(lol);
                        }
                    }
                }
            }

            for (auto lol : ans) {
                cout << lol + 1 << " ";
            }

            return 0;
        }



    } while (next_permutation(poses.begin(), poses.end()));

    cout << -1;
    return 0;
}
