#include <bits/stdc++.h>
#define int long long
#define ld long double
//#define p pair<int, int>
#define endl '\n'
const int INF = (int)1e9+1;

using namespace std;

int n;
vector<int> a;
vector<vector<int>> gr;
vector<array<int, 2>> dp;
vector<int> p;

void dfs_dp(int v, int parent) {
    dp[v][0] = 0;
    int min_diff = INF;
    p[v] = -1;
    for (int u : gr[v]) {
        if (u == parent) {
            continue;
        }
        dfs_dp(u, v);
        dp[v][0] += max(dp[u][0], dp[u][1]);
        int cur_diff = 0;
        if (dp[u][1] > dp[u][0]) {
            cur_diff = dp[u][1] - dp[u][0];
        }
        if (cur_diff < min_diff) {
            min_diff = cur_diff;
            p[v] = u;
        }
    }
    if (p[v] == -1) {
        dp[v][1] = 0;
    } else {
        dp[v][1] = dp[v][0] - min_diff + 1;
    }
}

vector<int> pr;

void dfs_repair(int v, int parent, bool paired) {
    int cur_b = 0;
    if (!paired && dp[v][1] > dp[v][0]) {
        cur_b = 1;
        pr[v] = p[v];
        pr[p[v]] = v;
    }
    for (int u : gr[v]) {
        if (u == parent) {
            continue;
        }
        int next_paired = (cur_b == 0 ? false : u == p[v]);
        dfs_repair(u, v, next_paired);
    }
}

vector<pair<int, int>> replicas;

void build_replicas() {
    replicas.assign(n, {-1, -1});
    for (int i = 0; i < 2 * n; ++i) {
        if (replicas[a[i]].first == -1) {
            replicas[a[i]].first = i;
        } else {
            replicas[a[i]].second = i;
        }
    }
}

void change_replica(int old_vertex, int new_vertex, int service) {
    if (replicas[service].first == old_vertex) {
        replicas[service].first = new_vertex;
    } else {
        replicas[service].second = new_vertex;
    }
}

vector<int> used;
vector<pair<int, int>> ans;

void swap_vertices(int u, int v) {
    assert(!used[u] && !used[v]);
    used[u] = used[v] = true;
    if (u == v) {
        return;
    }
    ans.emplace_back(u, v);
    change_replica(u, v, a[u]);
    change_replica(v, u, a[v]);
    swap(a[u], a[v]);
}

int second_vertex(int v) {
    if (replicas[a[v]].first == v) {
        return replicas[a[v]].second;
    } else {
        return replicas[a[v]].first;
    }
}

int fix_pair(int v, int u) {
    int w = second_vertex(u);
    swap_vertices(v, w);
    return w;
}

void fix_cycle(const vector<pair<int, int>>& verts) {
    if (verts.size() <= 1) {
        return;
    }
    auto [u, v] = verts[0];
    if (used[v]) {
        swap(u, v);
    }
    assert(!used[v]);
    while (a[v] != a[pr[v]]) {
        int w = fix_pair(v, u);
        v = w;
        u = pr[v];
        swap(v, u);
    }
}

vector<pair<int, int>> cycle;
vector<int> dfs_used;
int last_vertex;
bool check_cycle(int v) {
    int u = v;
    while (!dfs_used[u] && pr[u] != -1) {
        cycle.push_back({u, pr[u]});
        dfs_used[u] = true;
        u = pr[u];
        dfs_used[u] = true;
        u = second_vertex(u);
    }
    last_vertex = u;
    return dfs_used[u];
}

void solve() {
    cin >> n;
    a.resize(2 * n);
    for (int i = 0; i < 2 * n; ++i) {
        cin >> a[i];
        --a[i];
    }
    gr.assign(2 * n, {});
    for (int i = 0; i < 2 * n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }
    dp.resize(2 * n);
    p.resize(2 * n);
    dfs_dp(0, -1);
    pr.assign(2 * n, -1);
    dfs_repair(0, -1, false);
    used.assign(2 * n, 0);
    ans.clear();
    build_replicas();
    dfs_used.assign(2 * n, 0);
    for (int i = 0; i < 2 * n; ++i) {
        if (used[i]) {
            continue;
        }
        cycle.clear();
        if (check_cycle(i)) {
//            cout << "cycle\n";
            fix_cycle(cycle);
        } else {
//            cout << "not cycle\n";
            int v1 = last_vertex;
            reverse(cycle.begin(), cycle.end());
            for (auto& [x, y] : cycle) {
                swap(x, y);
            }
            check_cycle(second_vertex(i));
            int v2 = last_vertex;
            fix_pair(v1, v2);
            fix_cycle(cycle);
        }
    }
    cout << ans.size() << endl;
    for (auto [i, j] : ans) {
        cout << i + 1 << " " << j + 1 << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}