
#include <iostream>
#include <vector>
#include <set>
#include <numeric>
#include <algorithm>
#include <map>
#include <queue>
#include <stack>
#include <cmath>
#include <string>
#include <cstring>
#include <cassert>


#define forn(i, n) for(int i = 0; i < n; ++i)
#define all(v) v.begin(), v.end()

using ll = long long;
using ld = long double;

using namespace std;


void solve() {
	int n;
	cin >> n;
	vector<int> mask(n);
	for (int i = 0; i < n; ++i) {
		string s, t;
		cin >> s >> t;
		mask[i] = 2 * (s == "set") + (t == "true");
	}

	int first = -1, second = -1;
	for (int i = 0; i < n; ++i) {
		if (mask[i] & 1) {
			if (first == -1) first = i;
			else second = i;
		}
	}

	if (first != -1 && second != -1 && mask[first] == mask[second]) {
		cout << "-1\n";
		return;
	}

	vector<int> in(n), used(n);
	vector<vector<int>> g(n);

	int m; cin >> m;
	for (int i = 0; i < m; ++i) {
		int from, to;
		cin >> from >> to;
		--from; --to;
		g[from].push_back(to);
		in[to] += 1;
	}

	//unset false {x}
	//set true {1}
	//set false {x}
	//unset true {1}
	//unset false {x}
	//assert set true != set true
	vector<int> ans;
	for (int order : {0, 3, 2, 1, 0}) {
		queue<int> q;
		for (int i = 0; i < n; ++i) {
			if (in[i] == 0) {
				q.push(i);
			}
		}
		bool changed = false;
		while (!q.empty()) {
			int v = q.front();
			q.pop();
			if (mask[v] != order || in[v] < 0) {
				continue;
			}

			ans.push_back(v);
			changed = true;
			in[v] -= 1;

			for (const auto& u : g[v]) {
				in[u] -= 1;
				if (in[u] == 0) {
					q.push(u);
				}
			}
		}
		if (!changed && (order == 3 || order == 1)) {
			break;
		}
	}
	
	if (ans.size() == n) {
		for (auto& x : ans) {
			cout << x + 1 << ' ';
		} cout << '\n';
	}
	else {
		cout << "-1\n";
	}

	


}

int main()
{
	cin.tie(0)->sync_with_stdio(0);

	int t = 1;
	//cin >> t;
	forn(tt, t) solve();
}