#include <bits/stdc++.h>

using namespace std;

template<class A, class B> inline void umin(A& a, B b) { if (b < a) a = b; }
template<class A, class B> inline void umax(A& a, B b) { if (b > a) a = b; }

using ll = long long;
using ld = long double;
using pt = pair<ll, ll>;

void solve() {
    int n; cin >> n;
    unordered_map<string, vector<int>> p;
    vector<string> o(n);
    int ix = -1;
    for (auto& i : o) {
        i.resize(2);
        ++ix;
        cin >> i[0];
        string f; cin >> f;
        cin >> i[1];
        cin >> f;
        p[i].push_back(ix);
    }
    auto& pst = p["st"];
    auto& psf = p["sf"];
    auto& put = p["ut"];
    auto& puf = p["uf"];
    int m; cin >> m;
    auto g = vector(n, vector(0,0));
    auto rg = vector(n, vector(0,0));
    auto edge = [&](int u, int v) {
        g[u].push_back(v);
        rg[v].push_back(u);
    };
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        edge(u, v);
    }
    auto Solve = [&]() -> bool {
        if (put.size() > 1 || pst.size() > 1 || put.size() > pst.size()) {
            return false;
        }
        int st = pst.empty() ? -1 : pst[0];
        int ut = put.empty() ? -1 : put[0];
        for (auto i : psf) {
            if (st != -1) {
                edge(st, i);
            }
            if (ut != -1) {
                edge(i, ut);
            }
        }
        if (!psf.empty() && st == -1) {
            return false;
        }
        if (psf.empty() && ut != -1) {
            edge(st, ut);
        }
        if (st != -1) {
            int first = st;
            int last = ut != -1 ? ut : !psf.empty() ? psf.back() : first;
            for (int i : puf) {
                bool found = false;
                for (auto j : g[i]) {
                    if (o[j] != "uf") {
                        found = true;
                        break;
                    }
                }
                if (found) {
                    edge(i, first);
                }

                found = false;
                for (auto j : rg[i]) {
                    if (o[j] != "uf") {
                        found = true;
                        break;
                    }
                }
                if (found) {
                    edge(last, i);
                }
                if (g[i].empty() && rg[i].empty()) {
                    edge(i, first);
                }
            }
        }
        std::function<void(int)> dfs, dfs2;
        std::vector<char> mk(n, 0);
        vector<int> order;
        dfs = [&](int v) {
            if (mk[v]) return;
            mk[v] = true;
            for (int u : g[v]) {
                dfs(u);
            }
            order.push_back(v);
        };
        for (int i = 0; i < n; ++i) {
            dfs(i);
        }
        std::reverse(order.begin(), order.end());
        vector<int> pos(n);

        int first = 0;
        while (first < n && o[order[first]] == "uf") ++first;
        int last = first;
        for (int i = last + 1; i < n; ++i) {
            if (o[order[i]] != "uf") last = i;
        }
        if (first <= last) {
            vector<int> ee;
            for (int i = first; i <= last; ++i) {
                if (o[order[i]] == "uf") ee.push_back(order[i]);
            }
            for (int i = first; i <= last; ++i) {
                if (o[order[i]] != "uf") ee.push_back(order[i]);
            }
            for (int i = 0; i < ee.size(); ++i) {
                order[first + i] = ee[i];
            }
        }

        for (int i = 0; i < n; ++i) pos[order[i]] = i;
        for (int i = 0; i < n; ++i) {
            for (int j : g[i]) {
                if (pos[j] < pos[i]) return false;
            }
        }
        int reg = 0;
        for (int i : order) {
            bool set = o[i][0] == 's';
            bool tr = o[i][1] == 't';
            if (set) {
                if (!!reg != !tr) return false;
                reg = 1;
            } else {
                if (!!reg != tr) return false;
                reg = 0;
            }
        }

        for (int i : order) cout << i + 1 << ' ';
        cout << '\n';

        return true;
    };
    if (!Solve()) {
        cout << "-1\n";
    }
}

signed main() {
    int t = 1;
#ifdef KEK
    freopen("../input", "r", stdin);
    freopen("../output", "w", stdout);
    cin >> t;
#else
    cin.tie(0); cout.tie(0); std::ios::sync_with_stdio(false);
//    cin >> t;
#endif
    for (int i = 0; i < t; ++i) {
        solve();
    }
}