import java.io.*;
import java.util.*;

public class Main {
    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        InputReader in = new InputReader(System.in);
        PrintWriter out = new PrintWriter(System.out);
        solve(in, out);
        out.close();
    }

    public static class Pair {
        int a;
        int b;

        public Pair(int a, int b) {
            this.a = a;
            this.b = b;
        }

        @Override
        public boolean equals(Object o) {
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            Pair pair = (Pair) o;
            return a == pair.a && b == pair.b;
        }

        @Override
        public int hashCode() {
            return Objects.hash(a, b);
        }
    }

    public static void solve(InputReader in, PrintWriter out) {
        int n = in.nextInt();
        int[] arr = new int[n];

        for (int i = 0; i < n; i++) {
            arr[i] = in.nextInt();
        }

        long ans = 0;

        Stack<String> st = new Stack<>();

        int cur = 1;
        while (true) {
            for (int i = 0; i < n; i++) {
                if (arr[i] == cur) {
                    int index = i+1;
                    ans += n - index;
                    for (int j = i; j < n-1; j++) {
                        st.add(arr[j] + " " + arr[j+1]);
                        int temp = arr[j];
                        arr[j] = arr[j+1];
                        arr[j+1] = temp;
                    }
                    ans += n - cur;
                    for (int j = n-1; j >= cur; j--) {
                        st.add(arr[j-1] + " " + arr[j]);
                        int temp = arr[j];
                        arr[j] = arr[j-1];
                        arr[j-1] = temp;
                    }
                    break;
                }
            }
            cur++;
            if (cur == n+1) {
                break;
            }
        }
        out.println(ans);

        while (!st.isEmpty()) {
            out.println(st.pop());
        }

    }

    public static class InputReader {
        public BufferedReader reader;
        public StringTokenizer tokenizer;


        public InputReader(InputStream stream) {
            this.reader = new BufferedReader(new InputStreamReader(stream), 32768);
            this.tokenizer = null;
        }

        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw  new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }
        long nextLong() {
            return Long.parseLong(next());
        }

        double nextDouble() {
            return Double.parseDouble(next());
        }
    }
}