#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

#define ff first
#define ss second
#define all(x) x.begin(),x.end()


random_device rd;
mt19937 rnd(rd());

void solve() {
    int n;
    vector<string> t;

    cin >> n;

    t.resize(2);
    cin >> t[0] >> t[1];

    auto cell = [&t, n](int x, int y) -> int {
        if (x < 0) return 1;
        if (y < 0) return 1;
        if (x >= 2) return 1;
        if (y >= n) return 1;
        if (t[x][y] == '#') return 1;
        return 0;
    };

    auto up = [&cell](int x, int y) -> bool {
        if (cell(x, y) == 0 && cell(x - 1, y) == 0) {
            if (cell(x, y - 1) + cell(x + 1, y) + cell(x, y + 1) == 3) return true;
            return false;
        }
        return false;
    };
    auto dn = [&cell](int x, int y) -> bool {
        if (cell(x, y) == 0 && cell(x + 1, y) == 0) {
            if (cell(x, y - 1) + cell(x - 1, y) + cell(x, y + 1) == 3) return true;
            return false;
        }
        return false;
    };
    auto rt = [&cell](int x, int y) -> bool {
        if (cell(x, y) == 0 && cell(x, y + 1) == 0) {
            if (cell(x - 1, y) + cell(x, y - 1) + cell(x + 1, y) == 3) return true;
            return false;
        }
        return false;
    };
    auto lt = [&cell](int x, int y) -> bool {
        if (cell(x, y) == 0 && cell(x, y - 1) == 0) {
            if (cell(x - 1, y) + cell(x, y + 1) + cell(x + 1, y) == 3) return true;
            return false;
        }
        return false;
    };

    auto check = [&lt, &rt, & dn, &up, &cell](vector<string> t) -> int {
        int n = t[0].size();

        vector<tuple<int, int, int>> q;
        for (int i = 0; i < n; i++) {
            if (up(1, i)) {
                q.push_back({0, 1, i});
            }
            if (dn(0, i)) {
                q.push_back({1, 0, i});
            }
            if (rt(0, i)) {
                q.push_back({2, 0, i});
            }
            if (rt(1, i)) {
                q.push_back({2, 1, i});
            }
            if (lt(0, i)) {
                q.push_back({3, 0, i});
            }
            if (lt(1, i)) {
                q.push_back({3, 1, i});
            }
        }

        shuffle(all(q), rnd);

        while (!q.empty()) {
            auto [op, x, y] = q.back();
            q.pop_back();

            if (cell(x, y) == 1) continue;

            if (op == 0) {
                if (up(x, y)) {
                    t[x][y] = '#';
                    t[x - 1][y] = '#';
                }
            }
            if (op == 1) {
                if (dn(x, y)) {
                    t[x][y] = '#';
                    t[x + 1][y] = '#';
                }
            }
            if (op == 2) {
                if (rt(x, y)) {
                    t[x][y] = '#';
                    t[x][y + 1] = '#';
                }
            }
            if (op == 3) {
                if (lt(x, y)) {
                    t[x][y] = '#';
                    t[x][y - 1] = '#';
                }
            }

            for (int dy = -3; dy <= 3; dy++) {
                if (up(1, y + dy)) {
                    q.push_back({0, 1, y + dy});
                }
                if (dn(0, y + dy)) {
                    q.push_back({1, 0, y + dy});
                }
                if (rt(1, y + dy)) {
                    q.push_back({2, 1, y + dy});
                }
                if (rt(0, y + dy)) {
                    q.push_back({2, 0, y + dy});
                }
                if (lt(1, y + dy)) {
                    q.push_back({3, 1, y + dy});
                }
                if (lt(0, y + dy)) {
                    q.push_back({3, 0, y + dy});
                }
            }
        }

        int cnt = 0;
        for (int i = 0; i < 2; i++) {
            for (int j = 0; j < n; j++) {
                if (t[i][j] == '#') cnt++;
            }
        }

        if (cnt == 2 * n) {
            return 1;
        }
        for (int i = 0; i < 2; i++) {
            for (int j = 0; j < n; j++) {
                if (cell(i, j) == 0) {
                    if (cell(i - 1, j) + cell(i + 1, j) + cell(i, j - 1) + cell(i, j + 1) == 4) {
                        return 0;
                    }
                }
            }
        }

        return 2;
    };

    for (int h = 0; h < 50; h++) {
        auto t1 = t;
        int res = check(t1);

        if (res == 2) {
            cout << "Unique\n";
            return ;
        }
        if (res == 0) {
            cout << "None\n";
            return ;
        }
    }
    
    cout << "Multiple\n";   
}

int main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int t = 1;
    cin >> t;
    while(t--) solve();
    return 0;
}