#include <bits/stdc++.h>

using namespace std;

int n;

void add_edge(vector<pair<int, int>> &edges, int i, int j) {
	if (i != -1 && j != -1)
		edges.push_back({i, j});
}

vector<int> used;
vector<vector<int>> G;
vector<pair<string, bool>> a;


vector<int> order;

bool dfs(int v) {
	used[v] = 1;
	for (int to : G[v]) {
		if (!used[to]) {
			if (dfs(to))
				return true;
		} else if (used[to] == 1) {
			return true;
		}
	}
	order.push_back(v);
	used[v] = 2;
	return false;
}

void try_find_ans(const vector<pair<int, int>> &edges) {
	// cerr << "edges:\n";
	// for (auto [i, j] : edges)
	// 	cerr << i << " " << j << "\n";
	// cerr << "------\n";

	G.assign(n, vector<int>());
	for (auto [i, j] : edges) {
		if (a[i].first == "set" && a[j].first == "set")
			G[i].push_back(j);
	}
	used.assign(n, false);
	order.clear();
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			if (dfs(i)) {
				return;
			}
		}
	}
	vector<int> order_sets;
	reverse(order.begin(), order.end());
	for (int i : order) {
		if (a[i].first == "set")
			order_sets.push_back(i);
	}


	G.assign(n, vector<int>());
	for (auto [i, j] : edges) {
		G[i].push_back(j);
	}

	used.assign(n, false);
	order.clear();
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			if (dfs(i))
				return;
		}
	}
	reverse(order.begin(), order.end());

	vector<int> final_order;
	int was = 0;
	for (int v : order) {
		if (a[v] == pair<string, bool>{"unset", true}) {
			was++;
			for (int i : order_sets)
				final_order.push_back(i);
		}
		if (a[v].first == "unset") {
			final_order.push_back(v);
		}
	}
	if (was == 0) {
		for (int i : order_sets) {
			final_order.push_back(i);
		}
	}

	vector<int> pos(n);
	for (int i = 0; i < n; i++)
		pos[final_order[i]] = i;
	for (auto [i, j] : edges) {
		if (pos[i] > pos[j]) {
			return;
		}
	}
	for (int i : final_order)
		cout << i + 1 << " ";
	cout << "\n";
	exit(0);
}

void solve() {
	cin >> n;
	a.resize(n);
	int s1 = -1, s0 = -1, u1 = -1, u0 = -1;
	for (int i = 0; i < n; i++) {
		cin >> a[i].first;
		string t;
		cin >> t;
		a[i].second = t == "true";
		if (a[i] == pair<string, bool>{"set", true}) {
			if (s1 != -1) {
				cout << "-1\n";
				return;
			}
			s1 = i;
		}
		if (a[i] == pair<string, bool>{"set", false})
			s0 = i;
		if (a[i] == pair<string, bool>{"unset", true}) {
			if (u1 != -1) {
				cout << "-1\n";
				return;
			}
			u1 = i;
		}
		if (a[i] == pair<string, bool>{"unset", false})
			u0 = i;
	}
	// cerr << "s1: " << s1 << "\n";
	// cerr << "u1: " << u1 << "\n";

	int m;
	cin >> m;
	vector<pair<int, int>> sample_edges(m);
	for (auto &[i, j] : sample_edges) {
		cin >> i >> j;
		i--; j--;
	}
	if (s1 == -1 && s0 == -1) {
		if (u1 != -1) {
			cout << "-1\n";
			return;
		}
		try_find_ans(sample_edges);
		cout << "-1\n";
		return;
	}
	if (s1 == -1) {
		cout << "-1\n";
		return;
	}

	{
		vector<pair<int, int>> cur_edges = sample_edges;
		for (int i = 0; i < n; i++) {
			if (a[i].first == "set") {
				add_edge(cur_edges, i, u1);
			}
			if (a[i] == pair<string, bool>{"set", false})
				add_edge(cur_edges, s1, i);
		}
		try_find_ans(cur_edges);
	}
	cout << "-1\n";
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

#ifdef dimss
	freopen("test.txt", "r", stdin);
#endif

	int T = 1;
	// cin >> T;
	while (T--) {
		solve();
	}
	return 0;
}