#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <set>
#include <map>

using namespace std;

using ll = long long;

bool evaluate(const string &x) {
    ll left = 0, right = 0;
    ll *side = &left;
    bool pos = true;
    ll num = 0;
    for (auto c : x) {
        if (c == '*') {
            continue;
        }
        if ('0' <= c && c <= '9') {
            num = num * 10 + (c - '0');
        } else {
            if (pos) {
                *side += num;
            } else {
                *side -= num;
            }
            if (c == '-') {
                pos = false;
            } else if (c == '+') {
                pos = true;
            } else if (c == '=') {
                side = &right;
            } else {
                throw std::runtime_error("...");
            }
            num = 0;
        }
    }
    if (pos) {
        *side += num;
    } else {
        *side -= num;
    }
    return left == right;
}

void printString(const string &s) {
    for (auto c : s) {
        if (c != '*') {
            std::cout << c;
        }
    }
}

void test(string s, int i, int j) {
    s[j] = s[i];
    s[i] = '*';
    if (evaluate(s)) {
        printString(s);
        exit(0);
    }
}

int main() {
    string str;
    std::cin >> str;
    if (evaluate(str)) {
        std::cout << "Correct\n";
        return 0;
    }
    string coded(2 * str.size() + 1, '*');
    for (int i = 0; i < str.size(); ++i) {
        int j = i * 2 + 1;
        coded[j] = str[i];
    }
    for (int i = 0; i < coded.size(); ++i) {
        if ('0' > coded[i] || coded[i] > '9') {
            continue;
        }
        for (int j = 0; j < coded.size(); j += 2) {
            test(coded, i, j);
        }
    }
    std::cout << "Impossible\n";
}
