#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <algorithm>
#include <math.h>
#include <assert.h>
#include <numeric>
#include <cstdint>
#include <cstring>

using namespace std;

typedef long long ll;
typedef long double ld;

#define forn(i,n) for(int i = 0; i < int(n); i++)
#define fore(i,l,n) for(int i = l; i < int(n); i++)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define pb push_back
#define endl '\n'


const ll INF_64 = 1e18 + 10;

int bitcheck(ll mask, ll k) {
	return (mask >> k) & 1ll;
}


int n;

vector<int> a;
vector<vector<int>> g;
vector<vector<ll>> dp;
vector<vector<int>> p;
vector<pair<int, int>> ed;


void dfs(int v, int par = -1) {
	ll sm = 0;
	for (int u : g[v]) {
		if (u == par) continue;
		dfs(u, v);
		sm += max(dp[u][0], dp[u][1]);
	}
	dp[v][0] = sm;
	for (int u : g[v]) {
		if (u == par) continue;
		sm -= max(dp[u][0], dp[u][1]);
		if (dp[v][1] < sm + dp[u][0] + 1) {
			dp[v][1] = sm + dp[u][0] + 1;
			p[v][1] = u;
		}
		sm += max(dp[u][0], dp[u][1]);
	}
}

void restore(int v, int state, int par = -1) {
	if (p[v][state] != -1) {
		ed.push_back({ v, p[v][state] });
		restore(p[v][state], 0, v);
	}
	for (int u : g[v]) {
		if (u == par || u == p[v][state]) continue;
		if (dp[u][0] > dp[u][1]) restore(u, 0, v);
		else restore(u, 1, v);
	}
	
}


vector<pair<int, int>> ans;
vector<vector<int>> colors;
vector<int> used, sosed;

void func(int v)
{
	int u = sosed[v];
	if (u == -1 && used[v])
		return;
	
	int vcolor = a[v];
	int ucolor = a[u];
	if (ucolor == vcolor)
	{
		used[u] = used[v] = 1;
		return;
	}
	int bv = colors[vcolor][0];
	if (colors[vcolor][0] == v)
		bv = colors[vcolor][1];
	assert(!used[bv]);
	ans.pb({ bv, u });
	used[u] = used[bv] = 1;
	swap(a[u], a[bv]);
	if (colors[ucolor][0] == u)
		colors[ucolor][0] = bv;
	else
		colors[ucolor][1] = bv;
	if (colors[vcolor][0] == bv)
		colors[vcolor][0] = u;
	else
		colors[vcolor][1] = u;
	func(bv);
}


void solve()
{
	ans.clear();
	cin >> n;
	dp.assign(2 * n, vector<ll>(2, 0));
	p.assign(2 * n, vector<int>(2, -1));
	ed.clear();
	a.assign(2 * n, 0);
	forn(i, 2 * n) {
		cin >> a[i], a[i]--;
	}
	g.assign(2 * n, {});
	forn(i, 2 * n - 1) {
		int v, u;
		cin >> v >> u;
		--v, --u;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	dfs(0);
	if (dp[0][0] > dp[0][1])
		restore(0, 0);
	else restore(0, 1);
	/*cerr << "!\n";
	for (auto t : ed) {
		cout << t.first + 1 << ' ' << t.second + 1 << endl;
	}*/
	used.assign(2 * n, 0);
	sosed.assign(2 * n, -1);
	colors.assign(n, {});
	for (auto t : ed) {
		sosed[t.first] = t.second;
		sosed[t.second] = t.first;
	}

	forn(i, 2 * n)
		colors[a[i]].pb(i);

	forn(i, 2 * n)
	{
		if (sosed[i] == -1) continue;
		if (!used[i])
		{
			used[i] = 1;
			func(i);
		}
	}

	cout << ans.size() << endl;
	forn(i, ans.size())
		cout << ans[i].first + 1 << ' ' << ans[i].second + 1 << endl;
}
bool multitest = 1;


int32_t main()
{
	cin.tie(0);
	ios_base::sync_with_stdio(0);

	int tests = 1;
	if (multitest)
		cin >> tests;

	while (tests--)
		solve();
}