#include <iostream>
#include <string>
#include <optional>

using namespace std;

typedef long long ll;

optional<long long> eval(string s) {
    if (s.size() == 0) {
        return nullopt;
    }
    if (!isdigit(s[0]) || !isdigit(s.back())) {
        return nullopt;
    }
    ll res = 0;
    ll cur = 0;
    ll sign = 1;
    for (int i = 0; i < s.size(); i++) {
        if (s[i] == '+') {
            if (i > 0 && !isdigit(s[i - 1])) {
                return nullopt;
            }
            res += cur * sign;
            sign = 1;
            cur = 0;
        } else if (s[i] == '-') {
            if (i > 0 && !isdigit(s[i - 1])) {
                return nullopt;
            }
            res += cur * sign;
            sign = -1;
            cur = 0;
        } else if (!isdigit(s[i])) {
            return nullopt;
        } else {
            if (i > 0 && (s[i - 1] == '0') && (i == 1 || !isdigit(s[i - 2]))) {
                return nullopt;
            }
            cur = (cur * 10) + s[i] - '0';
        }
        if (cur >= 10000000000) {
            return nullopt;
        }
    }
    res += cur * sign;

    return res;
}

bool check(string s) {
    auto eq = s.find('=');
    string left = s.substr(0, eq);
    string right = s.substr(eq + 1, s.size() - eq - 1);
    auto res1 = eval(left);
    auto res2 = eval(right);

    if (!res1.has_value() || !res2.has_value()) {
        return 0;
    }

    return res1.value() == res2.value();
}

int main() {
#ifdef LOCAL
    freopen("in", "r", stdin);
    freopen("out", "w", stdout);
#endif
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    string s;
    cin >> s;
    if (check(s)) {
        cout << "Correct";
        return 0;
    } else {
        for (int i = 0; i < s.size(); i++) {
            if (isdigit(s[i])) {
                auto t = s;
                t.erase(i, 1);
                for (int j = 0; j <= t.size(); j++) {
                    auto x = t;
                    x.insert(x.begin() + j, s[i]);
                    if (check(x)) {
                        return cout << x, 0;
                    }
                }
            }
        }
    }
    cout << "Impossible";
    return 0;
}
