#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <utility>
#include <cassert>

using namespace std;

int solve() {
    int n;
    cin >> n;
    int n2 = n;
    n *= 2;
    vector<int> fp(n2, -1);
    vector<int> c(n);
    vector<int> m(n);
    for (int i = 0; i < n; i++) {
        cin >> c[i];
        c[i]--;
        if (fp[c[i]] == -1) {
            fp[c[i]] = i;
        } else {
            m[i] = fp[c[i]];
            m[fp[c[i]]] = i;
        }
    }
    vector<vector<int>> g(n);
    for (int i = 1; i < n; i++) {
        int u, v;
        cin >> u >> v;
        u--;v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    vector<vector<int>> dp(n, vector<int>(2));
    auto dps = [&](auto self, int u, int p)->void {
        for (int v : g[u]) {
            if (v == p) {
                continue;
            }
            self(self, v, u);
            dp[u][0] += max(dp[v][0], dp[v][1]);
        }
        for (int v : g[u]) {
            if (v == p) {
                continue;
            }
            dp[u][1] = max(dp[u][1], dp[u][0] - max(dp[v][0], dp[v][1]) + dp[v][0] + 1);
        }
    };
    dps(dps, 0, -1);
    vector<int> nei(n, -1);
    auto rps = [&](auto self, int u, int w, int p)->void {
        int b = -1;
        if (w == 1) {
            for (int v : g[u]) {
                if (v == p) {
                    continue;
                }
                if (dp[u][1] == dp[u][0] - max(dp[v][0], dp[v][1]) + dp[v][0] + 1) {
                    b = v;
                    break;
                }
            }
            cerr << u << " " << b << "\n";
            nei[u] = b;
            cerr << nei[u] << " !\n";
            nei[b] = u;
        }
        for (int v : g[u]) {
            if (v == p) {
                continue;
            }
            if (v == b) {
                self(self, v, 0, u);
            } else {
                int nw = (dp[v][0] < dp[v][1] ? 1 : 0);
                self(self, v, nw, u);
            }
        }
    };
    if (dp[0][0] < dp[0][1]) {
        rps(rps, 0, 1, -1);
    } else {
        rps(rps, 0, 0, -1);
    }
    vector<pair<int, int>> ans;
    vector<int> used(n);
    for (int i = 0; i < n; i++) {
        if (!used[i] && nei[i] == -1) {
            cerr << i << "\n";
            cerr << nei[i] << "\n";
            assert(0);
            vector<int> vx;
            int cur = i;
            while (!used[cur]) {
                used[cur] = 1;
                vx.push_back(cur);
                cur = m[i];
                vx.push_back(cur);
                used[cur] = 1;
                if (nei[cur] != -1) {
                    cur = nei[cur];
                }
            }
            for (int l = 0, r = vx.size() - 2; l < r; l++, r--) {
                ans.push_back({vx[l], vx[r]});
            }
        }
    }

    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            if (c[nei[i]] == c[i]) {
                continue;
            }
            vector<int> vx;
            int cur = i;
            while (!used[cur]) {
                used[cur] = 1;
                vx.push_back(cur);
                cur = m[i];
                vx.push_back(cur);
                used[cur] = 1;
                if (nei[cur] != -1) {
                    cur = nei[cur];
                }
            }
            for (int l = 1, r = vx.size() - 1; l < r; l++, r--) {
                ans.push_back({vx[l], vx[r]});
            }
        }
    }

    cout << ans.size() << "\n";
    for (auto [x, y] : ans) {
        cout << x + 1 << " " << y + 1 << "\n";
    }

    return 0;
}

int main() {
#ifdef LOCAL
    freopen("in", "r", stdin);
    freopen("out", "w", stdout);
#endif
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
