#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

void dfs(int v, vector<vector<int> > &g, vector<int> &color, vector<int> &in, vector<int> &out, int &T, int &has_cycle) {
    in[v] = T++;
    color[v] = 1;
    for (auto e : g[v]) {
        if (color[e] == 1) {
            has_cycle = 1;
        }
        if (color[e] == 0) {
            dfs(e, g, color, in, out, T, has_cycle);
        }
    }
    color[v] = 2;
    out[v] = T++;
}

vector<int> topsort(vector<vector<int> > &g) {
    int V = g.size();

    vector<int> in(V, -1), out(V, -1), color(V, 0);
    int T = 0, has_cycle = 0;
    for (int i = 0; i < V; i++) {
        if (color[i] == 0) {
            dfs(i, g, color, in, out, T, has_cycle);
        }
    }
    if (has_cycle) return vector<int>{};

    vector<int> order(V);
    for (int i = 0; i < V; i++) order[i] = i;

    sort(order.begin(), order.end(), [&](int i, int j) {
        return out[i] > out[j];
    });

    return order;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;
    vector<string> tp(n), rs(n);
    for (int i = 0; i < n; i++) {
        cin >> tp[i] >> rs[i];
    }

    int m;
    cin >> m;
    vector<vector<int> > g(n);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g[a].push_back(b);
    }

    int true_count = 0;
    for (int i = 0; i < n; i++) {
        if (rs[i] == "true") {
            true_count++;
        }
    }

    if (true_count == 0) {
        for (int i = 0; i < n; i++) {
            if (tp[i] == "set") {
                cout << -1 << "\n";
                return 0;
            }
        }
        vector<int> ans = topsort(g);
        if (ans.size() == 0) {
            cout << -1 << "\n";
            return 0;
        }
        for (auto e : ans) cout << e + 1 << " ";
        cout << "\n";
        return 0;
    }

    if (true_count == 1) {
        int idx = 0;
        for (int i = 0; i < n; i++) {
            if (rs[i] == "true") {
                if (tp[i] == "unset") {
                    cout << -1 << "\n";
                    return 0;
                }
                idx = i;
            }
        }
        for (int i = 0; i < n; i++) {
            if (i == idx) {
                continue;
            }
            if (tp[i] == "unset") {
                g[i].push_back(idx);
            }
            if (tp[i] == "set") {
                g[idx].push_back(i);
            }
        }
        vector<int> ans = topsort(g);
        if (ans.size() == 0) {
            cout << -1 << "\n";
            return 0;
        }
        for (auto e : ans) cout << e + 1 << " ";
        cout << "\n";
        return 0;
    }

    if (true_count == 2) {
        int idx_set_true = -1, idx_unset_true = -1;
        for (int i = 0; i < n; i++) {
            if (rs[i] == "true") {
                if (tp[i] == "set") idx_set_true = i;
                if (tp[i] == "unset") idx_unset_true = i;
            }
        }

        if (idx_set_true == -1 || idx_unset_true == -1) {
            cout << -1 << "\n";
            return 0;
        }

        vector<int> renum(n, -1);
        vector<int> unrenum;
        int w = 0;
        for (int i = 0; i < n; i++) {
            if (tp[i] == "set" || (tp[i] == "unset" && rs[i] == "true")) {
                renum[i] = w;
                unrenum.push_back(i);
                w++;
            }
        }

        vector<vector<int> > g1(w);
        for (int i = 0; i < n; i++) {
            for (auto e : g[i]) {
                if (renum[i] != -1 && renum[e] != -1) {
                    g1[renum[i]].push_back(renum[e]);
                }
            }
        }

        for (int i = 0; i < n; i++) {
            if (tp[i] == "set" && rs[i] == "false") {
                g1[renum[idx_set_true]].push_back(renum[i]);
                g1[renum[i]].push_back(renum[idx_unset_true]);
            }
        }
        g1[renum[idx_set_true]].push_back(renum[idx_unset_true]);

        vector<int> ts1 = topsort(g1);

        if (ts1.size() == 0) {
            cout << -1 << "\n";
            return 0;
        }

        vector<int> renum2(n, -1);
        vector<int> unrenum2 = {-1};
        w = 1;
        for (int i = 0; i < n; i++) {
            if (renum[i] == -1) {
                renum2[i] = w;
                unrenum2.push_back(i);
                w++;
            }
        }

        vector<vector<int> > g2(w);
        for (int i = 0; i < n; i++) {
            for (auto e : g[i]) {
                if (renum2[i] != -1 && renum2[e] != -1) {
                    g2[renum2[i]].push_back(renum2[e]);
                }
                if (renum2[i] == -1 && renum2[e] != -1) {
                    g2[0].push_back(renum2[e]);
                }
                if (renum2[i] != -1 && renum2[e] == -1) {
                    g2[renum2[i]].push_back(0);
                }
            }
        }

        vector<int> ts2 = topsort(g2);

        if (ts2.size() == 0) {
            cout << -1 << "\n";
            return 0;
        }

        for (auto e : ts2) {
            if (e == 0) {
                //cout << "[";
                for (auto e : ts1) cout << unrenum[e] + 1 << " ";
                //cout << "] ";
            } else {
                cout << unrenum2[e] + 1 << " ";
            }
        }
        cout << "\n";
    }
}
