#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

void solve() {
    int n, m, q;
    cin >> n >> m >> q;

    vector<ll> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];

    vector<ll> d(n);
    for (int i = 0; i < n; i++) cin >> d[i];

    vector<ll> l(m);
    for (int i = 0; i < m; i++) cin >> l[i];

    vector<ll> t(q);
    for (int i = 0; i < q; i++) cin >> t[i];

    vector<pair<ll, ll> > tasks(n);
    for (int i = 0; i < n; i++) {
        tasks[i] = { d[i], a[i] };
    }
    sort(tasks.begin(), tasks.end());
    for (int i = 1; i < n; i++) {
        tasks[i].second += tasks[i - 1].second;
    }

    vector<ll> allowance(n);
    for (int i = 0; i < n; i++) {
        allowance[i] = tasks[i].first - tasks[i].second;
    }
    for (int i = n - 2; i >= 0; i--) {
        allowance[i] = min(allowance[i], allowance[i + 1]);
    }

    reverse(l.begin(), l.end());
    l.push_back(0);
    reverse(l.begin(), l.end());
    for (int i = 1; i <= m; i++) {
        l[i] += l[i - 1];
    }

    for (int _ = 0; _ < q; _++) {
        ll ask = t[_];

        ll L = 0, R = m + 1;
        while (L + 1 < R) {
            ll M = (L + R) / 2;
            ll dur = l[M];

            ll start_film = ask - dur;
            if (start_film < 0) {
                R = M;
                continue;
            }

            ll le = -1, ri = n;
            while (le + 1 < ri) {
                ll mi = (le + ri) / 2;
                if (tasks[mi].second <= start_film) {
                    le = mi;
                } else {
                    ri = mi;
                }
            }

            if (le + 1 == n || allowance[le + 1] >= dur) {
                L = M;
            } else {
                R = M;
            }
        }
        cout << L << " ";
    }
    cout << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--)
    {
        solve();
    }
}
