#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int INF = 1e9;

void dfs(int v, int p, vector<vector<int> > &g, vector<vector<int> > &dp, vector<int> &restore) {
    int delta = -INF;
    int delta_source = -1;
    dp[v][0] = 0;
    for (auto u : g[v]) if (u != p) {
        dfs(u, v, g, dp, restore);
        dp[v][0] += max(dp[u][0], dp[u][1]);
        int x = dp[u][0] - max(dp[u][0], dp[u][1]);
        if (x > delta) {
            delta = x;
            delta_source = u;
        }
    }
    dp[v][1] = dp[v][0] + delta + 1;
    restore[v] = delta_source;
}

void dfs(int v, int p, int sel, vector<vector<int> > &g, vector<vector<int> > &dp, vector<int> &restore, vector<pair<int, int> > &pairing) {
    if (sel == 0) {
        for (auto u : g[v]) if (u != p) {
            dfs(u, v, dp[u][1] > dp[u][0], g, dp, restore, pairing);
        }
    } else {
        pairing.push_back({v, restore[v]});
        for (auto u : g[v]) if (u != p && u != restore[v]) {
            dfs(u, v, dp[u][1] > dp[u][0], g, dp, restore, pairing);
        }
        dfs(restore[v], v, 0, g, dp, restore, pairing);
    }
}

void solve()
{
    int n;
    cin >> n;

    vector<int> c(2 * n);
    for (int i = 0; i < 2 * n; i++) cin >> c[i], c[i]--;

    vector<vector<int> > g(2 * n);
    for (int i = 0; i < 2 * n - 1; i++) {
        int f, t;
        cin >> f >> t;
        f--, t--;

        g[f].push_back(t);
        g[t].push_back(f);
    }

    vector<vector<int> > dp(2 * n, vector<int>(2, -INF));
    vector<int> restore(2 * n, -1);
    dfs(0, 0, g, dp, restore);

    int sel = dp[0][0] > dp[0][1] ? 0 : 1;
    vector<pair<int, int> > pairing;
    dfs(0, 0, sel, g, dp, restore, pairing);

    vector<int> is_unpaired(2 * n, 1);
    for (auto e : pairing) {
        is_unpaired[e.first] = is_unpaired[e.second] = 0;
    }

    vector<int> x;
    for (int i = 0; i < 2 * n; i++) {
        if (is_unpaired[i]) x.push_back(i);
    }

    for (int i = 0; i < x.size(); i += 2) {
        pairing.push_back({x[i], x[i + 1]});
    }

    vector<int> edge_idx(2 * n);
    for (int i = 0; i < n; i++) {
        edge_idx[pairing[i].first] = i;
        edge_idx[pairing[i].second] = i;
    }

    vector<vector<int> > color_pos(n);
    for (int i = 0; i < 2 * n; i++) {
        color_pos[c[i]].push_back(i);
    }

    set<pair<int, int> > p_fix;
    for (auto e : pairing) p_fix.insert(e);

    vector<pair<int, int> > ans;
    while (p_fix.size()) {
        auto it = *p_fix.begin();
        p_fix.erase(it);

        pair<int, int> edge_to_fix = {it.first, it.second};
        //cout << it.first << " " << it.second << endl;
        int fixpoint = 0;
        while (true) {
            if (c[edge_to_fix.first] == c[edge_to_fix.second]) break;

            //cout << edge_to_fix.first << " " << edge_to_fix.second << endl;

            int want_color = fixpoint == 0 ? c[edge_to_fix.first] : c[edge_to_fix.second];
            int V = -1, U = -1;
            for (auto e : color_pos[want_color]) {
                //cout << "search for color " << want_color << " " << e << endl;
                if (edge_to_fix.first != e && edge_to_fix.second != e) {
                    V = fixpoint == 0 ? edge_to_fix.second : edge_to_fix.first;
                    U = e;
                    break;
                }
            }

            //cout << __LINE__ << " " << V << " " << U << endl;

            ans.push_back({V, U});
            swap(c[V], c[U]);
            int new_edge = edge_idx[U];
            edge_to_fix = pairing[new_edge];
            //cout << __LINE__ << " " << new_edge << " " << edge_to_fix.first << " " << edge_to_fix.second << "\n";
            fixpoint = V == edge_to_fix.first ? 0 : 1;

            //cout << __LINE__ << endl;

            int c1 = c[V];
            int c2 = c[U];
            for (auto &e : color_pos[c1]) if (e == V || e == U) e = V + U - e;
            for (auto &e : color_pos[c2]) if (e == V || e == U) e = V + U - e;

            //cout << __LINE__ << endl;
        }
    }

    cout << ans.size() << "\n";
    for (auto e : ans) cout << e.first + 1 << " " << e.second + 1 << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
