#include <bits/stdc++.h>

using namespace std;

#define SP ' '
#define LF '\n'
#define rep(i, a, b) for(ll i = (a); i < (b); i++)
#define all(x) (x).begin(), (x).end()

using ll = long long;
using ull = unsigned long long;
using ld = long double;

struct Event {
	ll t; // time
	// deadline for q=1, t_k for q=2
	ll q; // query type

	// q=1 = task
	multiset<ll, greater<ll>> tasks; // length

	// q=2 = query
	int qid; // query id
};

bool operator<(const Event& lhs, const Event& rhs) {
	if (lhs.t != rhs.t) return lhs.t > rhs.t;

	if (lhs.q != rhs.q) return lhs.q > rhs.q;

	return false;
}

void solve() {
	int n, m, q;
	cin >> n >> m >> q;

	using pii = pair<int, int>;

	vector<ll> a(n);
	rep(i, 0, n) cin >> a[i];
	vector<ll> d(n);
	rep(i, 0, n) cin >> d[i];

	vector<ll> l(m);
	rep(i, 0, m) cin >> l[i];
	rep(i, 1, m) l[i] += l[i - 1];

	// {deadline, tasks durs}
	map<ll, multiset<ll, greater<ll>>> tasks;
	rep(i, 0, n) {
		tasks[d[i]].insert(a[i]);
	}

	deque<Event> evs; // events

	for (auto& [k, v] : tasks) {
		evs.push_back(Event{
			.t = k,
			.q = 1,
			.tasks = move(v),
		});
	}
	rep(i, 0, q) {
		ll tk;
		cin >> tk;
		evs.push_back(Event{
			.t = tk,
			.q = 2,
			.qid = i,
		});
	}

	// dont forget small to large

	vector<ll> ans(q, -1);

	sort(all(evs));

	ll last_task_start = 1e16;
	ll last_task_dur = 0;
	multiset<ll, greater<ll>> pending;

	ll curr_used = accumulate(all(a), 0LL);

	while (evs.size()) {
		if (evs.front().q == 2 && (pending.empty() || last_task_start < evs.front().t)) {
			ll time_for_epi = evs.front().t;
			time_for_epi -= curr_used;
			if (last_task_start < evs.front().t) {
				time_for_epi -= evs.front().t - last_task_start;
			}
			// cout << "qid: " << evs.front().qid << LF;
			// cout << "time_for_epi: " << time_for_epi << LF;
			// cout << LF;

			ll this_ans = upper_bound(all(l), time_for_epi) - l.begin();
			ans[evs.front().qid] = this_ans;
			evs.pop_front();

			continue;
		}

		if (pending.size() > 0 && last_task_start > evs.front().t) {
			auto it = pending.begin();
			ll dur = *it;
			pending.erase(it);
			last_task_start -= dur;
			last_task_dur = dur;
			curr_used -= dur;
			// cout << "put task: " << last_task_start << SP << last_task_dur << SP << curr_used << LF;
		} else {
			multiset<ll, greater<ll>> tasks_from_other = std::move(evs.front().tasks);
			last_task_start = min(last_task_start, evs.front().t);
			// cout << "upd lts: " << last_task_start << LF;
			evs.pop_front();
			if (tasks_from_other.size() > pending.size()) {
				swap(tasks_from_other, pending);
			}
			for (auto i : tasks_from_other) {
				pending.insert(i);
			}
		}
	}

	rep(i, 0, q) {
		cout << ans[i] << SP;
	}
	cout << LF;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t;
	cin >> t;
	rep(i, 0, t) {
		solve();
	}
}
