#include <iostream>
#include <utility>
#include <vector>
#include <set>
#include <map>
using namespace std;
typedef long long ll;
#define d_c(type, name) type name; cin >> name
#define d_cl(name) d_c(ll, name)
#define d_cs(name) d_c(string, name)

struct Block {
    vector<string> data;
    explicit Block(vector<string> data) : data(std::move(data)){}
    bool match(const Block& rhs) {
        for(int i = 0; i < data.size(); i++) {
            for(int j = 0; j < data[i].size(); j++) {
                if(data[i][j] == 'X' || rhs.data[i][j] == 'X') {
                    continue;
                }
                if(data[i][j] != rhs.data[i][j]) {
                    return false;
                }
            }
        }
        return true;
    }
    Block replace(const Block& rhs) {
        Block res = *this;
        for(int i = 0; i < data.size(); i++) {
            for(int j = 0; j < data[i].size(); j++) {
                if(rhs.data[i][j] == 'X') {
                    continue;
                }
                res.data[i][j] = rhs.data[i][j];
            }
        }
        return res;
    }
};

int main() {
    vector<pair<Block, Block>> patterns {
            {Block({"#..", "X#X"}), Block({"###", "X#X"})},
            {Block({"X#X", "#.."}), Block({"X#X", "###"})},
            {Block({"..#", "X#X"}), Block({"###", "X#X"})},
            {Block({"X#X", "..#"}), Block({"X#X", "###"})},
            {Block({"X#X", "#.#"}), Block({"X#X", "#@#"})},
            {Block({"#.#", "X#X"}), Block({"#@#", "X#X"})},
            {Block({"#.#", "X.X"}), Block({"###", "X#X"})},
            {Block({"X.X", "#.#"}), Block({"X#X", "###"})},
    };
    d_cl(t);
    while(t--) {
        d_cl(n);
        vector<string> a(2);
        cin >> a[0] >> a[1];
        n+=2;
        a[0] = "#" + a[0] + "#";
        a[1] = "#" + a[1] + "#";
        auto get_block = [&](int i) {
            return Block({a[0].substr(i, 3), a[1].substr(i, 3)});
        };
        auto replace_block = [&](int i, Block rep) {
            auto orig = get_block(i).replace(rep);
            a[0].replace(i, 3, orig.data[0]);
            a[1].replace(i, 3, orig.data[1]);
        };
        bool was_changed = true;
        while(was_changed) {
            was_changed = false;
            for (int i = 0; i < n - 2; i++) {
                for (auto &[from, to]: patterns) {
                    auto block = get_block(i);
                    if (block.match(from)) {
                        replace_block(i, to);
                        was_changed = true;
                    }
                }
            }
            for (int i = n - 3; i >= 0; i--) {
                for (auto &[from, to]: patterns) {
                    auto block = get_block(i);
                    if (block.match(from)) {
                        replace_block(i, to);
                        was_changed = true;
                    }
                }
            }
        }
        auto is_none = a[0].find('@') != string::npos || a[1].find('@') != string::npos;
        auto is_mult = a[0].find('.') != string::npos || a[1].find('.') != string::npos;
        if(is_none) {
            cout << "None" << endl;
            continue;
        }
        if(is_mult) {
            cout << "Multiple" << endl;
            continue;
        }
        cout << "Unique" << endl;
    }
    return 0;
}
