#include <bits/stdc++.h>

#define int long long

using namespace std;
using ll = long long;

bool is_norm (int x, int y, int n, int m) {
    return x > -1 and x < n and y > -1 and y < m;
}

int calc_nei(int x, int y, int n, const vector<string> & a) {
    int cnt_used = 0;
    vector<int> dx = {1, -1, 0, 0};
    vector<int> dy = {0, 0, 1, -1};
    for (int k = 0; k < dx.size(); ++k) {
        int ni = x + dx[k];
        int nj = y + dy[k];
        if (is_norm(ni, nj, n, 2) and a[nj][ni] == '#') {
            ++cnt_used;
        }
    }
    return cnt_used;
}

void solve() {
    int n;
    cin >> n;
    vector<string> a(2);
    cin >> a[0];
    cin >> a[1];
    if (n == 1) {
        if ((a[0][0] == '.' and a[1][0] == '.') or (a[0][0] == '#' and a[1][0] == '#')) {
            cout << "Unique" << endl;
            return;
        }
        cout << "None" << endl;
        return;
    }
    vector<vector<bool> > used(2, vector<bool> (n));
    for (int j = 0; j < 2; ++j) {
        for (int i = 0; i < n; ++i) {
            if (a[j][i] == '#') {
                used[j][i] = true;
            }
        }
    }
    int cnt_al = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < 2; ++j) {
            if (a[j][i] == '#') {
                used[j][i] = true;
                continue;
            }
            if (used[j][i])
                continue;
            int cnt_used = calc_nei(i, j, n, a);
            if (cnt_used == 3 or (cnt_used == 2 and (i == 0 or i == n - 1))) {
                cout << "None" << endl;
                return;
            }
            if (cnt_used == 2) {
                if (a[j][i + 1] == '.') {
                    a[j][i + 1] = '#';
                    a[j][i] = '#';
                    used[j][i] = true;
                    used[j][i + 1] = true;
                }
                else if (j == 0 and a[j + 1][i] == '.') {
                    a[j + 1][i] = '#';
                    a[j][i] = '#';
                    used[j][i] = true;
                    used[j + 1][i] = true;
                }
                else if (j == 1 and a[j - 1][i] == '.') {
                    a[j - 1][i] = '#';
                    a[j][i] = '#';
                    used[j][i] = true;
                    used[j - 1][i] = true;
                }
                else {
                    cout << "None" << endl;
                    return;
                }
            }
        }
    }
    for (int j = 0; j < 2; ++j) {
        for (int i = 0; i < n; ++i) {
            if (a[j][i] == '#') {
                used[j][i] = true;
                continue;
            }
            if (used[j][i])
                continue;
            int cnt_used = calc_nei(i, j, n, a);
            if (cnt_used > 1) {
                cout << "None" << endl;
                return;
            }
        }
    }
    int cnt = 0;
    for (int j = 0; j < 2; ++j) {
        for (int i = 0; i < n; ++i) {
            if (!used[j][i])
                ++cnt;
        }
    }
    if (cnt == 0) {
        cout << "Unique" << endl;
        return;
    }
    cout << "Multiple" << endl;
}

void solve_A(){

}

int32_t main() {
    int t = 1;
    cin >> t;
    while (t-->0) {
        solve();
    }
}
/*
4
10
#.......##
##..#.##..
6
...#..
..#...
8
........
........
3
###
###
 */
