#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define int long long
using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
	template <typename K, typename V, typename Comp = less<K>>
using rbt_map = tree<K, V, Comp, rb_tree_tag, tree_order_statistics_node_update>;
	template <typename K, typename Comp = less<K>>
using rbt_set = rbt_map<K, null_type, Comp>;
	template <typename T>
void relax_min(T& a, const T& b) {
	if (b < a) a = b;
}
	template <typename T>
void relax_max(T& a, const T& b) {
	if (a < b) a = b;
}


#define all(x) (x).begin(), (x).end()
#define ft first
#define sc second

ld const PI = acos(-1);
int const mod = 998244353;
ll const INF = 1e18; 

bool comp_abs(__int128 a, __int128 b) {
	return b * b * 2 < a * a;
}

struct field_t {
	ll a, b;

	field_t(ll _a, ll _b) : a(_a), b(_b) {}

	field_t operator*(ll c) const {
		return field_t(a * c, b * c);
	}
	field_t& operator*=(ll c) & {
		a *= c;
		b *= c;
		return *this;
	}
	field_t operator-() const {
		return field_t(-a, -b);
	}
	field_t operator-(const field_t& q) const {
		return field_t(a - q.a, b - q.b);
	}
	field_t operator+(const field_t& q) const {
		return field_t(a + q.a, b + q.b);
	}
	field_t& operator+=(const field_t& q) & {
		a += q.a;
		b += q.b;
		return *this;
	}
	bool operator<(const field_t& q) const {
		ll qa = q.a - a;
		ll qb = b - q.b;
		if (!qa && !qb) return false;
		if (qa < 0 && qb >= 0) return false;
		if (qa >= 0 && qb < 0) return true;
		return comp_abs(abs(qa), abs(qb)) ^ (qa < 0); 
	}
	bool operator==(const field_t& q) const {
		return a == q.a && b == q.b;
	}
};

using point_t = pair<field_t, field_t>;
using seg_t = pair<point_t, point_t>;

field_t const inf = field_t(INF, 0);
field_t const one = field_t(2, 0);
field_t const zero = field_t(0, 0);
field_t const S2 = field_t(0, 1);

point_t mv[8] = {
	{one, zero},
	{S2, S2},
	{zero, one},
	{-S2, S2},
	{-one, zero},
	{-S2, -S2},
	{zero, -one},
	{S2, -S2}
};

int const N = 2e5 + 10;

struct op_t {
	char t;
	int d;
} ops[N];
int n;

vector<seg_t> draw_figure(int r) {
	point_t p{zero, zero};
	vector<seg_t> segs;
	point_t pivot{inf, zero};
	for (int i = 0; i < n; ++i) {
		auto& [t, d] = ops[i];
		if (t == 'r') {
			r = (r + d) % 8;
			continue;
		}
		point_t np = p;
		np.first += mv[r].first * d;
		np.second += mv[r].second * d;
		if (t == 'd') {
			segs.emplace_back(p, np);
			pivot = min(pivot, min(p, np));
		}
		p = np;
	}
	pivot.first *= -1;
	pivot.second *= -1;
	for (auto& [p, np] : segs) {
		p.first += pivot.first;
		p.second += pivot.second;
		np.first += pivot.first;
		np.second += pivot.second;
	}
	return segs;
}

using seg1_t = pair<field_t, point_t>;
vector<seg1_t> drawed[8][4];

void normalize(vector<seg1_t>& vec) {
	if (vec.empty()) return;
	for (auto& [id, sg] : vec) {
		if (sg.second < sg.first) {
			swap(sg.second, sg.first);
		}
	}
	sort(all(vec));
	vector<seg1_t> res;
	res.push_back(vec[0]);
	for (size_t i = 1; i < vec.size(); ++i) {
		auto& [id, sg] = vec[i];
		if (res.back().first == id && res.back().second.second == sg.first) {
			res.back().second.second = sg.second;
		} else {
			res.push_back(vec[i]);
		}
	}
	vec = res;
}

bool comp_on_line(vector<seg1_t>& lhs, vector<seg1_t>& rhs) {
	normalize(lhs);
	normalize(rhs);
	return lhs == rhs;
}

#define x first
#define y second
void get_drawed(const vector<seg_t>& fig, vector<seg1_t>* drawed) {
	for (auto& [p, np] : fig) {
		if (p.x == np.x) {
			drawed[0].emplace_back(p.x, point_t{p.y, np.y});
			continue;
		}
		if (p.y == np.y) {
			drawed[1].emplace_back(p.y, point_t{p.x, np.x});
			continue;
		}
		field_t dx = np.x - p.x; 
		field_t dy = np.y - p.y;
		if (dx < zero) {
			dx = -dx;
			dy = -dy;
		}
		if (dy < zero) {
			drawed[2].emplace_back(p.y + p.x, point_t{p.x, np.x});
		} else {
		    drawed[3].emplace_back(p.y - p.x, point_t{p.x, np.x});
		}
	}
}

bool comp_figure(int i, int j) {	
	for (int q = 0; q < 4; ++q) {
		if (!comp_on_line(drawed[i][q], drawed[j][q])) return false;
	}
	return true;
}

int calc() {	
	auto fig = draw_figure(0);
	get_drawed(fig, drawed[0]);
	for (int r = 1; r < 8; ++r) {
		fig = draw_figure(r);
		get_drawed(fig, drawed[r]);
		if (comp_figure(0, r)) return r;
	}
	return 8;
}

void solve() {
	cin >> n;
	string inp;
	for (int i = 0; i < n; ++i) {
		auto& [t, d] = ops[i];
		cin >> inp >> d;
		t = inp[0];
		if (t == 'r') d /= 45;
	}
	int ans = calc();
	if (4 < ans && ans < 8) ans = 8 - ans;
	cout << 45 * ans << '\n'; 	
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int t = 1;
	#ifdef LOCAL
	freopen("in", "r", stdin);
	freopen("out", "w", stdout);
	//cin >> t;
	#endif
	//cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}