#include <bits/stdc++.h>

using namespace std;

#ifdef DEBUG
#define show(x) cout << "[debug " << __LINE__ << "] " << x << endl
#else
#define show(x) ((void)0)
#endif

constexpr int N = 100000 + 100;

vector<int> g[N];
vector<int> topsort[N];
vector<int> order;
vector<int> t;
vector<int> color;

constexpr int ST = 0, SF = 1, UT = 2, UF = 3;

bool kok(int x) {
    return x == ST || x == SF || x == UT;
}

bool used[N];

void push_one(int v) {
    if (used[v]) {
        return;
    }

    used[v] = true;
    color[v] = 1;

    for (int x: g[v]) {
        if (color[x] == 0) {
            cout << -1 << "\n";
            exit(0);
        }
        push_one(x);
    }
}

void topsort_dfs(int v) {
    if (used[v]) {
        return;
    }

    used[v] = true;

    for (int x: topsort[v]) {
        topsort_dfs(x);
    }

    order.push_back(v);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    t.resize(n);
    color.assign(n, 2);

    int st_i = -1, ut_i = -1;

    for (int i = 0; i < n; ++i) {
        string a, b;
        cin >> a >> b;
        if (a == "unset" && b == "false") {
            t[i] = UF;
        } else if (a == "unset" && b == "true") {
            t[i] = UT;
        } else if (a == "set" && b == "false") {
            t[i] = SF;
        } else {
            t[i] = ST;
        }

        if (t[i] == ST) {
            st_i = i;
        }

        if (t[i] == UT) {
            ut_i = i;
        }
    }

    int m;
    cin >> m;

    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        --x, --y;

        topsort[y].push_back(x);

        if (kok(t[x]) && !kok(t[y])) {
            color[y] = 1;
        }

        if (!kok(t[x]) && kok(t[y])) {
            color[x] = 0;
        }

        if (!kok(t[x]) && !kok(t[y])) {
            g[x].push_back(y);
        }

        if (t[x] == SF && t[y] == ST) {
            cout << -1 << "\n";
            exit(0);
        }

        if (t[x] == UT && t[y] == SF) {
            cout << -1 << "\n";
            exit(0);
        }
    }

    for (int i = 0; i < n; ++i) {
        topsort_dfs(i);
    }

//    for (int x: order) {
//        show(x);
//    }

    for (int i = 0; i < n; ++i) {
        used[i] = false;
    }

    for (int i = 0; i < n; ++i) {
        if (t[i] == UF && color[i] == 1) {
            push_one(i);
        }
    }

    if (st_i == -1) {
        for (int i = 0; i < n; ++i) {
            if (t[i] != UF) {
                cout << -1 << "\n";
                exit(0);
            }
        }
    }

    int cnt_0 = 0, cnt_1 = 0;

    for (int i = 0; i < n; ++i) {
        if (t[i] != UF) {
            continue;
        }

        if (color[i] == 2) {
            color[i] = 0;
        }

        if (color[i] == 0) {
            ++cnt_0;
        } else {
            ++cnt_1;
        }
    }

    if (cnt_1 > 0 && ut_i == -1) {
        cout << -1 << "\n";
        exit(0);
    }

    for (int i: order) {
        if (t[i] == UF && color[i] == 0) {
            cout << i + 1 << " ";
        }
    }

    if (st_i != -1) {
        cout << st_i + 1 << " ";
    }

    for (int i: order) {
        if (t[i] == SF) {
            cout << i + 1 << " ";
        }
    }

    if (ut_i != -1) {
        cout << ut_i + 1 << " ";
    }

    for (int i: order) {
        if (t[i] == UF && color[i] == 1) {
            cout << i + 1 << " ";
        }
    }

    return 0;
}
