#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using pll = array<ll,2>;
using pii = array<int, 2>;
#define all(x) x.begin(), x.end()

inline bool set_true(const pii& op) { return op[0] == 1 && op[1] == 1; }
inline bool set_false(const pii& op) { return op[0] == 1 && op[1] == 0; }
inline bool unset_true(const pii& op) { return op[0] == 0 && op[1] == 1; }
inline bool unset_false(const pii& op) { return op[0] == 0 && op[1] == 0; }

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    vector<pii> op(n);
    string op1, op2;
    int set = 0, unset = 0;
    for (int i = 0; i < n; ++i) {
        cin >> op1 >> op2;
        op[i][0] = op1 == "set";
        op[i][1] = op2 == "true";
        set += op[i][0] == 1 && op[i][1] == 1;
        unset += op[i][0] == 0 && op[i][1] == 1;
    }
    // set - 1 unset - 0
    // true - 1 false - 0

    int m;
    cin >> m;
    unordered_map<int, int> next;
    unordered_set<int> deps;
    int a, b;
    for (int i = 0; i < m; ++i) {
        cin >> a >> b;
        --a;
        --b;
        deps.insert(b);
        next[a] = b;
    }

    if (set == 2 || (set == 0 && unset == 1) || (set == 0 && unset == 2)) {
        std::cout << -1 << endl;
        return 0;
    }

    vector<int> ans;
    if (set + unset == 0) {
        // cout << "case 1" << endl;
        for (auto [o, p]: op) {
            if (!(o == 0 && p == 0)) {
                std::cout << -1 << endl;
                return 0;
            }
        }

        queue<int> cur;
        for (int i = 0; i < n; ++i) {
            if (deps.count(i) == 0) {
                cur.push(i);
            }
        }

        int o;
        while (!cur.empty()) {
            o = cur.front();
            cur.pop();
            ans.push_back(o);
            if (next.count(o) != 0) {
                cur.push(next[o]);
            }
        }
    } else if (set == 1 && unset == 0) {
        // cout << "case 1" << endl;
        int o;
        auto comp = [&op](int a, int b){ return unset_false(op[b]); };
        priority_queue<int, vector<int>, decltype(comp)> cur(comp);
        for (int i = 0; i < n; ++i) {
            if (deps.count(i) == 0) {
                cur.push(i);
                // cout << i << ' ';
            }
        }
        // cout << endl;

        // cout << "stage 1" << endl;

        while (unset_false(op[cur.top()])) {
            o = cur.top();
            cur.pop();
            ans.push_back(o);
            if (next.count(o) != 0) {
                cur.push(next[o]);
            }
            // cout << cur.top() << endl;
        }

        // cout << "stage 2" << endl;

        queue<int> cur2;
        bool set_found = false;
        while (!cur.empty()) {
            o = cur.top();
            cur.pop();
            if (set_true(op[o])) {
                set_found = true;
                ans.push_back(o);
                if (next.count(o) != 0) {
                    cur2.push(next[o]);
                }
                continue;
            }
            cur2.push(o);
        }

        if (!set_found) {
            std::cout << -1 << endl;
            return 0;
        }

        // cout << "stage 2" << endl;

        while (!cur2.empty()) {
            o = cur2.front();
            if (!set_false(op[o])) {
                // for (auto i: ans) cout << i << ' ';
                // cout << endl;
                std::cout << -1 << endl;
                return 0;
            }
            cur2.pop();
            ans.push_back(o);
            if (next.count(o) != 0) {
                cur2.push(next[o]);
            }
        }
    } else if (set == 1 && unset == 1) {
        // cout << "case 1" << endl;
        int o;
        auto comp = [&op](int a, int b){ return unset_false(op[b]); };
        priority_queue<int, vector<int>, decltype(comp)> cur(comp);
        for (int i = 0; i < n; ++i) {
            if (deps.count(i) == 0) {
                cur.push(i);
                // cout << i << ' ';
            }
        }
        // cout << endl;

        // cout << "stage 1" << endl;

        while (unset_false(op[cur.top()])) {
            o = cur.top();
            cur.pop();
            ans.push_back(o);
            if (next.count(o) != 0) {
                cur.push(next[o]);
            }
        }

        // cout << "stage 2" << endl;

        auto comp2 = [&op](int a, int b){ return set_false(op[b]); };
        priority_queue<int, vector<int>, decltype(comp2)> cur2(comp2);
        bool set_found = false;
        while (!cur.empty()) {
            o = cur.top();
            cur.pop();
            if (set_true(op[o])) {
                set_found = true;
                ans.push_back(o);
                if (next.count(o) != 0) {
                    cur2.push(next[o]);
                }
                continue;
            }
            cur2.push(o);
            // cout << o << ' ';
        }
        // cout << endl;

        if (!set_found) {
            std::cout << -1 << endl;
            return 0;
        }

        // cout << "stage 3" << endl;

        while (set_false(op[cur2.top()])) {
            o = cur2.top();
            cur2.pop();
            ans.push_back(o);
            if (next.count(o) != 0) {
                cur2.push(next[o]);
            }
        }

        // cout << "stage 4" << endl;
        
        queue<int> cur3;
        bool unset_found = false;
        while (!cur2.empty()) {
            o = cur2.top();
            cur2.pop();
            if (unset_true(op[o])) {
                unset_found = true;
                ans.push_back(o);
                if (next.count(o) != 0) {
                    cur3.push(next[o]);
                }
                continue;
            }
            cur3.push(o);
            // cout << o << ' ';
        }
        // cout << endl;

        if (!unset_found) {
            std::cout << -1 << endl;
            return 0;
        }

        // cout << "stage 5" << endl;

        while (!cur3.empty()) {
            o = cur3.front();
            if (!unset_false(op[o])) {
                // for (auto i: ans) cout << i << ' ';
                // cout << endl;
                std::cout << -1 << endl;
                return 0;
            }
            cur3.pop();
            ans.push_back(o);
            if (next.count(o) != 0) {
                cur3.push(next[o]);
            }
        }
    }

    for (auto i: ans) {
        std::cout << i + 1 << ' ';
    }
    std::cout << endl;
}