#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <numeric>
#include <set>
#include <string>
#include <map>

using namespace std;

#define int long long
#define all(a) begin(a), end(a)
#define vi vector<int>
#define ve vector
#define pii pair<int,int>
#define rep(i, n) for(int i = 0; i < (n); i++)

void fast() {
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cout << fixed; cout.precision(10);
}
void dfs(int x, vector<int>& was, vector<vector<int>>& g, vector<int>& in_parsoch) {
    was[x] = 1;
    int fnd = -1;
    in_parsoch[x] = -1;
    for (auto y : g[x]) {
        if (was[y] == 1) continue;
        dfs(y, was, g, in_parsoch);
        if (fnd == -1 && in_parsoch[y] == -1) {
            fnd = y;
            in_parsoch[y] = x;
            in_parsoch[x] = y;
        }
    }
}

int get_id(map<int, int>& mp, int color, int x) {
    return mp[color] - x;
}

void solve() {
    
    int n;
    cin >> n;
    map<int, int> clr;
    vector<pair<int, int>> e(2 * n - 1);
    vector<int> a(2 * n);
    vector<vector<int>> g(2 * n);
    for (int i = 0; i < 2 * n; i++) {
        cin >> a[i];
        clr[a[i]] += i;
    }
    for (int i = 0; i < 2 * n - 1; i++) {
        int x, y;
        cin >> x >> y;
        x--; y--;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    vector<int> was(2 * n, 0);
    vector<int> in_parsoch(2 * n, -1);
    vector<int> rebro(2 * n, -1);
    dfs(0, was, g, in_parsoch);
    vector<pair<int, int>> answer;
    vector<pair<int, int>> parsoch;
    for (int i = 0; i < 2 * n; i++) {
        if (in_parsoch[i] == -1) continue;
        if (in_parsoch[i] < i) {
            parsoch.push_back({i, in_parsoch[i]});
            rebro[i] = (int)parsoch.size() - 1;
            rebro[in_parsoch[i]] = (int)parsoch.size() - 1;
        }
    }
    vector<int> was_ver(2 * n, 0);
    vector<int> was_e((int)parsoch.size(), 0);
    for (int i = 0; i < (int)parsoch.size(); i++) {
        if (was_e[i] != 0) continue;
        was_e[i] = 1;
        int x = parsoch[i].first;
        int y = parsoch[i].second;
        while (true) {
            if (x == -1 || y == -1) {
                break;
            }
            if (was_ver[y] == 1) {
                break;
            }
            if (a[x] == a[y]) {
                break;
            }
            int id = get_id(clr, a[x], x);
            if (was_ver[id]) break;
            answer.push_back({y, id});
            clr[a[y]] -= y;
            clr[a[y]] += id;
            
            clr[a[id]] += y;
            clr[a[id]] -= id;

            swap(a[y], a[id]);
            was_ver[id] = 1;
            was_ver[y] = 1;
            was_ver[x] = 1;
            int nxt_y = -1;
            if (in_parsoch[id] == -1) {
                for (auto t : g[id]) {
                    if (was_ver[t]) {
                        continue;
                    }
                    nxt_y = t;
                    break;
                }
            }
            else {
                nxt_y = in_parsoch[id];
            }
            if (nxt_y != -1) {
                if (was_e[rebro[nxt_y]] == 1) break;
                was_e[rebro[nxt_y]] = 1;
            }
            x = id;
            y = nxt_y;
        }
    }
    set<int> used;
    for (auto x : answer) {
        if (used.count(x.first) || used.count(x.second)) {
            throw -1;
        }
        used.insert(x.first);
        used.insert(x.second);
    }
    cout << (int)answer.size() << '\n';
    for (auto x : answer) {
        cout << x.first + 1 << ' ' << x.second + 1 << '\n';
    }

}

signed main() {
    fast();
#ifdef LOCAL
    freopen("input.in", "r", stdin);
    freopen("output.out", "w", stdout);
#endif
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}