#include <iostream>
#include <vector>
#include <array>
#include <string>
#include <algorithm>
#include <utility>

using namespace std;
using ll = long long;
using vi = vector<int>;
using vll = vector<ll>;

struct vtx {
    bool set, res;
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    int cnt_true_set = 0;
    int cnt_false_set = 0;
    int cnt_true_unset = 0;
    int cnt_false_unset = 0;
    vector<vtx> vs(n);
    for (int i = 0; i < n; ++i) {
        string t, s;
        cin >> t >> s;
        if (t == "set") {
            vs[i].set = true;
            if (s == "true") {
                ++cnt_true_set;
                vs[i].res = true;
            } else {
                ++cnt_false_set;
                vs[i].res = false;
            }
        } else {
            vs[i].set = false;
            if (s == "true") {
                ++cnt_true_unset;
                vs[i].res = true;
            } else {
                ++cnt_false_unset;
                vs[i].res = false;
            }
        }
    }
    int phase;
    if (cnt_true_set + cnt_true_unset > 2) {
        cout << "-1\n";
        return 0;
    }
    if (cnt_true_set + cnt_true_unset == 2) {
        if (cnt_true_set != 1) {
            cout << "-1\n";
            return 0;
        }
        phase = 3;
    } else if (cnt_true_set + cnt_true_unset == 1) {
        if (cnt_true_set != 1) {
            cout << "-1\n";
            return 0;
        }
        phase = 2;
    } else {
        if (cnt_true_set + cnt_true_unset > 0) {
            cout << "-1\n";
            return 0;
        }
        phase = 1;
    }

    int m;
    cin >> m;
    vector<vi> g(n);
    vector<vi> rev(n);
    vi outs(n, 0);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        ++outs[a];
        g[a].push_back(b);
        rev[b].push_back(a);
    }

//    vi ins(n, 0);
//    vector<char> used(n, false);
//    auto dfs = [&ins, &used, &g](const auto &dfs, int v) -> void {
//        used[v] = true;
//        for (int to : g[v]) {
//            ++ins[to];
//            if (used[to]) {
//                continue;
//            }
//            dfs(dfs, to);
//        }
//    };
//    dfs(dfs, 0);
    array<array<vi, 2>, 2> qs;
    for (int i = 0; i < n; ++i) {
        if (outs[i] == 0) {
            qs[vs[i].set][vs[i].res].push_back(i);
        }
    }
    vi ans;
    auto rmv = [&qs, &ans, &rev, &outs, &vs](bool set, bool res) -> void {
        int v = qs[set][res].back();
        ans.push_back(v);
        qs[set][res].pop_back();
        for (int from : rev[v]) {
            --outs[from];
            if (outs[from] == 0) {
                qs[vs[from].set][vs[from].res].push_back(from);
            }
        }
    };
    for (; phase > 0; --phase) {
        if (phase % 2 != 0) {
            while (!qs[false][false].empty()) {
                rmv(false, false);
            }
            if (phase == 3) {
                if (qs[false][true].empty()) {
                    cout << "-1\n";
                    return 0;
                }
                rmv(false, true);
            }
        } else {
            while (!qs[true][false].empty()) {
                rmv(true, false);
            }
            if (qs[true][true].empty()) {
                cout << "-1\n";
                return 0;
            }
            rmv(true, true);
        }
    }
    if (ans.size() != n) {
        cout << "-1\n";
        return 0;
    }
    for (int i = n - 1; i >= 0; --i) {
        cout << ans[i] + 1 << ' ';
    }
    cout << '\n';
}