#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2,avx,sse4.2,sse4.1,sse4,ssse3,sse3,sse2,sse,lzcnt,popcnt,abm,bmi,bmi2")

#include <iostream>
#include <algorithm>
#include <array>
#include <cstdint>
#include <numeric>

using namespace std;

using ll = long long;

constexpr int MAXN = 200010;
constexpr int MAXM = 200010;

array<ll, MAXN> a;
array<ll, MAXN> d;
array<ll, MAXM> l;
array<int, MAXN> ind;
array<ll, MAXN> delta_to_deadline;
array<ll, MAXN> suf_min;
array<ll, MAXM> end_time;


void solve() {
    int n, m, q;
    cin >> n >> m >> q;

    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }

    for (int i = 0; i < m; i++) {
        cin >> l[i];
    }

    iota(ind.begin(), ind.begin() + n, 0);

    sort(ind.begin(), ind.begin() + n, [](int i, int j) {
        return d[i] < d[j];
    });

    ll time = 0;
    for (int j = 0; j < n; j++) {
        int i = ind[j];

        time += a[i];
        delta_to_deadline[j] = d[i] - time;
    }

    suf_min[n - 1] = delta_to_deadline[n - 1];
    for (int i = n - 2; i >= 0; i--) {
        suf_min[i] = min(suf_min[i + 1], delta_to_deadline[i]);
    }

    int cur_i = 0;
    ll sm_delta = 0, pref_sum = 0;
    for (int k = 0; k < m; k++) {
        while (cur_i < n && suf_min[cur_i] - sm_delta < l[k]) {
            pref_sum += a[ind[cur_i]];
            cur_i++;
        }

        sm_delta += l[k];
        end_time[k] = pref_sum + sm_delta;
    }

    while (q--) {
        int t;
        cin >> t;

        size_t ans = upper_bound(end_time.begin(), end_time.begin() + m, t) - end_time.begin();
        cout << ans << " ";
    }

    cout << "\n";
}

int32_t main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);

    int t;
    cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}
