#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <vector>
#include <cmath>
#include <algorithm>

#define int long long
// #define double long double

using namespace std;

void dfs(vector<vector<int>>& g, vector<vector<int>>& dp, vector<int>& pr, int v, int p) {
	int s = 0;
	for (int to : g[v]) {
		if (to == p) {
			continue;
		}
		dfs(g, dp, pr, to, v);
		s += max(dp[to][0], dp[to][1]);
	}
	dp[v][0] = s;
	for (int to : g[v]) {
		if (to == p) {
			continue;
		}
		int y = s - max(dp[to][0], dp[to][1]) + dp[to][0] + 1;
		if (y > dp[v][1]) {
			dp[v][1] = y;
			pr[v] = to;
		}
	}
}

void dfs2(vector<vector<int>>& g, vector<vector<int>>& dp, vector<int>& pr,
	vector<pair<int, int>>& ans, int v, int p, bool ok = true) {
	if (ok && dp[v][1] > dp[v][0]) {
		ans.push_back({ v, pr[v] });
		for (int to : g[v]) {
			if (to == p) {
				continue;
			}
			dfs2(g, dp, pr, ans, to, v, to != pr[v]);
		}
	}
	else {
		for (int to : g[v]) {
			if (to == p) {
				continue;
			}
			dfs2(g, dp, pr, ans, to, v, true);
		}
	}
}

void solve() {
	int n;
	cin >> n;
	vector<int> a(2 * n);
	vector<vector<int>> b(n);
	for (int i = 0; i < 2 * n; i++) {
		cin >> a[i];
		b[a[i] - 1].push_back(i);
	}
	vector<int> other(2 * n);
	for (int i = 0; i < n; i++) {
		other[b[i][0]] = b[i][1];
		other[b[i][1]] = b[i][0];
	}
	vector<vector<int>> g(2 * n);
	for (int i = 0; i < 2 * n - 1; i++) {
		int x, y;
		cin >> x >> y;
		x--, y--;
		g[x].push_back(y);
		g[y].push_back(x);
	}

	vector<vector<int>> dp(2 * n, vector<int>(2, 0));
	vector<int> pr(2 * n, -1);
	dfs(g, dp, pr, 0, -1);

	vector<pair<int, int>> ans;
	dfs2(g, dp, pr, ans, 0, -1);

	/*cout << ans.size() << endl;
	for (auto i : ans) {
		cout << i.first + 1 << ' ' << i.second + 1 << '\n';
	}
	cout << "HUI" << endl;*/

	vector<bool> c(ans.size(), false);
	vector<int> d(2 * n, -1);
	for (int i = 0; i < ans.size(); i++) {
		d[ans[i].first] = i;
		d[ans[i].second] = i;
	}
	vector<pair<int, int>> s;
	for (int i = 0; i < ans.size(); i++) {
		if (c[i]) {
			continue;
		}

		int cur = i;
		while (true) {
			c[cur] = true;
			int x = ans[cur].first, y = ans[cur].second;
			if (a[x] == a[y]) {
				break;
			}

			int z = other[x];

			s.push_back({ y, z });
			swap(a[y], a[z]);
			other[z] = other[y];

			if (d[z] != -1) {
				cur = d[z];
				if (ans[cur].first != z) {
					swap(ans[cur].first, ans[cur].second);
				}
			}
			else {
				break;
			}
		}
	}

	cout << s.size() << '\n';
	for (auto i : s) {
		cout << i.first + 1 << ' ' << i.second + 1 << '\n';
	}
}

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#endif

	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}

	return 0;
}