#include <bits/stdc++.h>

using namespace std;
using pii = pair<int, int>;

void solve() {
    int n;
    cin >> n;

    vector<int> color(2 * n);
    for (int i = 0; i < 2 * n; i++) {
        cin >> color[i];
    }

    vector<vector<int>> g(2 * n);
    for (int i = 1; i < 2 * n; i++) {
        int v, u;
        cin >> v >> u;
        v--; u--;
        g[v].push_back(u);
        g[u].push_back(v);
    }

    vector<int> dp_unused(2 * n, 0);
    vector<pii> dp_used(2 * n, {0, 0}); // {ans, who}

    function<void(int, int)> dfs = [&] (int v, int p) -> void {
        int sum_best_child = 0;
        int sum_used_child = 0;
        for (int u : g[v]) {
            if (u == p) {
                continue;
            }
            dfs(u, v);
            sum_best_child += max(dp_used[u].first, dp_unused[u]);
            sum_used_child += dp_used[u].first;
        }
        dp_unused[v] = sum_best_child;
        // не используем - берем лучший
        // используем - надо иметь на руках лучшие неспаренные элементы
        for (int u : g[v]) {
            if (u == p) {
                continue;
            }
            int new_used = sum_used_child - dp_used[u].first + dp_unused[u] + 1;
            if (new_used > dp_used[v].first) {
                dp_used[v] = {new_used, u};
            }
        }
    };

    dfs(0, -1);

    // вершина, предок и режим (0 --- лучший, 1 --- unused)
    vector<pii> pairs;
    function<void(int, int, int)> collect = [&] (int v, int p, int mode) -> void {
        if (mode == 1 || dp_used[v].first < dp_unused[v]) {
            for (int u : g[v]) {
                if (u != p) {
                    collect(u, v, 0);
                }
            }
        } else {
            for (int u : g[v]) {
                if (u == p) {
                    continue;
                }
                if (u == dp_used[v].second) {
                    pairs.emplace_back(v, u);
                    collect(u, v, 1);
                } else {
                    collect(u, v, 0);
                }
            }
        }
    };

    collect(0, -1, 0);

    vector<bool> used(pairs.size(), false);
    vector<bool> used_in_pair(color.size(), false);
    for (int i = 0; i < pairs.size(); ++i) {
        used_in_pair[pairs[i].first] = true;
        used_in_pair[pairs[i].second] = true;
    }
    map<int, vector<int>> collookup;
    for(int i = 0; i < color.size(); ++i) {
        collookup[color[i]].push_back(i);
    }
    map<int, int> pairlookup;
    for(int i = 0; i < pairs.size(); ++i) {
        pairlookup[pairs[i].first] = i;
        pairlookup[pairs[i].second] = i;
    }

    vector<pair<int, int>> ans;

    function<int(int)> get_other = [&] (int idx) -> int{
        for(auto i : collookup[color[idx]]) {
            if (i != idx) return i;
        }
        return -1;
    };

    function<int(int)> get_pair = [&] (int idx) -> int{
        if (pairs[pairlookup[idx]].first != idx) return pairs[pairlookup[idx]].first;
        return pairs[pairlookup[idx]].second;
    };

    //for( auto i : pairs) {
    //    cout << i.first << ' ' << i.second << "\n";
    //}

    int oth, newp, newthing, cpair;
    for(int i = 0; i < pairs.size(); ++i){
        if (!used[i]) {
            used[i] = true;
            if (color[pairs[i].first] == color[pairs[i].second]) {
                continue;
            }
            oth = get_other(pairs[i].first);
            if (!used_in_pair[oth]) {
                ans.push_back({oth, pairs[i].second});
                continue;
            }
            oth = get_other(pairs[i].second);
            if (!used_in_pair[oth]) {
                ans.push_back({oth, pairs[i].first});
                continue;
            }

            ans.push_back({oth, pairs[i].first});
            //cout << pairs[i].first << ' ' << pairs[i].second << ' ' << oth << endl;
            newp = get_pair(oth);
            newthing = pairs[i].first;
            while (1) {
                cpair = pairlookup[newp];
                used[cpair] = true;
                //cout << newp << ' ' << newthing << ' ' << oth << endl;
                if (color[newp] == color[newthing]) {
                    //cout << "COLOR" << endl;
                    break;
                }
                oth = get_other(newthing);
                if (!used_in_pair[oth]) {
                    ans.push_back({oth, newp});
                    break;
                }
                ans.push_back({oth, newp});
                newthing = newp;
                newp = get_pair(oth);
            }
        }
    }
    cout << ans.size() << "\n";
    for (auto i : ans) {
        cout << i.first+1 << ' ' << i.second+1 << '\n';
    }
}

int main() {
    int tc;
    cin >> tc;
    while (tc--) {
        solve();
    }
}
