#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <array>
#include <cmath>
#include <bitset>
#include <queue>
#include <deque> 
#include <numeric>
#include <iomanip>

using namespace std;
typedef long long li;
typedef long double ld;

void dfs(int u, vector<int>& used, vector<vector<int>>& g, vector<int>& ord) {
	used[u] = 1;
	for (int v : g[u]) {
		if (used[v]) continue;
		dfs(v, used, g, ord);
	}
	ord.push_back(u);
}

void solve() {
	int n; cin >> n;
	vector<int> v(n);
	vector<vector<int>> c(4);
	int o3 = -1;
	int o1 = -1;
	for (int i = 0; i < n; ++i) {
		string s; cin >> s;
		string t; cin >> t;
		if (s == "unset") {
			if (t == "false") v[i] = 0;
			else {
				v[i] = 1;
				o1 = i;
			}
		}
		else {
			if (t == "false") v[i] = 2;
			else {
				v[i] = 3;
				o3 = i;
			}
		}
		c[v[i]].push_back(i);
	}
	// unset false = 0 
	// unset true = 1
	// set false = 2
	// set true = 3
	int m; cin >> m;
	vector<pair<int, int>> a(m);
	for (int i = 0; i < m; ++i) {
		cin >> a[i].first >> a[i].second;
		--a[i].first; --a[i].second;
	}

	for (int i = 0; i < m; ++i) {
		if (v[a[i].first] && v[a[i].second] && v[a[i].second] < v[a[i].first]) {
			cout << -1 << '\n';
			return;
		}
	}
	vector<vector<int>> c2(n), c2t(n);
	for (int i = 0; i < m; ++i) {
		if (v[a[i].first] == 2 && v[a[i].second] == 2) {
			c2[a[i].first].push_back(a[i].second);
			c2t[a[i].second].push_back(a[i].first);
		}
	}
	vector<int> o2;
	vector<int> used(n);
	for (int i = 0; i < n; ++i) {
		if (v[i] == 2 && c2t[i].empty()) {
			dfs(i, used, c2, o2);
		}
	}
	reverse(o2.begin(), o2.end());
	set<int> su, sd;
	vector<vector<int>> gu(n), gut(n);
	for (int i = 0; i < m; ++i) {
		if (v[a[i].first] == 0 && v[a[i].second]) {
			su.insert(a[i].first);
		}
		if (v[a[i].second] == 0 && v[a[i].first]) {
			sd.insert(a[i].second);
		}
		if (v[a[i].first] == 0 && v[a[i].second] == 0) {
			gu[a[i].first].push_back(a[i].second);
			gut[a[i].second].push_back(a[i].first);
		}
	}
	vector<int> oud;
	used.assign(n, 0);
	for (int i = 0; i < n; ++i) {
		if (v[i] == 0 && gut[i].empty()) {
			dfs(i, used, gu, oud);
		}
	}
	reverse(oud.begin(), oud.end());

	int id = oud.size();
	bool f = 0;
	for (int i = 0; i < int(oud.size()); ++i) {
		if (su.find(oud[i]) != su.end()) {
			if (f) {
				cout << -1 << '\n';
				return;
			}
		}
		if (sd.find(oud[i]) != sd.end()) {
			if (!f) id = i;
			f = 1;
		}
	}
	if (o1 == -1 && o3 == -1) {
		if (!c[2].empty()) {
			cout << -1 << '\n';
			return;
		}
		for (auto& x : oud) cout << x + 1 << ' ';
		return;
	}
	if (o3 == -1) {
		cout << -1 << '\n';
		return;
	}
	if (o1 == -1) {
		for (int i = 0; i < m; ++i) {
			if (v[a[i].second] < v[a[i].first]) {
				cout << -1 << '\n';
				return;
			}
		}
		for (auto& x : oud) cout << x + 1 << ' ';
		cout << o3 + 1 << ' ';
		for (auto& x : o2) cout << x + 1 << ' ';
		return;
	}

	for (int i = 0; i < id; ++i) cout << oud[i] + 1 << ' ';
	if (~o3) cout << o3 + 1 << ' ';
	for (auto& x : o2) cout << x + 1 << ' ';
	if (~o1) cout << o1 + 1 << ' ';
	for (int i = id; i < int(oud.size()); ++i) cout << oud[i] + 1 << ' ';
}

int main() {
	cin.tie(0)->sync_with_stdio(0);
	int t = 1;
	//cin >> t;
	while (t--) solve();
}