#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector <vector <int>> g;
vector <vector <int>> g_rev;
vector <bool> used;
vector <int> ans;

void dfs(int v) {
    used[v] = true;
    for (size_t i = 0; i < g[v].size(); ++i) {
        int to = g[v][i];
        if (!used[to])
            dfs(to);
    }
    ans.push_back(v);
}

void top_sort(int n) {
    ans.clear();
    for (int i = 0; i < n; i++)
        if (!used[i])
            dfs(i);
    reverse(ans.begin(), ans.end());
}

int main() {
    int n; cin >> n;
    vector <string> a(n);
    int set_true = 0;
    int unset_true = 0;

    for (int i = 0; i < n; i++) {
        string s1, s2;
        cin >> s1 >> s2;
        a[i] = s1 + " " + s2;
        if (a[i] == "set true")
            set_true = i;
        if (a[i] == "unset true")
            unset_true = i;
    }

    g.assign(n, vector <int>());
    g_rev.assign(n, vector <int>());
    used.assign(n, false);
    int m; cin >> m;
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        g_rev[v].push_back(u);
    }

    for (int i = 0; i < n; i++) {
        if (a[i] == "set false") {
            g[set_true].push_back(i);
            g[i].push_back(unset_true);
        }
        if (a[i] == "unset false") {
            bool to_set_false = false;
            bool to_set_true = false;
            bool to_unset_true = false;
            bool from_set_true = false;
            bool from_set_false = false;

            if (g[i].size() == 0 and g_rev[i].size() == 0)
                g[i].push_back(set_true);

            for (int j = 0; j < g[i].size(); j++) {
                if (a[g[i][j]] == "set false")
                    to_set_false = true;
                else if (a[g[i][j]] == "set true")
                    to_set_true = true;
                else if (a[g[i][j]] == "unset true")
                    to_unset_true = true;
            }

            for (int j = 0; j < g_rev[i].size(); j++) {
                if (a[g_rev[i][j]] == "set true")
                    from_set_true = true;
                else if (a[g_rev[i][j]] == "set false")
                    from_set_false = true;
            }

            if (to_set_false || to_unset_true) {
                g[i].push_back(set_true);
            }

            if (from_set_true || from_set_false) {
                g[unset_true].push_back(i);
            }
        }
    }
    g[set_true].push_back(unset_true);

    top_sort(n);
    vector <bool> new_used(n, false);
    bool is_correct = true;

    for (int i = 0; i < n; i++) {
        new_used[ans[i]] = true;

        for (auto u : g[ans[i]])
            if (new_used[u]){
                is_correct = false;
                break;
            }
    }

    if (!is_correct) {
        cout << -1;
        return 0;
    }

    for (int i = 0; i < n; i++)
        cout << ans[i] + 1 << " ";
}
