#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define all(a) a.begin(), a.end()

typedef long long ll;

const int N = 2e5 + 7;

int n;
vector<int> g[N];
int a[N];
vector<pair<int, int>> eds;
int m;
vector<pair<int, int>> g1[N];
int used[N];
vector<int> ord;
vector<int> kek;
vector<pair<int, int>> swaps;
vector<int> where[N];
int cnt[N];

int dfs(int v, int p = -1) {
    int ret = 1;
    for (int u : g[v]) {
        if (u == p) continue;
        int w = dfs(u, v);
        if (w == 1 && ret == 1) {
            eds.push_back({v, u});
            ret = 0;
        }
    }
    return ret;
}

void zhfs(int v) {
    used[v] = 1;
    ord.pb(v);
    for (auto [u, id] : g1[v]) {
        if (!used[u]) {
            kek.pb(id);
            zhfs(u);
        }
    }
}

void do_swap(int u, int v) {
    if (u == v) return;
    ++cnt[u];
    ++cnt[v];
    assert(cnt[u] <= 1);
    assert(cnt[v] <= 1);
    swap(a[u], a[v]);
    swaps.push_back({u, v});
}

void solve_path() {
    vector<pair<int, int>> lol;
    for (int i : kek) {
        lol.push_back(eds[i]);
    }
    int sz = (int)lol.size();
//    cout << "path" << endl;
//    for (auto p : lol) {
//        cout << p.first + 1 << " " << p.second + 1 << endl;
//    }
//    cout << endl;
    for (int i = 0; i < sz; ++i) {
        if (a[lol[i].first] != ord[i]) {
            swap(lol[i].first, lol[i].second);
        }
    }
    int rofl = -1;
    for (int u : where[ord[0]]) {
        if (u != lol[0].first) {
            rofl = u;
        }
    }
    do_swap(rofl, lol.back().second);
    for (int i = 0; i < sz - i - 1; ++i) {
        do_swap(lol[i].first, lol[sz - i - 1].first);
    }
    for (int i = 0; i < sz - i - 2; ++i) {
        do_swap(lol[i].second, lol[sz - i - 2].second);
    }
}

void solve_cycle() {
    int sz = ord.size();
    vector<pair<int, int>> lol;
    for (int i : kek) {
        lol.push_back(eds[i]);
    }
    for (int i = 0; i < sz; ++i) {
        if (a[lol[i].first] != ord[i]) {
            swap(lol[i].first, lol[i].second);
        }
    }
//    cout << "cycle" << endl;
//    for (auto p : lol) {
//        cout << p.first + 1 << " " << p.second + 1 << endl;
//    }
//    cout << endl;
    for (int i = 0; i < sz - i - 2; ++i) {
        do_swap(lol[i].first, lol[sz - i - 2].first);
    }
    for (int i = 0; i < sz - i - 1; ++i) {
        do_swap(lol[i].second, lol[sz - i - 1].second);
    }
}

int main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    int T;
    cin >> T;
    while (T--) {
        cin >> n;
        for (int i = 0; i < 2 * n; ++i) {
            g[i].clear();
            g1[i].clear();
            where[i].clear();
            used[i] = 0;
            cnt[i] = 0;
        }
        eds.clear();
        swaps.clear();
        for (int i = 0; i < 2 * n; ++i) {
            cin >> a[i];
            --a[i];
            where[a[i]].pb(i);
        }
        for (int i = 0; i < 2 * n - 1; ++i) {
            int u, v;
            cin >> u >> v;
            --u, --v;
            g[u].pb(v);
            g[v].pb(u);
        }
        dfs(0);
        m = eds.size();
        for (int i = 0; i < m; ++i) {
            auto [u, v] = eds[i];
            if (a[u] == a[v]) continue;
            g1[a[u]].pb({a[v], i});
            g1[a[v]].pb({a[u], i});
        }
        for (int i = 0; i < n; ++i) {
            if (g1[i].size() == 1 && !used[i]) {
                ord.clear();
                kek.clear();
                zhfs(i);
                solve_path();
            }
        }
        for (int i = 0; i < n; ++i) {
            if (g1[i].size() == 2 && !used[i]) {
                ord.clear();
                kek.clear();
                used[i] = 1;
                ord.pb(i);
                kek.pb(g1[i][0].second);
                zhfs(g1[i][0].first);
                kek.pb(g1[i][1].second);
                solve_cycle();
            }
        }
        cout << swaps.size() << "\n";
        for (auto p: swaps) {
            cout << p.first + 1 << " " << p.second + 1 << "\n";
        }
    }
    return 0;
}
