#include <bits/stdc++.h>

#define ld long double
#define endl '\n'

using namespace std;

constexpr int N = 2'000'05, inf = 0x3f3f3f3f;
int used[N], from[N], unused[N], colors[N];
vector<int> g[N];

void dfs(int u, int p) {
    used[u] = -inf, from[u] = -1, unused[u] = 0;

    for (int v : g[u]) {
        if(v == p) continue;
        dfs(v, u);

        used[u] += max(used[v], unused[v]);
        if(used[u] < unused[u] + unused[v] + 1) {
            used[u] = unused[u] + unused[v] + 1;
            from[u] = v;
        }
        unused[u] += max(used[v], unused[v]);
    }
}

// DO NOT FORGET TO CLEAR
int matching[N];
vector<pair<int, int>> matched;

void rebuild(int u, int p, int is_blocked) {
    if(used[u] > unused[u] && is_blocked == false) {
        // means u is blocked by itself
        int to = from[u];
        for(int v : g[u]) {
            if(v == p || v == to) continue;
            rebuild(v, u, false);
        }
        rebuild(to, u, true);
        matching[u] = to;
        matching[to] = u;
        matched.emplace_back(u, to);
    } else {
        for (int v : g[u]) {
            if(v == p) continue;
            rebuild(v, u, false);
        }
    }
}

vector<int> cpos[N];
int& get_sec(int color, int u) {
    auto& cur = cpos[color];
    if (cur[0] == u) return cur[1];
    else return cur[0];
}
int deg[N];

vector<pair<int, int>> ans;

void calc(int v) {
    while (v==-1) {}
    int color = colors[v];
    int nv = cpos[color][0];
    int nu = cpos[color][1];
    if (nv != v){
        swap(nu,nv);
    }
    if (nv != v){
        return;
    }
    assert(nv == v);
    int mat = matching[v];
    if (mat == -1){
        return;
    }
    //assert(mat != v);
    if (colors[mat] == colors[v]){
        return;
    }
    matching[mat] = matching[nu];
    ans.emplace_back(nu,mat);
    if (matching[mat]!=-1) {
        matching[matching[mat]] = mat;
    } else {
        return;
    }
    calc(mat);
}

void solve() {
    ans.clear();

    int cnt; cin >> cnt; int n = 2 * cnt;
    for(int i = 0; i < n; i++){
        g[i].clear();
        cpos[i].clear();
    }

    for(int i = 0; i < n; i++) {
        int c; cin >> c; c--;
        colors[i] = c;
        cpos[c].push_back(i);
    }

    for (int i = 1; i < n; i++) {
        int u, v; cin >> u >> v; u--, v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    int root = 0;
    dfs(root, -1);

    memset(matching, -1, sizeof(int) * n);
    matched.clear();
    rebuild(root, -1, false);

    memset(deg, 0, sizeof(int) * n);

    for(auto& [u, v] : matched) {
        // cout << u + 1 << ' ' << v + 1 << endl;
        deg[colors[u]]++, deg[colors[v]]++;
    }

    for (int color = 0; color < cnt; ++color) {
        vector<int> us;
        if (deg[color]){
            int v = cpos[color][0];
            int u = cpos[color][1];
            //assert(matching[v] == -1 || matching[u] == -1);
            if (matching[v] == -1){
                swap(v,u);
            }
            int init = v;
            int init1 = u;
            int len = 1;
            int key = -1, key_color = -1;
            vector<int> vv;
            us = {color};
            while (true) {
                int nxt = matching[v];
                int next_color = colors[nxt];
                int nv = cpos[next_color][0];
                if (nv == nxt){
                    nv = cpos[next_color][1];
                }
                us.emplace_back(next_color);
                vv.emplace_back(nxt);
                if (nv == init || matching[nv] == -1 || v == init1){
                    break;
                }
                v = nv;
                len++;
            }
            int mid = (len-1)>>1;
            key = vv[mid];
            calc(key);
            for (int c : us){
                deg[c] = 0;
            }
        }
    }

    //cout << "ANS::: " << endl;
    cout << ans.size() << endl;
    for(auto& [u, v] : ans) {
        cout << u + 1 << " " << v + 1 << endl;
    }
}

signed  main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    int q; cin >> q; while(q--)
        solve();
}

