#include <algorithm>
#include <iostream>
#include <map>
#include <numeric>
#include <vector>

using namespace std;

#define ALL(c) c.begin(), c.end()

const int N = 1e5 + 7;

int n, m;
string op[N][2];
vector<int> g[N];
map<pair<int, int>, int> go;
vector<int> uo1, so, uo2;
bool used[N];

bool check(vector<int> order) {
  if (order.size() != n) {
    return false;
  }
  int reg = 0;
  vector<int> ind(n);
  int cnt = 0;
  for (int i : order) {
    ind[i] = cnt;
    ++cnt;
    if (op[i][0] == "set") {
      if ((reg == 0) ^ (op[i][1] == "true")) {
        return false;
      }
      reg = 1;
    } else {
      if ((reg == 1) ^ (op[i][1] == "true")) {
        return false;
      }
      reg = 0;
    }
  }
  for (int v = 0; v < n; ++v) {
    for (int u : g[v]) {
      if (ind[v] > ind[u]) {
        return false;
      }
    }
  }
  return true;
}

void dfs(int v) {
  if (op[v][0] == "unset") {
    uo2.push_back(v);
  }
  used[v] = true;
  for (int u : g[v]) {
    if (!used[u]) {
      dfs(u);
    }
  }
}

signed main() {
  cin >> n;
  for (int i = 0; i < n; ++i) {
    cin >> op[i][0] >> op[i][1];
  }
  cin >> m;
  for (int i = 0; i < m; ++i) {
    int v, u;
    cin >> v >> u;
    --v, --u;
    g[v].push_back(u);
    go[{v, u}] = +1;
    go[{u, v}] = -1;
  }
  for (int i = 0; i < n; ++i) {
    if (op[i][0] == "set") {
      so.push_back(i);
      if (!used[i]) {
        dfs(i);
      }
    } else if (op[i][1] == "true") {
      if (!used[i]) {
        dfs(i);
      }
    }
  }
  for (int i = 0; i < n; ++i) {
    if (!used[i]) {
      uo1.push_back(i);
    }
  }
  auto cmp = [&](int i, int j) {
    if (op[i][1] != op[j][1]) {
      return op[i][1] == "true";
    } else {
      return go[{i, j}] == +1;
    }
  };
  sort(ALL(so), cmp);
  sort(ALL(uo1), cmp);
  sort(ALL(uo2), cmp);
  vector<int> order;
  for (int v : uo1) {
    order.push_back(v);
  }
  for (int v : so) {
    order.push_back(v);
  }
  for (int v : uo2) {
    order.push_back(v);
  }
  if (!check(order)) {
    cout << "-1\n";
  } else {
    for (int v : order) {
      cout << v + 1 << ' ';
    }
    cout << '\n';
  }
  return 0;
}