#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>

using namespace std;

#define ALL(c) c.begin(), c.end()

#define int long long

const int N = 2e5 + 7;
const int INF = 1e18;

int n, m, q;
int a[N];
int d[N];
int s[N];
int pa[N], ps[N];
pair<int, int> seg[N];

void solve() {
  cin >> n >> m >> q;
  for (int i = 0; i < n; ++i) {
    cin >> a[i];
  }
  for (int i = 0; i < n; ++i) {
    cin >> d[i];
  }
  for (int i = 0; i < m; ++i) {
    cin >> s[i];
  }
  for (int i = 0; i < m; ++i) {
    ps[i + 1] = ps[i] + s[i];
  }
  vector<int> ind(n);
  iota(ALL(ind), 0);
  sort(ALL(ind), [&](int i, int j) { return d[i] < d[j]; });
  for (int i = 0; i < n; ++i) {
    pa[i + 1] = pa[i] + a[ind[i]];
  }
  seg[n] = {pa[n], INF};
  for (int i = n - 1; i >= 0; --i) {
    seg[i] = {pa[i], min(seg[i + 1].second, d[ind[i]]) - a[ind[i]]};
  }
  for (int tq = 0; tq < q; ++tq) {
    int t;
    cin >> t;
    int left = -1, right = n;
    while (right - left > 1) {
      int mid = left + right >> 1;
      (seg[mid].second >= t ? right : left) = mid;
    }
    int st = min(seg[right].second, t) - seg[right].first;
    if (left != -1) {
      st = max(st, min(seg[left].second, t) - seg[left].first);
    }
    left = 0, right = m + 1;
    while (right - left > 1) {
      int mid = left + right >> 1;
      (ps[mid] <= st ? left : right) = mid;
    }
    cout << left << ' ';
  }
  cout << '\n';
}

signed main() {
  int t;
  cin >> t;
  while (t--) {
    solve();
  }
  return 0;
}