#include <algorithm>
#include <iostream>
#include <map>
#include <numeric>
#include <set>
#include <vector>

using namespace std;

#define ALL(c) c.begin(), c.end()

const int N = 1e5 + 7;

struct Item {
  int v, u, i, j;
};

int n;
int a[2 * N];
int ind[N][2];
vector<int> g[2 * N];
vector<pair<int, int>> p;
vector<Item> ng[N];
bool used[N];

bool dfs(int v, int last) {
  bool flag = false;
  for (int u : g[v]) {
    if (u != last) {
      if (!dfs(u, v) && !flag) {
        flag = true;
        p.push_back({v, u});
      }
    }
  }
  return flag;
}

vector<int> cur;
set<int> scur;

void dfs2(int v) {
  used[v] = true;
  for (auto e : ng[v]) {
    if (!scur.count(e.i)) {
      cur.push_back(e.i);
      cur.push_back(e.j);
      scur.insert(e.i);
      scur.insert(e.j);
      dfs2(e.u);
    }
  }
}

void add(int x) {
  if (scur.count(ind[0][x])) {
    cur.push_back(ind[1][x]);
  } else {
    cur.push_back(ind[0][x]);
  }
}

void solve() {
  cin >> n;
  fill(ind[0], ind[0] + n, -1);
  for (int i = 0; i < 2 * n; ++i) {
    cin >> a[i];
    --a[i];
    if (ind[0][a[i]] == -1) {
      ind[0][a[i]] = i;
    } else {
      ind[1][a[i]] = i;
    }
  }
  for (int i = 0; i < 2 * n - 1; ++i) {
    int v, u;
    cin >> v >> u;
    --v, --u;
    g[v].push_back(u);
    g[u].push_back(v);
  }
  dfs(0, 0);
  for (auto elem : p) {
    int i = elem.first;
    int j = elem.second;
    int v = a[i];
    int u = a[j];
    ng[v].push_back({v, u, i, j});
    ng[u].push_back({u, v, j, i});
  }
  vector<pair<int, int>> ans;
  for (int x = 0; x < n; ++x) {
    if (!used[x]) {
      used[x] = true;
      if (ng[x].empty() || ng[x][0].u == x) {
        continue;
      }
      cur.clear();
      scur.clear();
      dfs2(x);
      if (a[cur[0]] != a[cur.back()]) {
        int y = cur.back();
        add(cur[0]);
        add(y);
      }
      for (int i = 1; i < cur.size() - i; ++i) {
        ans.push_back({cur[i], cur[cur.size() - i]});
      }
    }
  }
  cout << ans.size() << '\n';
  for (auto elem : ans) {
    cout << elem.first + 1 << ' ' << elem.second + 1 << '\n';
  }
}

void clear_all() {
  for (int i = 0; i < 2 * n; ++i) {
    g[i].clear();
  }
  p.clear();
  for (int i = 0; i < n; ++i) {
    ng[i].clear();
    used[i] = false;
  }
}

signed main() {
  int t;
  cin >> t;
  while (t--) {
    solve();
    clear_all();
  }
  return 0;
}