#include <bits/stdc++.h>
using namespace std;


using ll = long long;
using ld = long double;
using vi = vector<int>;
using vl = vector<ll>;
using vvi = vector<vi>;

void color(int v, vvi &g, vi &was, vi &a) {
    was[v] = 1;
    if (a[v] == 1)
        a[v] = 5;

    for (auto to : g[v]) {
        if (!was[to])
            color(to, g, was, a);
    }
}

void topsort(int v, vvi &g, vi &was, vi &a, vvi &ans) {
    was[v] = 1;
    for (auto to : g[v]) {
        if (!was[to])
            topsort(to, g, was, a, ans);
    }

    ans[a[v]].push_back(v);
}

void solve()
{
    int n; cin >> n;
    vi a(n);

    int cnt_set = 0, cnt_unset = 0;
    for (int i = 0; i < n; i++) {
        string t, res;
        cin >> t >> res;
        if (t == "set") {
            if (res == "true") {
                cnt_set++;
                a[i] = 2;
            }
            else {
                a[i] = 3;
            }
        }
        else {
            if (res == "true") {
                cnt_unset++;
                a[i] = 4;
            }
            else {
                a[i] = 1;
            }
        }
    }

    int m; cin >> m;
    vvi g(n);

    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--; u--;

        g[v].push_back(u);
    }

    vi was(n, 0);
    for (int i = 0; i < n; i++) {
        if (!was[i] && a[i] != 1)
            color(i, g, was, a);
    }

    if (cnt_set > 1 || cnt_unset > 1) {
        cout << -1;
        return;
    }

    if (cnt_set == 0 && cnt_unset == 1) {
        cout << -1;
        return;
    }

    for (int i = 0; i < n; i++) {
        if (a[i] == 3) {
            if (cnt_set == 0) {
                cout << -1;
                return;
            }
        }

        if (a[i] == 5) {
            if (cnt_set == 0 || cnt_unset == 0) {
                cout << -1;
                return;
            }
        }
    }

    vvi ans(6);
    was = vi(n, 0);
    for (int i = 0; i < n; i++) {
        if (!was[i])
            topsort(i, g, was, a, ans);
    }

    for (int i = 1; i <= 5; i++)
        reverse(ans[i].begin(), ans[i].end());
    
    for (int i = 1; i <= 5; i++) {
        for (auto x : ans[i])
            cout << x + 1 << ' ';
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int T = 1;
    // cin >> T;

    while(T--> 0)
    {
        solve();
        cout << '\n';
    }

    return 0;
}