#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdint>

#define int int64_t

using namespace std;

void solve() {
    int n, m, q; cin >> n >> m >> q;
    vector<pair<int64_t, int>> tasks(n);
    vector<int> series(m);
    vector<pair<int64_t, int>> queries(q); // t_i, i
    for (int i = 0; i < n; i++) {
        cin >> tasks[i].second;
    }
    for (int i = 0; i < n; i++) {
        cin >> tasks[i].first;
    }
    for (int i = 0; i < m; i++) {
        cin >> series[i];
    }
    for (int i = 0; i < q; i++) {
        cin >> queries[i].first;
        queries[i].second = i;
    }
    
    sort(tasks.begin(), tasks.end());
    sort(queries.begin(), queries.end());

    tasks.push_back(make_pair(1LL << 60, 0));

    vector<int64_t> ends;
    int series_ptr = 0;
    int64_t as_sum = 0;
    int64_t time_consumed = 0;
    for (int i = 0; i <= n; i++) {
        int64_t deadline = tasks[i].first;
        int64_t a = tasks[i].second;
        int64_t time_left = deadline - as_sum - time_consumed;
        while (series_ptr < m && series[series_ptr] + a <= time_left) {
            time_left -= series[series_ptr];
            time_consumed += series[series_ptr];
            ends.push_back(deadline - time_left);
            series_ptr++;
        }
        as_sum += a;
    }

    vector<int> answers(q);
    int ends_ptr = 0;
    for (auto [t, i] : queries) {
        while (ends_ptr < ends.size() && ends[ends_ptr] <= t) {
            ends_ptr++;
        }
        answers[i] = ends_ptr;
    }
    for (int i : answers) {
        cout << i << ' ';
    }
    cout << '\n';
}

signed main() {
    int t; cin >> t;
    while (t--) {
        solve();
    }
}