//#include <bits/stdc++.h>
//
//using namespace std;
//
//struct Point {
//    int x, y;
//
//    bool operator<(const Point &other) const {
//        if (x == other.x)
//            return y < other.y;
//        return x < other.x;
//    }
//
//    bool operator==(const Point &other) const {
//        return x == other.x && y == other.y;
//    }
//
//    Point operator-(const Point &other) const {
//        return {x - other.x, y - other.y};
//    }
//
//    Point operator+(const Point &other) const {
//        return {x + other.x, y + other.y};
//    }
//
//    Point operator*(int n) const {
//        return {x * n, y * n};
//    }
//};
//
//struct Segment {
//    Point a, b;
//
//    Segment(Point q, Point w) {
//        if (w < q)
//            swap(q, w);
//        a = q;
//        b = w;
//    }
//
//    bool operator<(const Segment &other) const {
//        if (a == other.a)
//            return b < other.b;
//        return a < other.a;
//    }
//
//    bool operator==(const Segment &other) const {
//        return a == other.a && b == other.b;
//    }
//
//    Segment operator-(const Segment &other) const {
//        return {a - other.a, b - other.b};
//    }
//};
//
//struct Fig {
//    vector<Segment> segs;
//
//    Fig(const vector<Segment> &s) : segs(s) {
//        sort(segs.begin(), segs.end());
//    }
//
//    bool operator==(const Fig &other) const {
//        auto d = segs[0] - other.segs[0];
//        if (!(d.a == d.b))
//            return false;
//        for (int i = 1; i < segs.size(); ++i) {
//            auto dd = segs[i] - other.segs[i];
//            if (!(d == dd))
//                return false;
//        }
//        return true;
//    }
//};
//
//const vector<Point> T_DIRS = {
//        {1, 0},
//        {1, 1},
//        {0, 1},
//        {-1, 1},
//        {-1, 0},
//        {-1, -1},
//        {0, -1},
//        {1, -1}
//};
//
//struct TurtleDraw {
//    Point current{0, 0};
//    int direction = 0;
//
//    void reset() {
//        current = {0, 0};
//        direction = 0;
//    }
//
//    void rotate(int a) {
//        direction += a / 45;
//        direction %= 8;
//    }
//
//    void move(int d) {
//        current = current + T_DIRS[direction] * d;
//    }
//
//    Segment draw(int d) {
//        auto old = current;
//        move(d);
//        return {old, current};
//    }
//};
//
//struct Turtle {
//    int a = 360, d;
//    TurtleDraw td;
//    vector<char> cmds;
//
//    Turtle(int n) {
//        while (n--) {
//            string c;
//            cin >> c;
//            if (c == "rotate")
//                cmds.push_back(0);
//            else if (c == "move")
//                cmds.push_back(1);
//            else
//                cmds.push_back(2);
//            int v;
//            cin >> v;
//            if (cmds.back() == 0)
//                a = v;
//            else
//                d = v;
//        }
//    }
//
//    Fig work(int ang) {
//        td.reset();
//        td.rotate(ang);
//        vector<Segment> result;
//        for (auto cmd : cmds) {
//            if (cmd == 0)
//                td.rotate(a);
//            else if (cmd == 1)
//                td.move(d);
//            else {
//                auto seg = td.draw(d);
//                result.push_back(seg);
//            }
//        }
//        return Fig(result);
//    }
//};
//
//int main() {
//    int n;
//    cin >> n;
//    Turtle base_turtle(n);
//    auto base_fig = base_turtle.work(0);
//    for (int i = 45; i <= 360; i += 45) {
//        auto new_fig = base_turtle.work(i);
//        if (base_fig == new_fig) {
//            cout << i << endl;
//            return 0;
//        }
//    }
//    cout << base_turtle.a << endl;
//    return 0;
//}

#include <bits/stdc++.h>

using namespace std;

vector<int> path;
int n;
map<int, unordered_set<int>> activ, parn, child;
unordered_map<int, int> type, abx;


bool dfs(bool state, int turn){
    if(turn==n or path[n-1]!=-1){
        return true;
    }

    if(state){
        for(auto i: activ[-10]){
            for(auto j: parn[i]){
                child[j].erase(i);
                if(child[j].size()==0){
                    activ[type[j]].insert(j);
                }
            }
            path[turn]=i;
            activ[-10].erase(i);
            if(dfs(state, turn+1)){
                return true;
            }
            else{
                activ[-10].insert(i);
                for(auto j: parn[i]){
                    child[j].insert(i);
                    activ[type[j]].erase(j);
                }
            }
        }
        if(activ[-21].size()!=0){
            auto i=*(activ[-21].begin());
            for(auto j: parn[i]){
                child[j].erase(i);
                if(child[j].size()==0){
                    activ[type[j]].insert(j);
                }
            }
            path[turn]=i;
            activ[-21].erase(i);
            if(dfs(false, turn+1)){
                return true;
            }
            else{
                activ[-21].insert(i);
                for(auto j: parn[i]){
                    child[j].insert(i);
                    if(child[j].size()>=1){
                        activ[type[j]].erase(j);
                    }
                }
            }

        }
    }
    else{
        for(auto i: activ[-20]){
            for(auto j: parn[i]){
                child[j].erase(i);
                if(child[j].size()==0){
                    activ[type[j]].insert(j);
                }
            }
            path[turn]=i;
            activ[-20].erase(i);
            if(dfs(state, turn+1)){
                return true;
            }
            else{
                activ[-20].insert(i);
                for(auto j: parn[i]){
                    child[j].insert(i);
                    if(child[j].size()>=1){
                        activ[type[j]].erase(j);
                    }
                }
            }
        }
        if(activ[-11].size()==1){
            auto i=*(activ[-11].begin());
            for(auto j: parn[i]){
                child[j].erase(i);
                if(child[j].size()==0){
                    activ[type[j]].insert(j);
                }
            }
            path[turn]=i;
            activ[-11].erase(i);
            if(dfs(true, turn+1)){
                return true;
            }
            else {
                activ[-11].insert(i);
                for (auto j: parn[i]) {
                    child[j].insert(i);
                    if (child[j].size() >= 1) {
                        activ[type[j]].erase(j);
                    }
                }
            }
        }
    }
    return false;
}

void solve(){
    cin>>n;
    path.resize(n);
    path[n-1]=-1;
    for(int i=1; i<=n; ++i){
        string a, b;
        cin>>a>>b;
        if(a=="set"){
            if(b=="false"){
                type[i]=-10;
                abx[-10]++;
            }
            else{
                type[i]=-11;
                abx[-11]++;
            }
        }
        else{
            if(b=="false"){
                type[i]=-20;
                abx[-20]++;
            }
            else{
                type[i]=-21;
                abx[-21]++;
            }
        }
    }
    int q;
    cin>>q;
    for(int i=0; i<q; ++i){
        int l, r;
        cin>>l>>r;
        child[r].insert(l);
        parn[l].insert(r);
    }
    if(abx[-21] + abx[-11]>2){
        cout<<-1;
        return;
    }
    for(int i=1; i<=n; ++i){
        if(child.count(i)==0 or child[i].size()==0){
            activ[type[i]].insert(i);
        }
    }
    if(dfs(false, 0)){
        for(int i=0; i<n; ++i){
            cout<<path[i]<<' ';
        }
    }
    else{
        cout<<-1;
    }
    return;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    activ.clear(); parn.clear(); child.clear(); abx.clear();
    int t=1;
//    cin>>t;
    while(t--){
        solve();
        cout<<'\n';
    }
    return 0;
}
