#include <iostream>
#include <vector>
#include <unordered_set>
#include <set>
#include <algorithm>

using namespace std;

const int maxn = 100005;
vector <bool> used(maxn, 0);
vector <int> g[maxn];
vector <int> topsort;

void dfs(int v){
    used[v] = true;
    for(auto u:g[v]){
        if(!used[u])
            dfs(u);
    }
    topsort.push_back(v);
}

bool solve(){
    int sett = -1, unsett = -1;
    int n;
    cin >> n;
    vector <bool> is_set(n+1, false);
    bool has_false_set = false;
    for(int i = 0; i < n; ++i){
        string s, tr;
        cin >> s >> tr;
        if(s == "set") {
            is_set[i] = true;
            if(tr == "false")
                has_false_set = true;
        }
        if(tr == "true"){
            if(s == "set"){
                if (sett != -1)
                    return false;
                sett = i;
            }
            else{
                if(unsett != -1)
                    return false;
                unsett = i;
            }
            is_set[i] = true;
        }
    }
    int m;
    cin >> m;
    vector <pair <int, int> > edges(m);
    for(int i = 0; i < m; ++i){
        int u,v;
        cin >> u >> v;
        u--, v--;
        edges[i] = {u, v};
        if((is_set[u] && is_set[v])) {
            if(v != unsett)
                g[u].push_back(v); // set -> unset true not add
            if(u == unsett) // unset true -> set
                return false;
        }
        else if(is_set[u])
            g[n].push_back(v);
        else if(is_set[v])
            g[u].push_back(n);
        else
            g[u].push_back(v);
    }
    if (unsett != -1 && sett == -1)
        return false;
    if(has_false_set && sett == -1)
        return false;
    for(int i = 0; i < n; ++i){
        if (!used[i] && is_set[i] && unsett != i)
            dfs(i);
    }
    vector <int> set_order;
    if(sett != -1) {
        set_order.push_back(sett);
        for (int i = topsort.size() - 1; i >= 0; --i) {
            if (topsort[i] != sett)
                set_order.push_back(topsort[i]);
        }
    }
    topsort.clear();
    for(int i = 0; i <= n; ++i){
        if(!is_set[i] && !used[i])
            dfs(i);
    }
    vector <int> ans;
    for(int i = topsort.size() - 1; i >= 0; --i){
        if(topsort[i] == n){
            if (unsett == -1)
                continue;
            for(auto x:set_order)
                ans.push_back(x);
            ans.push_back(unsett);

        }
        else
            ans.push_back(topsort[i]);
    }
    if (unsett == -1){
        for(auto x:set_order)
            ans.push_back(x);

    }
    vector <int> pos(n);
    for(int i = 0; i < n; ++i){
        pos[ans[i]] = i;
    }
    for(auto e:edges){
        if (pos[e.first] > pos[e.second])
            return false;
    }
    for(int i = 0; i < n; ++i)
        cout << ans[i] + 1 << ' ';
    cout << '\n';
    return true;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie();
    if(!solve())
        cout << "-1\n";
}
